/* Integration.c generated by valac 0.48.8, the Vala compiler
 * generated from Integration.vala, do not modify */

/*-
 * Copyright 2013-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <gio/gio.h>
#include <glib-object.h>
#include <glib.h>
#include <libaccounts-glib.h>
#include <libsignon-glib/signon-glib.h>
#include <rest/oauth2-proxy.h>
#include <rest/rest-proxy-call.h>
#include <rest/rest-proxy.h>
#include <json-glib/json-glib.h>
#include <stdlib.h>
#include <string.h>

#define TYPE_INTEGRATION_APPLICATION (integration_application_get_type ())
#define INTEGRATION_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_INTEGRATION_APPLICATION, IntegrationApplication))
#define INTEGRATION_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_INTEGRATION_APPLICATION, IntegrationApplicationClass))
#define IS_INTEGRATION_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_INTEGRATION_APPLICATION))
#define IS_INTEGRATION_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_INTEGRATION_APPLICATION))
#define INTEGRATION_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_INTEGRATION_APPLICATION, IntegrationApplicationClass))

typedef struct _IntegrationApplication IntegrationApplication;
typedef struct _IntegrationApplicationClass IntegrationApplicationClass;
typedef struct _IntegrationApplicationPrivate IntegrationApplicationPrivate;
enum  {
	INTEGRATION_APPLICATION_0_PROPERTY,
	INTEGRATION_APPLICATION_NUM_PROPERTIES
};
static GParamSpec* integration_application_properties[INTEGRATION_APPLICATION_NUM_PROPERTIES];
#define _g_option_context_free0(var) ((var == NULL) ? NULL : (var = (g_option_context_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _IntegrationApplicationApiInfos IntegrationApplicationApiInfos;
typedef struct _Block1Data Block1Data;
#define _g_main_loop_unref0(var) ((var == NULL) ? NULL : (var = (g_main_loop_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _ag_auth_data_unref0(var) ((var == NULL) ? NULL : (var = (ag_auth_data_unref (var), NULL)))
#define _integration_application_api_infos_free0(var) ((var == NULL) ? NULL : (var = (integration_application_api_infos_free (var), NULL)))
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))

struct _IntegrationApplication {
	GApplication parent_instance;
	IntegrationApplicationPrivate * priv;
};

struct _IntegrationApplicationClass {
	GApplicationClass parent_class;
};

struct _Block1Data {
	int _ref_count_;
	IntegrationApplication* self;
	SignonAuthSession* auth_session;
	GVariant* session_result;
	GMainLoop* main_loop;
};

struct _IntegrationApplicationApiInfos {
	gchar* access_token;
	gchar* client_id;
	gchar* redirect_uri;
	AgAccountService* account_service;
};

static gpointer integration_application_parent_class = NULL;
static guint integration_application_account_id;
static gchar* integration_application_method;
static guint integration_application_account_id = (guint) 0;
static gchar* integration_application_method = NULL;

GType integration_application_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (IntegrationApplication, g_object_unref)
static IntegrationApplication* integration_application_new (void);
static IntegrationApplication* integration_application_construct (GType object_type);
static gint integration_application_real_command_line (GApplication* base,
                                                GApplicationCommandLine* command_line);
gboolean integration_application_get_user_name (IntegrationApplication* self,
                                                guint account_id);
gboolean integration_application_get_user_image (IntegrationApplication* self,
                                                 guint account_id);
void integration_application_api_infos_free (IntegrationApplicationApiInfos * self);
G_DEFINE_AUTOPTR_CLEANUP_FUNC (IntegrationApplicationApiInfos, integration_application_api_infos_free)
IntegrationApplicationApiInfos* integration_application_get_token (IntegrationApplication* self,
                                                                   guint account_id);
IntegrationApplicationApiInfos* integration_application_api_infos_new (void);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void ___lambda4_ (Block1Data* _data1_,
                  GObject* obj,
                  GAsyncResult* res);
static void ____lambda4__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
gint integration_application_main (gchar** args,
                                   gint args_length1);
static void integration_application_api_infos_instance_init (IntegrationApplicationApiInfos * self);
static void integration_application_finalize (GObject * obj);
static GType integration_application_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

static const GOptionEntry INTEGRATION_APPLICATION_options[3] = {{"account-id", 'a', 0, G_OPTION_ARG_INT, &integration_application_account_id, "Specify the account id", "ID"}, {"method", (gchar) 0, 0, G_OPTION_ARG_STRING, &integration_application_method, "The action to do", "NAME"}, {NULL}};

static IntegrationApplication*
integration_application_construct (GType object_type)
{
	IntegrationApplication * self = NULL;
	self = (IntegrationApplication*) g_object_new (object_type, "flags", G_APPLICATION_HANDLES_COMMAND_LINE, NULL);
	return self;
}

static IntegrationApplication*
integration_application_new (void)
{
	return integration_application_construct (TYPE_INTEGRATION_APPLICATION);
}

static gint
integration_application_real_command_line (GApplication* base,
                                           GApplicationCommandLine* command_line)
{
	IntegrationApplication * self;
	gchar** args = NULL;
	gint _tmp0_ = 0;
	gchar** _tmp1_;
	gint args_length1;
	gint _args_size_;
	const gchar* _tmp13_;
	gboolean finished = FALSE;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	GQuark _tmp17_ = 0U;
	static GQuark _tmp16_label0 = 0;
	static GQuark _tmp16_label1 = 0;
	GError* _inner_error0_ = NULL;
	gint result = 0;
	self = (IntegrationApplication*) base;
	g_return_val_if_fail (command_line != NULL, 0);
	_tmp1_ = g_application_command_line_get_arguments (command_line, &_tmp0_);
	args = _tmp1_;
	args_length1 = _tmp0_;
	_args_size_ = args_length1;
	{
		GOptionContext* opt_context = NULL;
		GOptionContext* _tmp2_;
		GOptionContext* _tmp3_;
		GOptionContext* _tmp4_;
		GOptionContext* _tmp5_;
		GOptionContext* _tmp6_;
		_tmp2_ = g_option_context_new ("- Google Integration");
		opt_context = _tmp2_;
		_tmp3_ = opt_context;
		g_option_context_set_help_enabled (_tmp3_, TRUE);
		_tmp4_ = opt_context;
		g_option_context_set_ignore_unknown_options (_tmp4_, TRUE);
		_tmp5_ = opt_context;
		g_option_context_add_main_entries (_tmp5_, INTEGRATION_APPLICATION_options, NULL);
		_tmp6_ = opt_context;
		g_option_context_parse_strv (_tmp6_, &args, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			gint _tmp7_ = -1;
			_g_option_context_free0 (opt_context);
			if (_inner_error0_->domain == G_OPTION_ERROR) {
				goto __catch0_g_option_error;
			}
			args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp7_;
		}
		_g_option_context_free0 (opt_context);
	}
	goto __finally0;
	__catch0_g_option_error:
	{
		GError* e = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
		gchar** _tmp10_;
		gint _tmp10__length1;
		const gchar* _tmp11_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp8_ = e;
		_tmp9_ = _tmp8_->message;
		g_application_command_line_print (command_line, "error: %s\n", _tmp9_);
		_tmp10_ = args;
		_tmp10__length1 = args_length1;
		_tmp11_ = _tmp10_[0];
		g_application_command_line_print (command_line, "Run '%s --help' to see a full list of available command line options.\n", _tmp11_);
		result = -1;
		_g_error_free0 (e);
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
		return result;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gint _tmp12_ = -1;
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp12_;
	}
	_tmp13_ = integration_application_method;
	if (_tmp13_ == NULL) {
		g_application_command_line_print (command_line, "Missing method argument.\n");
		result = -1;
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
		return result;
	}
	if (integration_application_account_id == ((guint) 0)) {
		g_application_command_line_print (command_line, "Missing account-id argument.\n");
		result = -1;
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
		return result;
	}
	finished = FALSE;
	_tmp14_ = integration_application_method;
	_tmp15_ = _tmp14_;
	_tmp17_ = (NULL == _tmp15_) ? 0 : g_quark_from_string (_tmp15_);
	if (_tmp17_ == ((0 != _tmp16_label0) ? _tmp16_label0 : (_tmp16_label0 = g_quark_from_static_string ("UserName")))) {
		switch (0) {
			default:
			{
				finished = integration_application_get_user_name (self, integration_application_account_id);
				break;
			}
		}
	} else if (_tmp17_ == ((0 != _tmp16_label1) ? _tmp16_label1 : (_tmp16_label1 = g_quark_from_static_string ("UserImage")))) {
		switch (0) {
			default:
			{
				finished = integration_application_get_user_image (self, integration_application_account_id);
				break;
			}
		}
	} else {
		switch (0) {
			default:
			{
				const gchar* _tmp18_;
				_tmp18_ = integration_application_method;
				g_application_command_line_print (command_line, "Method '%s' unavailable.\n", _tmp18_);
				break;
			}
		}
	}
	if (finished) {
		const gchar* _tmp19_;
		_tmp19_ = integration_application_method;
		g_application_command_line_print (command_line, "Method '%s' finished on account '%u'.\n", _tmp19_, integration_application_account_id);
	}
	result = 0;
	args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
	return result;
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		IntegrationApplication* self;
		self = _data1_->self;
		_g_main_loop_unref0 (_data1_->main_loop);
		_g_variant_unref0 (_data1_->session_result);
		_g_object_unref0 (_data1_->auth_session);
		_g_object_unref0 (self);
		g_slice_free (Block1Data, _data1_);
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
___lambda4_ (Block1Data* _data1_,
             GObject* obj,
             GAsyncResult* res)
{
	IntegrationApplication* self;
	GMainLoop* _tmp6_;
	GError* _inner_error0_ = NULL;
	self = _data1_->self;
	g_return_if_fail (res != NULL);
	{
		GVariant* _tmp0_ = NULL;
		SignonAuthSession* _tmp1_;
		GVariant* _tmp2_;
		GVariant* _tmp3_;
		_tmp1_ = _data1_->auth_session;
		_tmp2_ = signon_auth_session_process_finish (_tmp1_, res, &_inner_error0_);
		_tmp0_ = _tmp2_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp3_ = _tmp0_;
		_tmp0_ = NULL;
		_g_variant_unref0 (_data1_->session_result);
		_data1_->session_result = _tmp3_;
		_g_variant_unref0 (_tmp0_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp4_ = e;
		_tmp5_ = _tmp4_->message;
		g_critical ("Integration.vala:109: %s", _tmp5_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_tmp6_ = _data1_->main_loop;
	g_main_loop_quit (_tmp6_);
}

static void
____lambda4__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
	___lambda4_ (self, source_object, res);
	block1_data_unref (self);
}

IntegrationApplicationApiInfos*
integration_application_get_token (IntegrationApplication* self,
                                   guint account_id)
{
	IntegrationApplicationApiInfos* api_infos = NULL;
	IntegrationApplicationApiInfos* _tmp0_;
	AgManager* ag_manager = NULL;
	AgManager* _tmp1_;
	GError* _inner_error0_ = NULL;
	IntegrationApplicationApiInfos* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = integration_application_api_infos_new ();
	api_infos = _tmp0_;
	_tmp1_ = ag_manager_new ();
	ag_manager = _tmp1_;
	{
		Block1Data* _data1_;
		AgAccount* account = NULL;
		AgManager* _tmp2_;
		AgAccount* _tmp3_;
		AgAccountService* account_service = NULL;
		AgAccount* _tmp4_;
		AgAccount* _tmp5_;
		AgAccountService* _tmp6_;
		AgAuthData* auth_data = NULL;
		AgAccountService* _tmp7_;
		AgAuthData* _tmp8_;
		GVariant* session_data = NULL;
		AgAuthData* _tmp9_;
		GVariant* _tmp10_;
		IntegrationApplicationApiInfos* _tmp11_;
		AgAccountService* _tmp12_;
		AgAccountService* _tmp13_;
		IntegrationApplicationApiInfos* _tmp14_;
		GVariant* _tmp15_;
		GVariant* _tmp16_;
		GVariant* _tmp17_;
		gchar* _tmp18_;
		IntegrationApplicationApiInfos* _tmp19_;
		GVariant* _tmp20_;
		GVariant* _tmp21_;
		GVariant* _tmp22_;
		gchar* _tmp23_;
		SignonIdentity* identity = NULL;
		AgAuthData* _tmp24_;
		SignonIdentity* _tmp25_;
		SignonIdentity* _tmp26_;
		SignonAuthSession* _tmp27_;
		GMainLoop* _tmp28_;
		SignonAuthSession* _tmp29_;
		GVariant* _tmp30_;
		GMainLoop* _tmp31_;
		GVariant* _tmp32_;
		IntegrationApplicationApiInfos* _tmp33_;
		GVariant* _tmp34_;
		GVariant* _tmp35_;
		GVariant* _tmp36_;
		gchar* _tmp37_;
		_data1_ = g_slice_new0 (Block1Data);
		_data1_->_ref_count_ = 1;
		_data1_->self = g_object_ref (self);
		_tmp2_ = ag_manager;
		_tmp3_ = ag_manager_load_account (_tmp2_, (AgAccountId) account_id, &_inner_error0_);
		account = _tmp3_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			block1_data_unref (_data1_);
			_data1_ = NULL;
			goto __catch0_g_error;
		}
		_tmp4_ = account;
		_tmp5_ = _g_object_ref0 (_tmp4_);
		_tmp6_ = ag_account_service_new (_tmp5_, NULL);
		account_service = _tmp6_;
		_tmp7_ = account_service;
		_tmp8_ = ag_account_service_get_auth_data (_tmp7_);
		auth_data = _tmp8_;
		_tmp9_ = auth_data;
		_tmp10_ = ag_auth_data_get_login_parameters (_tmp9_, NULL);
		session_data = _tmp10_;
		_tmp11_ = api_infos;
		_tmp12_ = account_service;
		_tmp13_ = _g_object_ref0 (_tmp12_);
		_g_object_unref0 (_tmp11_->account_service);
		_tmp11_->account_service = _tmp13_;
		_tmp14_ = api_infos;
		_tmp15_ = session_data;
		_tmp16_ = g_variant_lookup_value (_tmp15_, "ClientId", NULL);
		_tmp17_ = _tmp16_;
		_tmp18_ = g_variant_dup_string (_tmp17_, NULL);
		_g_free0 (_tmp14_->client_id);
		_tmp14_->client_id = _tmp18_;
		_g_variant_unref0 (_tmp17_);
		_tmp19_ = api_infos;
		_tmp20_ = session_data;
		_tmp21_ = g_variant_lookup_value (_tmp20_, "RedirectUri", NULL);
		_tmp22_ = _tmp21_;
		_tmp23_ = g_variant_dup_string (_tmp22_, NULL);
		_g_free0 (_tmp19_->redirect_uri);
		_tmp19_->redirect_uri = _tmp23_;
		_g_variant_unref0 (_tmp22_);
		_tmp24_ = auth_data;
		_tmp25_ = signon_identity_new_from_db ((guint32) ag_auth_data_get_credentials_id (_tmp24_));
		identity = _tmp25_;
		_tmp26_ = identity;
		_tmp27_ = signon_identity_create_session (_tmp26_, "oauth", &_inner_error0_);
		_data1_->auth_session = _tmp27_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (identity);
			_ag_auth_data_unref0 (auth_data);
			_g_object_unref0 (account_service);
			_g_object_unref0 (account);
			block1_data_unref (_data1_);
			_data1_ = NULL;
			goto __catch0_g_error;
		}
		_data1_->session_result = NULL;
		_tmp28_ = g_main_loop_new (NULL, FALSE);
		_data1_->main_loop = _tmp28_;
		_tmp29_ = _data1_->auth_session;
		_tmp30_ = session_data;
		signon_auth_session_process (_tmp29_, _tmp30_, "oauth2", NULL, ____lambda4__gasync_ready_callback, block1_data_ref (_data1_));
		_tmp31_ = _data1_->main_loop;
		g_main_loop_run (_tmp31_);
		_tmp32_ = _data1_->session_result;
		if (_tmp32_ == NULL) {
			result = NULL;
			_g_object_unref0 (identity);
			_ag_auth_data_unref0 (auth_data);
			_g_object_unref0 (account_service);
			_g_object_unref0 (account);
			block1_data_unref (_data1_);
			_data1_ = NULL;
			_g_object_unref0 (ag_manager);
			_integration_application_api_infos_free0 (api_infos);
			return result;
		}
		_tmp33_ = api_infos;
		_tmp34_ = _data1_->session_result;
		_tmp35_ = g_variant_lookup_value (_tmp34_, "AccessToken", NULL);
		_tmp36_ = _tmp35_;
		_tmp37_ = g_variant_dup_string (_tmp36_, NULL);
		_g_free0 (_tmp33_->access_token);
		_tmp33_->access_token = _tmp37_;
		_g_variant_unref0 (_tmp36_);
		_g_object_unref0 (identity);
		_ag_auth_data_unref0 (auth_data);
		_g_object_unref0 (account_service);
		_g_object_unref0 (account);
		block1_data_unref (_data1_);
		_data1_ = NULL;
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp38_;
		const gchar* _tmp39_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp38_ = e;
		_tmp39_ = _tmp38_->message;
		g_critical ("Integration.vala:122: %s", _tmp39_);
		result = NULL;
		_g_error_free0 (e);
		_g_object_unref0 (ag_manager);
		_integration_application_api_infos_free0 (api_infos);
		return result;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (ag_manager);
		_integration_application_api_infos_free0 (api_infos);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	result = api_infos;
	_g_object_unref0 (ag_manager);
	return result;
}

static gpointer
_json_object_ref0 (gpointer self)
{
	return self ? json_object_ref (self) : NULL;
}

static gpointer
_g_variant_ref0 (gpointer self)
{
	return self ? g_variant_ref (self) : NULL;
}

gboolean
integration_application_get_user_name (IntegrationApplication* self,
                                       guint account_id)
{
	IntegrationApplicationApiInfos* api_infos = NULL;
	IntegrationApplicationApiInfos* _tmp0_;
	IntegrationApplicationApiInfos* _tmp1_;
	OAuth2Proxy* proxy = NULL;
	IntegrationApplicationApiInfos* _tmp2_;
	const gchar* _tmp3_;
	IntegrationApplicationApiInfos* _tmp4_;
	const gchar* _tmp5_;
	IntegrationApplicationApiInfos* _tmp6_;
	const gchar* _tmp7_;
	OAuth2Proxy* _tmp8_;
	RestProxyCall* call = NULL;
	OAuth2Proxy* _tmp9_;
	RestProxyCall* _tmp10_;
	RestProxyCall* _tmp11_;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = integration_application_get_token (self, account_id);
	api_infos = _tmp0_;
	_tmp1_ = api_infos;
	if (_tmp1_ == NULL) {
		result = FALSE;
		_integration_application_api_infos_free0 (api_infos);
		return result;
	}
	_tmp2_ = api_infos;
	_tmp3_ = _tmp2_->client_id;
	_tmp4_ = api_infos;
	_tmp5_ = _tmp4_->access_token;
	_tmp6_ = api_infos;
	_tmp7_ = _tmp6_->redirect_uri;
	_tmp8_ = (OAuth2Proxy*) oauth2_proxy_new_with_token (_tmp3_, _tmp5_, _tmp7_, "https://apis.live.net/v5.0/me", FALSE);
	proxy = _tmp8_;
	_tmp9_ = proxy;
	_tmp10_ = rest_proxy_new_call ((RestProxy*) _tmp9_);
	call = _tmp10_;
	_tmp11_ = call;
	rest_proxy_call_set_method (_tmp11_, "GET");
	{
		RestProxyCall* _tmp12_;
		_tmp12_ = call;
		rest_proxy_call_run (_tmp12_, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp13_;
		const gchar* _tmp14_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp13_ = e;
		_tmp14_ = _tmp13_->message;
		g_critical ("Integration.vala:147: %s", _tmp14_);
		result = FALSE;
		_g_error_free0 (e);
		_g_object_unref0 (call);
		_g_object_unref0 (proxy);
		_integration_application_api_infos_free0 (api_infos);
		return result;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gboolean _tmp15_ = FALSE;
		_g_object_unref0 (call);
		_g_object_unref0 (proxy);
		_integration_application_api_infos_free0 (api_infos);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp15_;
	}
	{
		JsonParser* parser = NULL;
		JsonParser* _tmp16_;
		JsonParser* _tmp17_;
		RestProxyCall* _tmp18_;
		const gchar* _tmp19_;
		RestProxyCall* _tmp20_;
		JsonObject* root_object = NULL;
		JsonParser* _tmp21_;
		JsonNode* _tmp22_;
		JsonObject* _tmp23_;
		JsonObject* _tmp24_;
		JsonObject* mails_member = NULL;
		JsonObject* _tmp25_;
		JsonObject* _tmp26_;
		const gchar* mail = NULL;
		JsonObject* _tmp27_;
		const gchar* _tmp28_;
		AgAccountService* account_service = NULL;
		IntegrationApplicationApiInfos* _tmp29_;
		AgAccountService* _tmp30_;
		AgAccountService* _tmp31_;
		AgAccountService* _tmp32_;
		AgAccount* _tmp33_;
		AgAccount* _tmp34_;
		const gchar* _tmp35_;
		AgAccountService* _tmp36_;
		AgAccount* _tmp37_;
		AgAccount* _tmp38_;
		AgAuthData* auth_data = NULL;
		AgAccountService* _tmp39_;
		AgAuthData* _tmp40_;
		gchar* key = NULL;
		AgAuthData* _tmp41_;
		const gchar* _tmp42_;
		AgAuthData* _tmp43_;
		const gchar* _tmp44_;
		gchar* _tmp45_;
		GVariant* auth_query = NULL;
		AgAccountService* _tmp46_;
		const gchar* _tmp47_;
		GVariant* _tmp48_;
		GVariant* _tmp49_;
		GVariant* _tmp50_;
		_tmp16_ = json_parser_new ();
		parser = _tmp16_;
		_tmp17_ = parser;
		_tmp18_ = call;
		_tmp19_ = rest_proxy_call_get_payload (_tmp18_);
		_tmp20_ = call;
		json_parser_load_from_data (_tmp17_, _tmp19_, (gssize) rest_proxy_call_get_payload_length (_tmp20_), &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (parser);
			goto __catch1_g_error;
		}
		_tmp21_ = parser;
		_tmp22_ = json_parser_get_root (_tmp21_);
		_tmp23_ = json_node_get_object (_tmp22_);
		_tmp24_ = _json_object_ref0 (_tmp23_);
		root_object = _tmp24_;
		_tmp25_ = root_object;
		_tmp26_ = json_object_get_object_member (_tmp25_, "emails");
		mails_member = _tmp26_;
		_tmp27_ = mails_member;
		_tmp28_ = json_object_get_string_member (_tmp27_, "account");
		mail = _tmp28_;
		_tmp29_ = api_infos;
		_tmp30_ = _tmp29_->account_service;
		_tmp31_ = _g_object_ref0 (_tmp30_);
		account_service = _tmp31_;
		_tmp32_ = account_service;
		_tmp33_ = ag_account_service_get_account (_tmp32_);
		_tmp34_ = _tmp33_;
		_tmp35_ = mail;
		ag_account_set_display_name (_tmp34_, _tmp35_);
		_tmp36_ = account_service;
		_tmp37_ = ag_account_service_get_account (_tmp36_);
		_tmp38_ = _tmp37_;
		ag_account_store_blocking (_tmp38_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (account_service);
			_json_object_unref0 (root_object);
			_g_object_unref0 (parser);
			goto __catch1_g_error;
		}
		_tmp39_ = account_service;
		_tmp40_ = ag_account_service_get_auth_data (_tmp39_);
		auth_data = _tmp40_;
		_tmp41_ = auth_data;
		_tmp42_ = ag_auth_data_get_method (_tmp41_);
		_tmp43_ = auth_data;
		_tmp44_ = ag_auth_data_get_mechanism (_tmp43_);
		_tmp45_ = g_strdup_printf ("auth/%s/%s/AuthQuery", _tmp42_, _tmp44_);
		key = _tmp45_;
		_tmp46_ = account_service;
		_tmp47_ = key;
		_tmp48_ = ag_account_service_get_variant (_tmp46_, _tmp47_, NULL);
		_tmp49_ = _g_variant_ref0 (_tmp48_);
		auth_query = _tmp49_;
		_tmp50_ = auth_query;
		if (_tmp50_ != NULL) {
			GVariant* variant = NULL;
			const gchar* _tmp51_;
			GVariant* _tmp52_;
			const gchar* _tmp53_;
			gchar* _tmp54_;
			gchar* _tmp55_;
			GVariant* _tmp56_;
			GVariant* _tmp57_;
			AgAccountService* _tmp58_;
			const gchar* _tmp59_;
			GVariant* _tmp60_;
			_tmp51_ = mail;
			_tmp52_ = auth_query;
			_tmp53_ = g_variant_get_string (_tmp52_, NULL);
			_tmp54_ = g_strdup_printf ("login_hint=%s&amp;%s", _tmp51_, _tmp53_);
			_tmp55_ = _tmp54_;
			_tmp56_ = g_variant_new_string (_tmp55_);
			g_variant_ref_sink (_tmp56_);
			_tmp57_ = _tmp56_;
			_g_free0 (_tmp55_);
			variant = _tmp57_;
			_tmp58_ = account_service;
			_tmp59_ = key;
			_tmp60_ = variant;
			ag_account_service_set_variant (_tmp58_, _tmp59_, _tmp60_);
			_g_variant_unref0 (variant);
		} else {
			GVariant* variant = NULL;
			const gchar* _tmp61_;
			gchar* _tmp62_;
			gchar* _tmp63_;
			GVariant* _tmp64_;
			GVariant* _tmp65_;
			AgAccountService* _tmp66_;
			const gchar* _tmp67_;
			GVariant* _tmp68_;
			_tmp61_ = mail;
			_tmp62_ = g_strdup_printf ("login_hint=%s", _tmp61_);
			_tmp63_ = _tmp62_;
			_tmp64_ = g_variant_new_string (_tmp63_);
			g_variant_ref_sink (_tmp64_);
			_tmp65_ = _tmp64_;
			_g_free0 (_tmp63_);
			variant = _tmp65_;
			_tmp66_ = account_service;
			_tmp67_ = key;
			_tmp68_ = variant;
			ag_account_service_set_variant (_tmp66_, _tmp67_, _tmp68_);
			_g_variant_unref0 (variant);
		}
		_g_variant_unref0 (auth_query);
		_g_free0 (key);
		_ag_auth_data_unref0 (auth_data);
		_g_object_unref0 (account_service);
		_json_object_unref0 (root_object);
		_g_object_unref0 (parser);
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp69_;
		const gchar* _tmp70_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp69_ = e;
		_tmp70_ = _tmp69_->message;
		g_critical ("Integration.vala:174: %s", _tmp70_);
		_g_error_free0 (e);
	}
	__finally1:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gboolean _tmp71_ = FALSE;
		_g_object_unref0 (call);
		_g_object_unref0 (proxy);
		_integration_application_api_infos_free0 (api_infos);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp71_;
	}
	result = TRUE;
	_g_object_unref0 (call);
	_g_object_unref0 (proxy);
	_integration_application_api_infos_free0 (api_infos);
	return result;
}

gboolean
integration_application_get_user_image (IntegrationApplication* self,
                                        guint account_id)
{
	IntegrationApplicationApiInfos* api_infos = NULL;
	IntegrationApplicationApiInfos* _tmp0_;
	IntegrationApplicationApiInfos* _tmp1_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = integration_application_get_token (self, account_id);
	api_infos = _tmp0_;
	_tmp1_ = api_infos;
	if (_tmp1_ == NULL) {
		result = FALSE;
		_integration_application_api_infos_free0 (api_infos);
		return result;
	}
	result = TRUE;
	_integration_application_api_infos_free0 (api_infos);
	return result;
}

gint
integration_application_main (gchar** args,
                              gint args_length1)
{
	IntegrationApplication* app = NULL;
	IntegrationApplication* _tmp0_;
	gint status = 0;
	gint result = 0;
	_tmp0_ = integration_application_new ();
	app = _tmp0_;
	status = g_application_run ((GApplication*) app, (gint) args_length1, args);
	result = status;
	_g_object_unref0 (app);
	return result;
}

int
main (int argc,
      char ** argv)
{
	return integration_application_main (argv, argc);
}

IntegrationApplicationApiInfos*
integration_application_api_infos_new (void)
{
	IntegrationApplicationApiInfos* self;
	self = g_slice_new0 (IntegrationApplicationApiInfos);
	integration_application_api_infos_instance_init (self);
	return self;
}

static void
integration_application_api_infos_instance_init (IntegrationApplicationApiInfos * self)
{
}

void
integration_application_api_infos_free (IntegrationApplicationApiInfos * self)
{
	_g_free0 (self->access_token);
	_g_free0 (self->client_id);
	_g_free0 (self->redirect_uri);
	_g_object_unref0 (self->account_service);
	g_slice_free (IntegrationApplicationApiInfos, self);
}

static void
integration_application_class_init (IntegrationApplicationClass * klass,
                                    gpointer klass_data)
{
	integration_application_parent_class = g_type_class_peek_parent (klass);
	((GApplicationClass *) klass)->command_line = (gint (*) (GApplication*, GApplicationCommandLine*)) integration_application_real_command_line;
	G_OBJECT_CLASS (klass)->finalize = integration_application_finalize;
}

static void
integration_application_instance_init (IntegrationApplication * self,
                                       gpointer klass)
{
}

static void
integration_application_finalize (GObject * obj)
{
	IntegrationApplication * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_INTEGRATION_APPLICATION, IntegrationApplication);
	G_OBJECT_CLASS (integration_application_parent_class)->finalize (obj);
}

static GType
integration_application_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (IntegrationApplicationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) integration_application_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (IntegrationApplication), 0, (GInstanceInitFunc) integration_application_instance_init, NULL };
	GType integration_application_type_id;
	integration_application_type_id = g_type_register_static (g_application_get_type (), "IntegrationApplication", &g_define_type_info, 0);
	return integration_application_type_id;
}

GType
integration_application_get_type (void)
{
	static volatile gsize integration_application_type_id__volatile = 0;
	if (g_once_init_enter (&integration_application_type_id__volatile)) {
		GType integration_application_type_id;
		integration_application_type_id = integration_application_get_type_once ();
		g_once_init_leave (&integration_application_type_id__volatile, integration_application_type_id);
	}
	return integration_application_type_id__volatile;
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gint i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

