/* AccountsManager.c generated by valac 0.48.8, the Vala compiler
 * generated from AccountsManager.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2013-2015 Pantheon Developers (https://launchpad.net/switchboard-plug-onlineaccounts)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <glib-object.h>
#include <gee.h>
#include <glib.h>
#include <gio/gio.h>
#include <libaccounts-glib.h>

#define ONLINE_ACCOUNTS_TYPE_ACCOUNTS_MANAGER (online_accounts_accounts_manager_get_type ())
#define ONLINE_ACCOUNTS_ACCOUNTS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ONLINE_ACCOUNTS_TYPE_ACCOUNTS_MANAGER, OnlineAccountsAccountsManager))
#define ONLINE_ACCOUNTS_ACCOUNTS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ONLINE_ACCOUNTS_TYPE_ACCOUNTS_MANAGER, OnlineAccountsAccountsManagerClass))
#define ONLINE_ACCOUNTS_IS_ACCOUNTS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ONLINE_ACCOUNTS_TYPE_ACCOUNTS_MANAGER))
#define ONLINE_ACCOUNTS_IS_ACCOUNTS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ONLINE_ACCOUNTS_TYPE_ACCOUNTS_MANAGER))
#define ONLINE_ACCOUNTS_ACCOUNTS_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ONLINE_ACCOUNTS_TYPE_ACCOUNTS_MANAGER, OnlineAccountsAccountsManagerClass))

typedef struct _OnlineAccountsAccountsManager OnlineAccountsAccountsManager;
typedef struct _OnlineAccountsAccountsManagerClass OnlineAccountsAccountsManagerClass;
typedef struct _OnlineAccountsAccountsManagerPrivate OnlineAccountsAccountsManagerPrivate;

#define ONLINE_ACCOUNTS_TYPE_ACCOUNT (online_accounts_account_get_type ())
#define ONLINE_ACCOUNTS_ACCOUNT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ONLINE_ACCOUNTS_TYPE_ACCOUNT, OnlineAccountsAccount))
#define ONLINE_ACCOUNTS_ACCOUNT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ONLINE_ACCOUNTS_TYPE_ACCOUNT, OnlineAccountsAccountClass))
#define ONLINE_ACCOUNTS_IS_ACCOUNT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ONLINE_ACCOUNTS_TYPE_ACCOUNT))
#define ONLINE_ACCOUNTS_IS_ACCOUNT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ONLINE_ACCOUNTS_TYPE_ACCOUNT))
#define ONLINE_ACCOUNTS_ACCOUNT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ONLINE_ACCOUNTS_TYPE_ACCOUNT, OnlineAccountsAccountClass))

typedef struct _OnlineAccountsAccount OnlineAccountsAccount;
typedef struct _OnlineAccountsAccountClass OnlineAccountsAccountClass;
enum  {
	ONLINE_ACCOUNTS_ACCOUNTS_MANAGER_0_PROPERTY,
	ONLINE_ACCOUNTS_ACCOUNTS_MANAGER_NUM_PROPERTIES
};
static GParamSpec* online_accounts_accounts_manager_properties[ONLINE_ACCOUNTS_ACCOUNTS_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _ag_provider_unref0(var) ((var == NULL) ? NULL : (var = (ag_provider_unref (var), NULL)))
enum  {
	ONLINE_ACCOUNTS_ACCOUNTS_MANAGER_ACCOUNT_ADDED_SIGNAL,
	ONLINE_ACCOUNTS_ACCOUNTS_MANAGER_ACCOUNT_REMOVED_SIGNAL,
	ONLINE_ACCOUNTS_ACCOUNTS_MANAGER_NUM_SIGNALS
};
static guint online_accounts_accounts_manager_signals[ONLINE_ACCOUNTS_ACCOUNTS_MANAGER_NUM_SIGNALS] = {0};

struct _OnlineAccountsAccountsManager {
	GObject parent_instance;
	OnlineAccountsAccountsManagerPrivate * priv;
	GeeArrayList* accounts_available;
};

struct _OnlineAccountsAccountsManagerClass {
	GObjectClass parent_class;
};

struct _OnlineAccountsAccountsManagerPrivate {
	OnlineAccountsAccount* to_delete;
};

static gint OnlineAccountsAccountsManager_private_offset;
static gpointer online_accounts_accounts_manager_parent_class = NULL;
static OnlineAccountsAccountsManager* online_accounts_accounts_manager_accounts_manager;
static OnlineAccountsAccountsManager* online_accounts_accounts_manager_accounts_manager = NULL;

GType online_accounts_accounts_manager_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (OnlineAccountsAccountsManager, g_object_unref)
GType online_accounts_account_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (OnlineAccountsAccount, g_object_unref)
void online_accounts_accounts_manager_remove_cached_account (OnlineAccountsAccountsManager* self);
OnlineAccountsAccountsManager* online_accounts_accounts_manager_get_default (void);
static OnlineAccountsAccountsManager* online_accounts_accounts_manager_new (void);
static OnlineAccountsAccountsManager* online_accounts_accounts_manager_construct (GType object_type);
void online_accounts_accounts_manager_add_account (OnlineAccountsAccountsManager* self,
                                                   OnlineAccountsAccount* account);
void online_accounts_account_delete_account (OnlineAccountsAccount* self,
                                             GAsyncReadyCallback _callback_,
                                             gpointer _user_data_);
void online_accounts_account_delete_account_finish (OnlineAccountsAccount* self,
                                                    GAsyncResult* _res_,
                                                    GError** error);
static void ___lambda4_ (OnlineAccountsAccountsManager* self,
                  GObject* obj,
                  GAsyncResult* res);
void online_accounts_accounts_manager_restore_cached_account (OnlineAccountsAccountsManager* self);
static void ____lambda4__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
void online_accounts_accounts_manager_remove_account (OnlineAccountsAccountsManager* self,
                                                      OnlineAccountsAccount* account);
static GObject * online_accounts_accounts_manager_constructor (GType type,
                                                        guint n_construct_properties,
                                                        GObjectConstructParam * construct_properties);
OnlineAccountsAccount* online_accounts_account_new (AgAccount* account);
OnlineAccountsAccount* online_accounts_account_construct (GType object_type,
                                                          AgAccount* account);
static void online_accounts_accounts_manager_finalize (GObject * obj);
static GType online_accounts_accounts_manager_get_type_once (void);

static inline gpointer
online_accounts_accounts_manager_get_instance_private (OnlineAccountsAccountsManager* self)
{
	return G_STRUCT_MEMBER_P (self, OnlineAccountsAccountsManager_private_offset);
}

OnlineAccountsAccountsManager*
online_accounts_accounts_manager_get_default (void)
{
	OnlineAccountsAccountsManager* _tmp0_;
	OnlineAccountsAccountsManager* _tmp2_;
	OnlineAccountsAccountsManager* result = NULL;
	_tmp0_ = online_accounts_accounts_manager_accounts_manager;
	if (_tmp0_ == NULL) {
		OnlineAccountsAccountsManager* _tmp1_;
		_tmp1_ = online_accounts_accounts_manager_new ();
		_g_object_unref0 (online_accounts_accounts_manager_accounts_manager);
		online_accounts_accounts_manager_accounts_manager = _tmp1_;
	}
	_tmp2_ = online_accounts_accounts_manager_accounts_manager;
	result = _tmp2_;
	return result;
}

static OnlineAccountsAccountsManager*
online_accounts_accounts_manager_construct (GType object_type)
{
	OnlineAccountsAccountsManager * self = NULL;
	self = (OnlineAccountsAccountsManager*) g_object_new (object_type, NULL);
	return self;
}

static OnlineAccountsAccountsManager*
online_accounts_accounts_manager_new (void)
{
	return online_accounts_accounts_manager_construct (ONLINE_ACCOUNTS_TYPE_ACCOUNTS_MANAGER);
}

void
online_accounts_accounts_manager_add_account (OnlineAccountsAccountsManager* self,
                                              OnlineAccountsAccount* account)
{
	GeeArrayList* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (account != NULL);
	_tmp0_ = self->accounts_available;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, account);
	g_signal_emit (self, online_accounts_accounts_manager_signals[ONLINE_ACCOUNTS_ACCOUNTS_MANAGER_ACCOUNT_ADDED_SIGNAL], 0, account);
}

static void
___lambda4_ (OnlineAccountsAccountsManager* self,
             GObject* obj,
             GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (res != NULL);
	{
		online_accounts_account_delete_account_finish (G_TYPE_CHECK_INSTANCE_CAST (obj, ONLINE_ACCOUNTS_TYPE_ACCOUNT, OnlineAccountsAccount), res, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_g_object_unref0 (self->priv->to_delete);
		self->priv->to_delete = NULL;
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp0_;
		const gchar* _tmp1_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp0_ = e;
		_tmp1_ = _tmp0_->message;
		g_critical ("AccountsManager.vala:78: %s", _tmp1_);
		online_accounts_accounts_manager_restore_cached_account (self);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
____lambda4__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
	___lambda4_ ((OnlineAccountsAccountsManager*) self, source_object, res);
	g_object_unref (self);
}

void
online_accounts_accounts_manager_remove_cached_account (OnlineAccountsAccountsManager* self)
{
	OnlineAccountsAccount* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->to_delete;
	if (_tmp0_ != NULL) {
		OnlineAccountsAccount* _tmp1_;
		_tmp1_ = self->priv->to_delete;
		online_accounts_account_delete_account (_tmp1_, ____lambda4__gasync_ready_callback, g_object_ref (self));
	}
}

void
online_accounts_accounts_manager_restore_cached_account (OnlineAccountsAccountsManager* self)
{
	OnlineAccountsAccount* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->to_delete;
	if (_tmp0_ != NULL) {
		OnlineAccountsAccount* _tmp1_;
		_tmp1_ = self->priv->to_delete;
		online_accounts_accounts_manager_add_account (self, _tmp1_);
	}
	_g_object_unref0 (self->priv->to_delete);
	self->priv->to_delete = NULL;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
online_accounts_accounts_manager_remove_account (OnlineAccountsAccountsManager* self,
                                                 OnlineAccountsAccount* account)
{
	GeeArrayList* _tmp0_;
	OnlineAccountsAccount* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (account != NULL);
	_tmp0_ = self->accounts_available;
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, account);
	online_accounts_accounts_manager_remove_cached_account (self);
	_tmp1_ = _g_object_ref0 (account);
	_g_object_unref0 (self->priv->to_delete);
	self->priv->to_delete = _tmp1_;
	g_signal_emit (self, online_accounts_accounts_manager_signals[ONLINE_ACCOUNTS_ACCOUNTS_MANAGER_ACCOUNT_REMOVED_SIGNAL], 0, account);
}

static GObject *
online_accounts_accounts_manager_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	OnlineAccountsAccountsManager * self;
	GeeArrayList* _tmp0_;
	AgManager* manager = NULL;
	AgManager* _tmp1_;
	AgManager* _tmp2_;
	GList* _tmp3_;
	GError* _inner_error0_ = NULL;
	parent_class = G_OBJECT_CLASS (online_accounts_accounts_manager_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, ONLINE_ACCOUNTS_TYPE_ACCOUNTS_MANAGER, OnlineAccountsAccountsManager);
	_tmp0_ = gee_array_list_new (ONLINE_ACCOUNTS_TYPE_ACCOUNT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_g_object_unref0 (self->accounts_available);
	self->accounts_available = _tmp0_;
	_tmp1_ = ag_manager_new ();
	manager = _tmp1_;
	_tmp2_ = manager;
	_tmp3_ = ag_manager_list_enabled (_tmp2_);
	{
		GList* accountid_collection = NULL;
		GList* accountid_it = NULL;
		accountid_collection = _tmp3_;
		for (accountid_it = accountid_collection; accountid_it != NULL; accountid_it = accountid_it->next) {
			AgAccountId accountid = 0U;
			accountid = (AgAccountId) ((guintptr) accountid_it->data);
			{
				{
					AgAccount* ag_account = NULL;
					AgManager* _tmp4_;
					AgAccount* _tmp5_;
					AgProvider* provider = NULL;
					AgManager* _tmp6_;
					AgAccount* _tmp7_;
					const gchar* _tmp8_;
					AgProvider* _tmp9_;
					AgProvider* _tmp10_;
					OnlineAccountsAccount* account = NULL;
					AgAccount* _tmp11_;
					OnlineAccountsAccount* _tmp12_;
					OnlineAccountsAccount* _tmp13_;
					_tmp4_ = manager;
					_tmp5_ = ag_manager_load_account (_tmp4_, accountid, &_inner_error0_);
					ag_account = _tmp5_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						goto __catch0_g_error;
					}
					_tmp6_ = manager;
					_tmp7_ = ag_account;
					_tmp8_ = ag_account_get_provider_name (_tmp7_);
					_tmp9_ = ag_manager_get_provider (_tmp6_, _tmp8_);
					provider = _tmp9_;
					_tmp10_ = provider;
					if (_tmp10_ == NULL) {
						_ag_provider_unref0 (provider);
						_g_object_unref0 (ag_account);
						continue;
					}
					_tmp11_ = ag_account;
					_tmp12_ = online_accounts_account_new (_tmp11_);
					account = _tmp12_;
					_tmp13_ = account;
					online_accounts_accounts_manager_add_account (self, _tmp13_);
					_g_object_unref0 (account);
					_ag_provider_unref0 (provider);
					_g_object_unref0 (ag_account);
				}
				goto __finally0;
				__catch0_g_error:
				{
					GError* e = NULL;
					GError* _tmp14_;
					const gchar* _tmp15_;
					e = _inner_error0_;
					_inner_error0_ = NULL;
					_tmp14_ = e;
					_tmp15_ = _tmp14_->message;
					g_critical ("AccountsManager.vala:57: %s", _tmp15_);
					_g_error_free0 (e);
				}
				__finally0:
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					(accountid_collection == NULL) ? NULL : (accountid_collection = (g_list_free (accountid_collection), NULL));
					_g_object_unref0 (manager);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
				}
			}
		}
		(accountid_collection == NULL) ? NULL : (accountid_collection = (g_list_free (accountid_collection), NULL));
	}
	_g_object_unref0 (manager);
	return obj;
}

static void
online_accounts_accounts_manager_class_init (OnlineAccountsAccountsManagerClass * klass,
                                             gpointer klass_data)
{
	online_accounts_accounts_manager_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &OnlineAccountsAccountsManager_private_offset);
	G_OBJECT_CLASS (klass)->constructor = online_accounts_accounts_manager_constructor;
	G_OBJECT_CLASS (klass)->finalize = online_accounts_accounts_manager_finalize;
	online_accounts_accounts_manager_signals[ONLINE_ACCOUNTS_ACCOUNTS_MANAGER_ACCOUNT_ADDED_SIGNAL] = g_signal_new ("account-added", ONLINE_ACCOUNTS_TYPE_ACCOUNTS_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, ONLINE_ACCOUNTS_TYPE_ACCOUNT);
	online_accounts_accounts_manager_signals[ONLINE_ACCOUNTS_ACCOUNTS_MANAGER_ACCOUNT_REMOVED_SIGNAL] = g_signal_new ("account-removed", ONLINE_ACCOUNTS_TYPE_ACCOUNTS_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, ONLINE_ACCOUNTS_TYPE_ACCOUNT);
}

static void
online_accounts_accounts_manager_instance_init (OnlineAccountsAccountsManager * self,
                                                gpointer klass)
{
	self->priv = online_accounts_accounts_manager_get_instance_private (self);
}

static void
online_accounts_accounts_manager_finalize (GObject * obj)
{
	OnlineAccountsAccountsManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, ONLINE_ACCOUNTS_TYPE_ACCOUNTS_MANAGER, OnlineAccountsAccountsManager);
	online_accounts_accounts_manager_remove_cached_account (self);
	_g_object_unref0 (self->accounts_available);
	_g_object_unref0 (self->priv->to_delete);
	G_OBJECT_CLASS (online_accounts_accounts_manager_parent_class)->finalize (obj);
}

static GType
online_accounts_accounts_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (OnlineAccountsAccountsManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) online_accounts_accounts_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (OnlineAccountsAccountsManager), 0, (GInstanceInitFunc) online_accounts_accounts_manager_instance_init, NULL };
	GType online_accounts_accounts_manager_type_id;
	online_accounts_accounts_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "OnlineAccountsAccountsManager", &g_define_type_info, 0);
	OnlineAccountsAccountsManager_private_offset = g_type_add_instance_private (online_accounts_accounts_manager_type_id, sizeof (OnlineAccountsAccountsManagerPrivate));
	return online_accounts_accounts_manager_type_id;
}

GType
online_accounts_accounts_manager_get_type (void)
{
	static volatile gsize online_accounts_accounts_manager_type_id__volatile = 0;
	if (g_once_init_enter (&online_accounts_accounts_manager_type_id__volatile)) {
		GType online_accounts_accounts_manager_type_id;
		online_accounts_accounts_manager_type_id = online_accounts_accounts_manager_get_type_once ();
		g_once_init_leave (&online_accounts_accounts_manager_type_id__volatile, online_accounts_accounts_manager_type_id);
	}
	return online_accounts_accounts_manager_type_id__volatile;
}

