/* MailDialog.c generated by valac 0.48.8, the Vala compiler
 * generated from MailDialog.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2013-2016 elementary LLC. (https://elementary.io)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>

#define ONLINE_ACCOUNTS_TYPE_DIALOG (online_accounts_dialog_get_type ())
#define ONLINE_ACCOUNTS_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ONLINE_ACCOUNTS_TYPE_DIALOG, OnlineAccountsDialog))
#define ONLINE_ACCOUNTS_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ONLINE_ACCOUNTS_TYPE_DIALOG, OnlineAccountsDialogClass))
#define ONLINE_ACCOUNTS_IS_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ONLINE_ACCOUNTS_TYPE_DIALOG))
#define ONLINE_ACCOUNTS_IS_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ONLINE_ACCOUNTS_TYPE_DIALOG))
#define ONLINE_ACCOUNTS_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ONLINE_ACCOUNTS_TYPE_DIALOG, OnlineAccountsDialogClass))

typedef struct _OnlineAccountsDialog OnlineAccountsDialog;
typedef struct _OnlineAccountsDialogClass OnlineAccountsDialogClass;
typedef struct _OnlineAccountsDialogPrivate OnlineAccountsDialogPrivate;
typedef enum  {
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_NONE,
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_GENERAL,
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_NO_SIGNONUI,
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_BAD_PARAMETERS,
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_CANCELED,
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_NOT_AVAILABLE,
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_BAD_URL,
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_BAD_CAPTCHA,
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_BAD_CAPTCHA_URL,
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_REFRESH_FAILED,
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_FORBIDDEN,
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_FORGOT_PASSWORD
} OnlineAccountsSignonUIError;

#define ONLINE_ACCOUNTS_TYPE_SIGNON_UI_ERROR (online_accounts_signon_ui_error_get_type ())

#define ONLINE_ACCOUNTS_TYPE_MAIL_DIALOG (online_accounts_mail_dialog_get_type ())
#define ONLINE_ACCOUNTS_MAIL_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ONLINE_ACCOUNTS_TYPE_MAIL_DIALOG, OnlineAccountsMailDialog))
#define ONLINE_ACCOUNTS_MAIL_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ONLINE_ACCOUNTS_TYPE_MAIL_DIALOG, OnlineAccountsMailDialogClass))
#define ONLINE_ACCOUNTS_IS_MAIL_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ONLINE_ACCOUNTS_TYPE_MAIL_DIALOG))
#define ONLINE_ACCOUNTS_IS_MAIL_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ONLINE_ACCOUNTS_TYPE_MAIL_DIALOG))
#define ONLINE_ACCOUNTS_MAIL_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ONLINE_ACCOUNTS_TYPE_MAIL_DIALOG, OnlineAccountsMailDialogClass))

typedef struct _OnlineAccountsMailDialog OnlineAccountsMailDialog;
typedef struct _OnlineAccountsMailDialogClass OnlineAccountsMailDialogClass;
typedef struct _OnlineAccountsMailDialogPrivate OnlineAccountsMailDialogPrivate;
enum  {
	ONLINE_ACCOUNTS_MAIL_DIALOG_0_PROPERTY,
	ONLINE_ACCOUNTS_MAIL_DIALOG_NUM_PROPERTIES
};
static GParamSpec* online_accounts_mail_dialog_properties[ONLINE_ACCOUNTS_MAIL_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block2Data Block2Data;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))

struct _OnlineAccountsDialog {
	GtkGrid parent_instance;
	OnlineAccountsDialogPrivate * priv;
	GHashTable* parameters;
	gchar* request_id;
	OnlineAccountsSignonUIError error_code;
};

struct _OnlineAccountsDialogClass {
	GtkGridClass parent_class;
	GHashTable* (*get_reply) (OnlineAccountsDialog* self);
	gboolean (*set_parameters) (OnlineAccountsDialog* self, GHashTable* params);
	gboolean (*refresh_captcha) (OnlineAccountsDialog* self, const gchar* uri);
};

struct _OnlineAccountsMailDialog {
	OnlineAccountsDialog parent_instance;
	OnlineAccountsMailDialogPrivate * priv;
};

struct _OnlineAccountsMailDialogClass {
	OnlineAccountsDialogClass parent_class;
};

struct _OnlineAccountsMailDialogPrivate {
	GtkButton* cancel_button;
	GtkButton* save_button;
	GtkEntry* imap_username_entry;
	GtkEntry* imap_password_entry;
	GtkEntry* imap_server_entry;
	GtkSpinButton* imap_port_spin;
	GtkComboBoxText* imap_encryption_combobox;
	GtkEntry* smtp_username_entry;
	GtkEntry* smtp_password_entry;
	GtkCheckButton* no_credentials;
	GtkEntry* smtp_server_entry;
	GtkSpinButton* smtp_port_spin;
	GtkComboBoxText* smtp_encryption_combobox;
	GtkCheckButton* use_imap_credentials;
	gboolean imap_modified_by_user;
	gboolean imap_port_modified_by_user;
	gboolean smtp_modified_by_user;
	gboolean smtp_port_modified_by_user;
};

struct _Block2Data {
	int _ref_count_;
	OnlineAccountsMailDialog* self;
	GtkGrid* smtp_credentials;
};

static gint OnlineAccountsMailDialog_private_offset;
static gpointer online_accounts_mail_dialog_parent_class = NULL;

GType online_accounts_dialog_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (OnlineAccountsDialog, g_object_unref)
GType online_accounts_signon_ui_error_get_type (void) G_GNUC_CONST;
GType online_accounts_mail_dialog_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (OnlineAccountsMailDialog, g_object_unref)
OnlineAccountsMailDialog* online_accounts_mail_dialog_new (GHashTable* params);
OnlineAccountsMailDialog* online_accounts_mail_dialog_construct (GType object_type,
                                                                 GHashTable* params);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
OnlineAccountsDialog* online_accounts_dialog_construct (GType object_type,
                                                        GHashTable* parameter);
gboolean online_accounts_dialog_set_parameters (OnlineAccountsDialog* self,
                                                GHashTable* params);
static void __lambda19_ (Block2Data* _data2_);
static void online_accounts_mail_dialog_reset_ok (OnlineAccountsMailDialog* self);
static void ___lambda19__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void __lambda20_ (OnlineAccountsMailDialog* self);
static void ___lambda20__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void __lambda21_ (OnlineAccountsMailDialog* self);
static void ___lambda21__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void __lambda22_ (OnlineAccountsMailDialog* self);
static void ___lambda22__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void __lambda23_ (OnlineAccountsMailDialog* self);
static void ___lambda23__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void __lambda24_ (OnlineAccountsMailDialog* self);
static void ___lambda24__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void __lambda25_ (OnlineAccountsMailDialog* self);
static void ___lambda25__gtk_combo_box_changed (GtkComboBox* _sender,
                                         gpointer self);
static void __lambda26_ (OnlineAccountsMailDialog* self);
static void ___lambda26__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void __lambda27_ (OnlineAccountsMailDialog* self);
static void ___lambda27__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void __lambda28_ (OnlineAccountsMailDialog* self);
static void ___lambda28__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void __lambda29_ (OnlineAccountsMailDialog* self);
static void ___lambda29__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void __lambda30_ (OnlineAccountsMailDialog* self);
static void ___lambda30__gtk_combo_box_changed (GtkComboBox* _sender,
                                         gpointer self);
static void __lambda31_ (OnlineAccountsMailDialog* self);
static void ___lambda31__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
static void __lambda32_ (OnlineAccountsMailDialog* self);
static void ___lambda32__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
static gboolean online_accounts_mail_dialog_real_refresh_captcha (OnlineAccountsDialog* base,
                                                           const gchar* uri);
static gboolean online_accounts_mail_dialog_real_set_parameters (OnlineAccountsDialog* base,
                                                          GHashTable* params);
static gboolean online_accounts_mail_dialog_validate_params (OnlineAccountsMailDialog* self,
                                                      GHashTable* params);
static GHashTable* online_accounts_mail_dialog_real_get_reply (OnlineAccountsDialog* base);
GHashTable* online_accounts_dialog_get_reply (OnlineAccountsDialog* self);
static void online_accounts_mail_dialog_finalize (GObject * obj);
static GType online_accounts_mail_dialog_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static inline gpointer
online_accounts_mail_dialog_get_instance_private (OnlineAccountsMailDialog* self)
{
	return G_STRUCT_MEMBER_P (self, OnlineAccountsMailDialog_private_offset);
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
	g_atomic_int_inc (&_data2_->_ref_count_);
	return _data2_;
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
		OnlineAccountsMailDialog* self;
		self = _data2_->self;
		_g_object_unref0 (_data2_->smtp_credentials);
		_g_object_unref0 (self);
		g_slice_free (Block2Data, _data2_);
	}
}

static void
__lambda19_ (Block2Data* _data2_)
{
	OnlineAccountsMailDialog* self;
	gboolean _tmp0_ = FALSE;
	GtkCheckButton* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GtkCheckButton* _tmp7_;
	GtkCheckButton* _tmp8_;
	gboolean _tmp9_;
	gboolean _tmp10_;
	self = _data2_->self;
	_tmp1_ = self->priv->no_credentials;
	_tmp2_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp1_);
	_tmp3_ = _tmp2_;
	if (!_tmp3_) {
		GtkCheckButton* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
		_tmp4_ = self->priv->use_imap_credentials;
		_tmp5_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp4_);
		_tmp6_ = _tmp5_;
		_tmp0_ = !_tmp6_;
	} else {
		_tmp0_ = FALSE;
	}
	gtk_widget_set_sensitive ((GtkWidget*) _data2_->smtp_credentials, _tmp0_);
	_tmp7_ = self->priv->use_imap_credentials;
	_tmp8_ = self->priv->no_credentials;
	_tmp9_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp8_);
	_tmp10_ = _tmp9_;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp7_, !_tmp10_);
	online_accounts_mail_dialog_reset_ok (self);
}

static void
___lambda19__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda19_ (self);
}

static void
__lambda20_ (OnlineAccountsMailDialog* self)
{
	online_accounts_mail_dialog_reset_ok (self);
}

static void
___lambda20__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda20_ ((OnlineAccountsMailDialog*) self);
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	g_strstrip (_result_);
	result = _result_;
	return result;
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		g_clear_error (&_inner_error0_);
		g_assert_not_reached ();
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

static void
__lambda21_ (OnlineAccountsMailDialog* self)
{
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	_tmp0_ = self->priv->imap_username_entry;
	_tmp1_ = gtk_entry_get_text (_tmp0_);
	_tmp2_ = _tmp1_;
	if (string_contains (_tmp2_, "@")) {
		gchar* domain = NULL;
		GtkEntry* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar** _tmp6_;
		gchar** _tmp7_;
		gchar** _tmp8_;
		gint _tmp8__length1;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		const gchar* _tmp14_;
		gint _tmp15_;
		gint _tmp16_;
		_tmp3_ = self->priv->imap_username_entry;
		_tmp4_ = gtk_entry_get_text (_tmp3_);
		_tmp5_ = _tmp4_;
		_tmp7_ = _tmp6_ = g_strsplit (_tmp5_, "@", 2);
		_tmp8_ = _tmp7_;
		_tmp8__length1 = _vala_array_length (_tmp6_);
		_tmp9_ = _tmp8_[1];
		_tmp10_ = string_strip (_tmp9_);
		_tmp11_ = _tmp10_;
		_tmp12_ = string_replace (_tmp11_, "@", "");
		_tmp13_ = _tmp12_;
		_g_free0 (_tmp11_);
		_tmp8_ = (_vala_array_free (_tmp8_, _tmp8__length1, (GDestroyNotify) g_free), NULL);
		domain = _tmp13_;
		_tmp14_ = domain;
		_tmp15_ = strlen (_tmp14_);
		_tmp16_ = _tmp15_;
		if (_tmp16_ > 0) {
			if (!self->priv->imap_modified_by_user) {
				GtkEntry* _tmp17_;
				const gchar* _tmp18_;
				gchar* _tmp19_;
				gchar* _tmp20_;
				_tmp17_ = self->priv->imap_server_entry;
				_tmp18_ = domain;
				_tmp19_ = g_strconcat ("imap.", _tmp18_, NULL);
				_tmp20_ = _tmp19_;
				gtk_entry_set_text (_tmp17_, _tmp20_);
				_g_free0 (_tmp20_);
			}
			if (!self->priv->smtp_modified_by_user) {
				GtkEntry* _tmp21_;
				const gchar* _tmp22_;
				gchar* _tmp23_;
				gchar* _tmp24_;
				_tmp21_ = self->priv->smtp_server_entry;
				_tmp22_ = domain;
				_tmp23_ = g_strconcat ("smtp.", _tmp22_, NULL);
				_tmp24_ = _tmp23_;
				gtk_entry_set_text (_tmp21_, _tmp24_);
				_g_free0 (_tmp24_);
			}
		}
		_g_free0 (domain);
	}
	online_accounts_mail_dialog_reset_ok (self);
}

static void
___lambda21__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda21_ ((OnlineAccountsMailDialog*) self);
}

static void
__lambda22_ (OnlineAccountsMailDialog* self)
{
	online_accounts_mail_dialog_reset_ok (self);
}

static void
___lambda22__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda22_ ((OnlineAccountsMailDialog*) self);
}

static void
__lambda23_ (OnlineAccountsMailDialog* self)
{
	GtkEntry* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	_tmp0_ = self->priv->imap_server_entry;
	g_object_get ((GtkWidget*) _tmp0_, "has-focus", &_tmp1_, NULL);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		self->priv->imap_modified_by_user = TRUE;
	}
	online_accounts_mail_dialog_reset_ok (self);
}

static void
___lambda23__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda23_ ((OnlineAccountsMailDialog*) self);
}

static void
__lambda24_ (OnlineAccountsMailDialog* self)
{
	GtkSpinButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	_tmp0_ = self->priv->imap_port_spin;
	g_object_get ((GtkWidget*) _tmp0_, "has-focus", &_tmp1_, NULL);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		self->priv->imap_port_modified_by_user = TRUE;
	}
	online_accounts_mail_dialog_reset_ok (self);
}

static void
___lambda24__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda24_ ((OnlineAccountsMailDialog*) self);
}

static void
__lambda25_ (OnlineAccountsMailDialog* self)
{
	if (!self->priv->imap_port_modified_by_user) {
		GtkComboBoxText* _tmp0_;
		gint _tmp1_;
		gint _tmp2_;
		_tmp0_ = self->priv->imap_encryption_combobox;
		_tmp1_ = gtk_combo_box_get_active ((GtkComboBox*) _tmp0_);
		_tmp2_ = _tmp1_;
		switch (_tmp2_) {
			case 1:
			{
				GtkSpinButton* _tmp3_;
				_tmp3_ = self->priv->imap_port_spin;
				gtk_spin_button_set_value (_tmp3_, (gdouble) 993);
				break;
			}
			case 2:
			{
				GtkSpinButton* _tmp4_;
				_tmp4_ = self->priv->imap_port_spin;
				gtk_spin_button_set_value (_tmp4_, (gdouble) 143);
				break;
			}
			default:
			{
				GtkSpinButton* _tmp5_;
				_tmp5_ = self->priv->imap_port_spin;
				gtk_spin_button_set_value (_tmp5_, (gdouble) 143);
				break;
			}
		}
	}
}

static void
___lambda25__gtk_combo_box_changed (GtkComboBox* _sender,
                                    gpointer self)
{
	__lambda25_ ((OnlineAccountsMailDialog*) self);
}

static void
__lambda26_ (OnlineAccountsMailDialog* self)
{
	online_accounts_mail_dialog_reset_ok (self);
}

static void
___lambda26__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda26_ ((OnlineAccountsMailDialog*) self);
}

static void
__lambda27_ (OnlineAccountsMailDialog* self)
{
	online_accounts_mail_dialog_reset_ok (self);
}

static void
___lambda27__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda27_ ((OnlineAccountsMailDialog*) self);
}

static void
__lambda28_ (OnlineAccountsMailDialog* self)
{
	GtkEntry* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	_tmp0_ = self->priv->smtp_server_entry;
	g_object_get ((GtkWidget*) _tmp0_, "has-focus", &_tmp1_, NULL);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		self->priv->smtp_modified_by_user = TRUE;
	}
	online_accounts_mail_dialog_reset_ok (self);
}

static void
___lambda28__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda28_ ((OnlineAccountsMailDialog*) self);
}

static void
__lambda29_ (OnlineAccountsMailDialog* self)
{
	GtkSpinButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	_tmp0_ = self->priv->smtp_port_spin;
	g_object_get ((GtkWidget*) _tmp0_, "has-focus", &_tmp1_, NULL);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		self->priv->smtp_port_modified_by_user = TRUE;
	}
	online_accounts_mail_dialog_reset_ok (self);
}

static void
___lambda29__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda29_ ((OnlineAccountsMailDialog*) self);
}

static void
__lambda30_ (OnlineAccountsMailDialog* self)
{
	if (!self->priv->smtp_port_modified_by_user) {
		GtkComboBoxText* _tmp0_;
		gint _tmp1_;
		gint _tmp2_;
		_tmp0_ = self->priv->smtp_encryption_combobox;
		_tmp1_ = gtk_combo_box_get_active ((GtkComboBox*) _tmp0_);
		_tmp2_ = _tmp1_;
		switch (_tmp2_) {
			case 1:
			{
				GtkSpinButton* _tmp3_;
				_tmp3_ = self->priv->smtp_port_spin;
				gtk_spin_button_set_value (_tmp3_, (gdouble) 465);
				break;
			}
			case 2:
			{
				GtkSpinButton* _tmp4_;
				_tmp4_ = self->priv->smtp_port_spin;
				gtk_spin_button_set_value (_tmp4_, (gdouble) 587);
				break;
			}
			default:
			{
				GtkSpinButton* _tmp5_;
				_tmp5_ = self->priv->smtp_port_spin;
				gtk_spin_button_set_value (_tmp5_, (gdouble) 25);
				break;
			}
		}
	}
}

static void
___lambda30__gtk_combo_box_changed (GtkComboBox* _sender,
                                    gpointer self)
{
	__lambda30_ ((OnlineAccountsMailDialog*) self);
}

static void
__lambda31_ (OnlineAccountsMailDialog* self)
{
	g_signal_emit_by_name ((OnlineAccountsDialog*) self, "finished");
}

static void
___lambda31__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
	__lambda31_ ((OnlineAccountsMailDialog*) self);
}

static void
__lambda32_ (OnlineAccountsMailDialog* self)
{
	((OnlineAccountsDialog*) self)->error_code = ONLINE_ACCOUNTS_SIGNON_UI_ERROR_CANCELED;
	g_signal_emit_by_name ((OnlineAccountsDialog*) self, "finished");
	gtk_widget_destroy ((GtkWidget*) self);
}

static void
___lambda32__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
	__lambda32_ ((OnlineAccountsMailDialog*) self);
}

OnlineAccountsMailDialog*
online_accounts_mail_dialog_construct (GType object_type,
                                       GHashTable* params)
{
	OnlineAccountsMailDialog * self = NULL;
	Block2Data* _data2_;
	GtkGrid* main_grid = NULL;
	GtkGrid* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkLabel* provider_label = NULL;
	GtkLabel* _tmp2_;
	GtkStyleContext* _tmp3_;
	GtkLabel* imap_label = NULL;
	GtkLabel* _tmp4_;
	GtkStyleContext* _tmp5_;
	GtkEntry* _tmp6_;
	GtkEntry* _tmp7_;
	GtkEntry* _tmp8_;
	GtkEntry* _tmp9_;
	GtkEntry* _tmp10_;
	GtkEntry* _tmp11_;
	GtkEntry* _tmp12_;
	GtkGrid* imap_credentials = NULL;
	GtkGrid* _tmp13_;
	GtkStyleContext* _tmp14_;
	GtkEntry* _tmp15_;
	GtkEntry* _tmp16_;
	GtkEntry* _tmp17_;
	GtkEntry* _tmp18_;
	GtkSpinButton* _tmp19_;
	GtkSpinButton* _tmp20_;
	GtkGrid* imap_settings_grid = NULL;
	GtkGrid* _tmp21_;
	GtkStyleContext* _tmp22_;
	GtkEntry* _tmp23_;
	GtkSpinButton* _tmp24_;
	GtkLabel* imap_encryption_label = NULL;
	GtkLabel* _tmp25_;
	GtkComboBoxText* _tmp26_;
	GtkComboBoxText* _tmp27_;
	GtkComboBoxText* _tmp28_;
	GtkComboBoxText* _tmp29_;
	GtkComboBoxText* _tmp30_;
	GtkComboBoxText* _tmp31_;
	GtkGrid* imap_encryption_grid = NULL;
	GtkGrid* _tmp32_;
	GtkComboBoxText* _tmp33_;
	GtkLabel* smtp_label = NULL;
	GtkLabel* _tmp34_;
	GtkStyleContext* _tmp35_;
	GtkEntry* _tmp36_;
	GtkEntry* _tmp37_;
	GtkEntry* _tmp38_;
	GtkEntry* _tmp39_;
	GtkEntry* _tmp40_;
	GtkEntry* _tmp41_;
	GtkEntry* _tmp42_;
	GtkGrid* _tmp43_;
	GtkStyleContext* _tmp44_;
	GtkEntry* _tmp45_;
	GtkEntry* _tmp46_;
	GtkEntry* _tmp47_;
	GtkEntry* _tmp48_;
	GtkSpinButton* _tmp49_;
	GtkSpinButton* _tmp50_;
	GtkGrid* smtp_settings_grid = NULL;
	GtkGrid* _tmp51_;
	GtkStyleContext* _tmp52_;
	GtkEntry* _tmp53_;
	GtkSpinButton* _tmp54_;
	GtkCheckButton* _tmp55_;
	GtkCheckButton* _tmp56_;
	GtkCheckButton* _tmp57_;
	GtkCheckButton* _tmp58_;
	GtkLabel* smtp_encryption_label = NULL;
	GtkLabel* _tmp59_;
	GtkComboBoxText* _tmp60_;
	GtkComboBoxText* _tmp61_;
	GtkComboBoxText* _tmp62_;
	GtkComboBoxText* _tmp63_;
	GtkComboBoxText* _tmp64_;
	GtkComboBoxText* _tmp65_;
	GtkGrid* smtp_encryption_grid = NULL;
	GtkGrid* _tmp66_;
	GtkComboBoxText* _tmp67_;
	GtkButton* _tmp68_;
	GtkButton* _tmp69_;
	GtkButton* _tmp70_;
	GtkButton* _tmp71_;
	GtkStyleContext* _tmp72_;
	GtkButton* _tmp73_;
	GtkButton* _tmp74_;
	GtkGrid* save_box = NULL;
	GtkGrid* _tmp75_;
	GtkButton* _tmp76_;
	GtkButton* _tmp77_;
	GtkGrid* entry_grid = NULL;
	GtkGrid* _tmp78_;
	GtkCheckButton* _tmp79_;
	GtkCheckButton* _tmp80_;
	GtkScrolledWindow* scrolled = NULL;
	GtkScrolledWindow* _tmp81_;
	GtkCheckButton* _tmp82_;
	GtkCheckButton* _tmp83_;
	GtkEntry* _tmp84_;
	GtkEntry* _tmp85_;
	GtkEntry* _tmp86_;
	GtkSpinButton* _tmp87_;
	GtkComboBoxText* _tmp88_;
	GtkEntry* _tmp89_;
	GtkEntry* _tmp90_;
	GtkEntry* _tmp91_;
	GtkSpinButton* _tmp92_;
	GtkComboBoxText* _tmp93_;
	GtkButton* _tmp94_;
	GtkButton* _tmp95_;
	g_return_val_if_fail (params != NULL, NULL);
	_data2_ = g_slice_new0 (Block2Data);
	_data2_->_ref_count_ = 1;
	self = (OnlineAccountsMailDialog*) online_accounts_dialog_construct (object_type, params);
	_data2_->self = g_object_ref (self);
	_tmp0_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp0_);
	main_grid = _tmp0_;
	g_object_set ((GtkWidget*) main_grid, "margin", 12, NULL);
	gtk_widget_set_halign ((GtkWidget*) main_grid, GTK_ALIGN_CENTER);
	gtk_widget_set_valign ((GtkWidget*) main_grid, GTK_ALIGN_CENTER);
	gtk_grid_set_column_spacing (main_grid, 12);
	gtk_grid_set_row_spacing (main_grid, 6);
	gtk_orientable_set_orientation ((GtkOrientable*) main_grid, GTK_ORIENTATION_VERTICAL);
	_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) main_grid);
	gtk_style_context_add_class (_tmp1_, "login");
	_tmp2_ = (GtkLabel*) gtk_label_new (_ ("Mail Account"));
	g_object_ref_sink (_tmp2_);
	provider_label = _tmp2_;
	_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) provider_label);
	gtk_style_context_add_class (_tmp3_, "h1");
	gtk_widget_set_margin_bottom ((GtkWidget*) provider_label, 24);
	_tmp4_ = (GtkLabel*) gtk_label_new ("IMAP");
	g_object_ref_sink (_tmp4_);
	imap_label = _tmp4_;
	_tmp5_ = gtk_widget_get_style_context ((GtkWidget*) imap_label);
	gtk_style_context_add_class (_tmp5_, "h4");
	gtk_widget_set_halign ((GtkWidget*) imap_label, GTK_ALIGN_START);
	_tmp6_ = (GtkEntry*) gtk_entry_new ();
	g_object_ref_sink (_tmp6_);
	_g_object_unref0 (self->priv->imap_username_entry);
	self->priv->imap_username_entry = _tmp6_;
	_tmp7_ = self->priv->imap_username_entry;
	gtk_entry_set_placeholder_text (_tmp7_, _ ("Email"));
	_tmp8_ = self->priv->imap_username_entry;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp8_, TRUE);
	_tmp9_ = (GtkEntry*) gtk_entry_new ();
	g_object_ref_sink (_tmp9_);
	_g_object_unref0 (self->priv->imap_password_entry);
	self->priv->imap_password_entry = _tmp9_;
	_tmp10_ = self->priv->imap_password_entry;
	gtk_entry_set_placeholder_text (_tmp10_, _ ("Password"));
	_tmp11_ = self->priv->imap_password_entry;
	gtk_entry_set_visibility (_tmp11_, FALSE);
	_tmp12_ = self->priv->imap_password_entry;
	gtk_entry_set_input_purpose (_tmp12_, GTK_INPUT_PURPOSE_PASSWORD);
	_tmp13_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp13_);
	imap_credentials = _tmp13_;
	gtk_orientable_set_orientation ((GtkOrientable*) imap_credentials, GTK_ORIENTATION_VERTICAL);
	_tmp14_ = gtk_widget_get_style_context ((GtkWidget*) imap_credentials);
	gtk_style_context_add_class (_tmp14_, GTK_STYLE_CLASS_LINKED);
	_tmp15_ = self->priv->imap_username_entry;
	gtk_container_add ((GtkContainer*) imap_credentials, (GtkWidget*) _tmp15_);
	_tmp16_ = self->priv->imap_password_entry;
	gtk_container_add ((GtkContainer*) imap_credentials, (GtkWidget*) _tmp16_);
	_tmp17_ = (GtkEntry*) gtk_entry_new ();
	g_object_ref_sink (_tmp17_);
	_g_object_unref0 (self->priv->imap_server_entry);
	self->priv->imap_server_entry = _tmp17_;
	_tmp18_ = self->priv->imap_server_entry;
	gtk_entry_set_placeholder_text (_tmp18_, _ ("Server"));
	_tmp19_ = (GtkSpinButton*) gtk_spin_button_new_with_range ((gdouble) 1, (gdouble) G_MAXUINT16, (gdouble) 10);
	g_object_ref_sink (_tmp19_);
	_g_object_unref0 (self->priv->imap_port_spin);
	self->priv->imap_port_spin = _tmp19_;
	_tmp20_ = self->priv->imap_port_spin;
	gtk_spin_button_set_value (_tmp20_, (gdouble) 993);
	_tmp21_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp21_);
	imap_settings_grid = _tmp21_;
	_tmp22_ = gtk_widget_get_style_context ((GtkWidget*) imap_settings_grid);
	gtk_style_context_add_class (_tmp22_, GTK_STYLE_CLASS_LINKED);
	_tmp23_ = self->priv->imap_server_entry;
	gtk_container_add ((GtkContainer*) imap_settings_grid, (GtkWidget*) _tmp23_);
	_tmp24_ = self->priv->imap_port_spin;
	gtk_container_add ((GtkContainer*) imap_settings_grid, (GtkWidget*) _tmp24_);
	_tmp25_ = (GtkLabel*) gtk_label_new (_ ("Encryption:"));
	g_object_ref_sink (_tmp25_);
	imap_encryption_label = _tmp25_;
	_tmp26_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
	g_object_ref_sink (_tmp26_);
	_g_object_unref0 (self->priv->imap_encryption_combobox);
	self->priv->imap_encryption_combobox = _tmp26_;
	_tmp27_ = self->priv->imap_encryption_combobox;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp27_, TRUE);
	_tmp28_ = self->priv->imap_encryption_combobox;
	gtk_combo_box_text_append (_tmp28_, "None", _ ("None"));
	_tmp29_ = self->priv->imap_encryption_combobox;
	gtk_combo_box_text_append (_tmp29_, "SSL/TLS", "SSL/TLS");
	_tmp30_ = self->priv->imap_encryption_combobox;
	gtk_combo_box_text_append (_tmp30_, "STARTTLS", "STARTTLS");
	_tmp31_ = self->priv->imap_encryption_combobox;
	gtk_combo_box_set_active ((GtkComboBox*) _tmp31_, 1);
	_tmp32_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp32_);
	imap_encryption_grid = _tmp32_;
	gtk_grid_set_column_spacing (imap_encryption_grid, 6);
	gtk_container_add ((GtkContainer*) imap_encryption_grid, (GtkWidget*) imap_encryption_label);
	_tmp33_ = self->priv->imap_encryption_combobox;
	gtk_container_add ((GtkContainer*) imap_encryption_grid, (GtkWidget*) _tmp33_);
	_tmp34_ = (GtkLabel*) gtk_label_new ("SMTP");
	g_object_ref_sink (_tmp34_);
	smtp_label = _tmp34_;
	_tmp35_ = gtk_widget_get_style_context ((GtkWidget*) smtp_label);
	gtk_style_context_add_class (_tmp35_, "h4");
	gtk_widget_set_halign ((GtkWidget*) smtp_label, GTK_ALIGN_START);
	_tmp36_ = (GtkEntry*) gtk_entry_new ();
	g_object_ref_sink (_tmp36_);
	_g_object_unref0 (self->priv->smtp_username_entry);
	self->priv->smtp_username_entry = _tmp36_;
	_tmp37_ = self->priv->smtp_username_entry;
	gtk_entry_set_placeholder_text (_tmp37_, _ ("Email"));
	_tmp38_ = self->priv->smtp_username_entry;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp38_, TRUE);
	_tmp39_ = (GtkEntry*) gtk_entry_new ();
	g_object_ref_sink (_tmp39_);
	_g_object_unref0 (self->priv->smtp_password_entry);
	self->priv->smtp_password_entry = _tmp39_;
	_tmp40_ = self->priv->smtp_password_entry;
	gtk_entry_set_placeholder_text (_tmp40_, _ ("Password"));
	_tmp41_ = self->priv->smtp_password_entry;
	gtk_entry_set_visibility (_tmp41_, FALSE);
	_tmp42_ = self->priv->smtp_password_entry;
	gtk_entry_set_input_purpose (_tmp42_, GTK_INPUT_PURPOSE_PASSWORD);
	_tmp43_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp43_);
	_data2_->smtp_credentials = _tmp43_;
	gtk_orientable_set_orientation ((GtkOrientable*) _data2_->smtp_credentials, GTK_ORIENTATION_VERTICAL);
	_tmp44_ = gtk_widget_get_style_context ((GtkWidget*) _data2_->smtp_credentials);
	gtk_style_context_add_class (_tmp44_, GTK_STYLE_CLASS_LINKED);
	_tmp45_ = self->priv->smtp_username_entry;
	gtk_container_add ((GtkContainer*) _data2_->smtp_credentials, (GtkWidget*) _tmp45_);
	_tmp46_ = self->priv->smtp_password_entry;
	gtk_container_add ((GtkContainer*) _data2_->smtp_credentials, (GtkWidget*) _tmp46_);
	_tmp47_ = (GtkEntry*) gtk_entry_new ();
	g_object_ref_sink (_tmp47_);
	_g_object_unref0 (self->priv->smtp_server_entry);
	self->priv->smtp_server_entry = _tmp47_;
	_tmp48_ = self->priv->smtp_server_entry;
	gtk_entry_set_placeholder_text (_tmp48_, _ ("Server"));
	_tmp49_ = (GtkSpinButton*) gtk_spin_button_new_with_range ((gdouble) 1, (gdouble) G_MAXUINT16, (gdouble) 10);
	g_object_ref_sink (_tmp49_);
	_g_object_unref0 (self->priv->smtp_port_spin);
	self->priv->smtp_port_spin = _tmp49_;
	_tmp50_ = self->priv->smtp_port_spin;
	gtk_spin_button_set_value (_tmp50_, (gdouble) 587);
	_tmp51_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp51_);
	smtp_settings_grid = _tmp51_;
	_tmp52_ = gtk_widget_get_style_context ((GtkWidget*) smtp_settings_grid);
	gtk_style_context_add_class (_tmp52_, GTK_STYLE_CLASS_LINKED);
	_tmp53_ = self->priv->smtp_server_entry;
	gtk_container_add ((GtkContainer*) smtp_settings_grid, (GtkWidget*) _tmp53_);
	_tmp54_ = self->priv->smtp_port_spin;
	gtk_container_add ((GtkContainer*) smtp_settings_grid, (GtkWidget*) _tmp54_);
	_tmp55_ = (GtkCheckButton*) gtk_check_button_new_with_label (_ ("Use IMAP Credentials"));
	g_object_ref_sink (_tmp55_);
	_g_object_unref0 (self->priv->use_imap_credentials);
	self->priv->use_imap_credentials = _tmp55_;
	_tmp56_ = self->priv->use_imap_credentials;
	g_object_bind_property_with_closures ((GObject*) _tmp56_, "active", (GObject*) _data2_->smtp_credentials, "sensitive", G_BINDING_INVERT_BOOLEAN, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp57_ = self->priv->use_imap_credentials;
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp57_, TRUE);
	_tmp58_ = (GtkCheckButton*) gtk_check_button_new_with_label (_ ("No authentication required"));
	g_object_ref_sink (_tmp58_);
	_g_object_unref0 (self->priv->no_credentials);
	self->priv->no_credentials = _tmp58_;
	_tmp59_ = (GtkLabel*) gtk_label_new (_ ("Encryption:"));
	g_object_ref_sink (_tmp59_);
	smtp_encryption_label = _tmp59_;
	_tmp60_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
	g_object_ref_sink (_tmp60_);
	_g_object_unref0 (self->priv->smtp_encryption_combobox);
	self->priv->smtp_encryption_combobox = _tmp60_;
	_tmp61_ = self->priv->smtp_encryption_combobox;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp61_, TRUE);
	_tmp62_ = self->priv->smtp_encryption_combobox;
	gtk_combo_box_text_append (_tmp62_, "None", _ ("None"));
	_tmp63_ = self->priv->smtp_encryption_combobox;
	gtk_combo_box_text_append (_tmp63_, "SSL/TLS", "SSL/TLS");
	_tmp64_ = self->priv->smtp_encryption_combobox;
	gtk_combo_box_text_append (_tmp64_, "STARTTLS", "STARTTLS");
	_tmp65_ = self->priv->smtp_encryption_combobox;
	gtk_combo_box_set_active ((GtkComboBox*) _tmp65_, 2);
	_tmp66_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp66_);
	smtp_encryption_grid = _tmp66_;
	gtk_grid_set_column_spacing (smtp_encryption_grid, 6);
	gtk_container_add ((GtkContainer*) smtp_encryption_grid, (GtkWidget*) smtp_encryption_label);
	_tmp67_ = self->priv->smtp_encryption_combobox;
	gtk_container_add ((GtkContainer*) smtp_encryption_grid, (GtkWidget*) _tmp67_);
	_tmp68_ = (GtkButton*) gtk_button_new_with_label (_ ("Cancel"));
	g_object_ref_sink (_tmp68_);
	_g_object_unref0 (self->priv->cancel_button);
	self->priv->cancel_button = _tmp68_;
	_tmp69_ = self->priv->cancel_button;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp69_, TRUE);
	_tmp70_ = (GtkButton*) gtk_button_new_with_label (_ ("Log In"));
	g_object_ref_sink (_tmp70_);
	_g_object_unref0 (self->priv->save_button);
	self->priv->save_button = _tmp70_;
	_tmp71_ = self->priv->save_button;
	_tmp72_ = gtk_widget_get_style_context ((GtkWidget*) _tmp71_);
	gtk_style_context_add_class (_tmp72_, GTK_STYLE_CLASS_SUGGESTED_ACTION);
	_tmp73_ = self->priv->save_button;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp73_, TRUE);
	_tmp74_ = self->priv->save_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp74_, FALSE);
	_tmp75_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp75_);
	save_box = _tmp75_;
	gtk_widget_set_margin_top ((GtkWidget*) save_box, 12);
	gtk_grid_set_column_spacing (save_box, 6);
	_tmp76_ = self->priv->cancel_button;
	gtk_container_add ((GtkContainer*) save_box, (GtkWidget*) _tmp76_);
	_tmp77_ = self->priv->save_button;
	gtk_container_add ((GtkContainer*) save_box, (GtkWidget*) _tmp77_);
	_tmp78_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp78_);
	entry_grid = _tmp78_;
	g_object_set ((GtkWidget*) entry_grid, "expand", TRUE, NULL);
	gtk_grid_set_row_spacing (entry_grid, 6);
	gtk_orientable_set_orientation ((GtkOrientable*) entry_grid, GTK_ORIENTATION_VERTICAL);
	gtk_container_add ((GtkContainer*) entry_grid, (GtkWidget*) imap_label);
	gtk_container_add ((GtkContainer*) entry_grid, (GtkWidget*) imap_credentials);
	gtk_container_add ((GtkContainer*) entry_grid, (GtkWidget*) imap_settings_grid);
	gtk_container_add ((GtkContainer*) entry_grid, (GtkWidget*) imap_encryption_grid);
	gtk_container_add ((GtkContainer*) entry_grid, (GtkWidget*) smtp_label);
	_tmp79_ = self->priv->no_credentials;
	gtk_container_add ((GtkContainer*) entry_grid, (GtkWidget*) _tmp79_);
	gtk_container_add ((GtkContainer*) entry_grid, (GtkWidget*) _data2_->smtp_credentials);
	_tmp80_ = self->priv->use_imap_credentials;
	gtk_container_add ((GtkContainer*) entry_grid, (GtkWidget*) _tmp80_);
	gtk_container_add ((GtkContainer*) entry_grid, (GtkWidget*) smtp_settings_grid);
	gtk_container_add ((GtkContainer*) entry_grid, (GtkWidget*) smtp_encryption_grid);
	gtk_container_add ((GtkContainer*) main_grid, (GtkWidget*) provider_label);
	gtk_container_add ((GtkContainer*) main_grid, (GtkWidget*) entry_grid);
	gtk_container_add ((GtkContainer*) main_grid, (GtkWidget*) save_box);
	_tmp81_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
	g_object_ref_sink (_tmp81_);
	scrolled = _tmp81_;
	gtk_container_add ((GtkContainer*) scrolled, (GtkWidget*) main_grid);
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) scrolled);
	online_accounts_dialog_set_parameters ((OnlineAccountsDialog*) self, params);
	_tmp82_ = self->priv->no_credentials;
	g_signal_connect_data ((GObject*) _tmp82_, "notify::active", (GCallback) ___lambda19__g_object_notify, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
	_tmp83_ = self->priv->use_imap_credentials;
	g_signal_connect_object ((GObject*) _tmp83_, "notify::active", (GCallback) ___lambda20__g_object_notify, self, 0);
	_tmp84_ = self->priv->imap_username_entry;
	g_signal_connect_object ((GObject*) _tmp84_, "notify::text", (GCallback) ___lambda21__g_object_notify, self, 0);
	_tmp85_ = self->priv->imap_password_entry;
	g_signal_connect_object ((GObject*) _tmp85_, "notify::text", (GCallback) ___lambda22__g_object_notify, self, 0);
	_tmp86_ = self->priv->imap_server_entry;
	g_signal_connect_object ((GObject*) _tmp86_, "notify::text", (GCallback) ___lambda23__g_object_notify, self, 0);
	_tmp87_ = self->priv->imap_port_spin;
	g_signal_connect_object ((GObject*) _tmp87_, "notify::text", (GCallback) ___lambda24__g_object_notify, self, 0);
	_tmp88_ = self->priv->imap_encryption_combobox;
	g_signal_connect_object ((GtkComboBox*) _tmp88_, "changed", (GCallback) ___lambda25__gtk_combo_box_changed, self, 0);
	_tmp89_ = self->priv->smtp_username_entry;
	g_signal_connect_object ((GObject*) _tmp89_, "notify::text", (GCallback) ___lambda26__g_object_notify, self, 0);
	_tmp90_ = self->priv->smtp_password_entry;
	g_signal_connect_object ((GObject*) _tmp90_, "notify::text", (GCallback) ___lambda27__g_object_notify, self, 0);
	_tmp91_ = self->priv->smtp_server_entry;
	g_signal_connect_object ((GObject*) _tmp91_, "notify::text", (GCallback) ___lambda28__g_object_notify, self, 0);
	_tmp92_ = self->priv->smtp_port_spin;
	g_signal_connect_object ((GObject*) _tmp92_, "notify::text", (GCallback) ___lambda29__g_object_notify, self, 0);
	_tmp93_ = self->priv->smtp_encryption_combobox;
	g_signal_connect_object ((GtkComboBox*) _tmp93_, "changed", (GCallback) ___lambda30__gtk_combo_box_changed, self, 0);
	_tmp94_ = self->priv->save_button;
	g_signal_connect_object (_tmp94_, "clicked", (GCallback) ___lambda31__gtk_button_clicked, self, 0);
	_tmp95_ = self->priv->cancel_button;
	g_signal_connect_object (_tmp95_, "clicked", (GCallback) ___lambda32__gtk_button_clicked, self, 0);
	gtk_widget_show_all ((GtkWidget*) self);
	_g_object_unref0 (scrolled);
	_g_object_unref0 (entry_grid);
	_g_object_unref0 (save_box);
	_g_object_unref0 (smtp_encryption_grid);
	_g_object_unref0 (smtp_encryption_label);
	_g_object_unref0 (smtp_settings_grid);
	_g_object_unref0 (smtp_label);
	_g_object_unref0 (imap_encryption_grid);
	_g_object_unref0 (imap_encryption_label);
	_g_object_unref0 (imap_settings_grid);
	_g_object_unref0 (imap_credentials);
	_g_object_unref0 (imap_label);
	_g_object_unref0 (provider_label);
	_g_object_unref0 (main_grid);
	block2_data_unref (_data2_);
	_data2_ = NULL;
	return self;
}

OnlineAccountsMailDialog*
online_accounts_mail_dialog_new (GHashTable* params)
{
	return online_accounts_mail_dialog_construct (ONLINE_ACCOUNTS_TYPE_MAIL_DIALOG, params);
}

static gboolean
online_accounts_mail_dialog_real_refresh_captcha (OnlineAccountsDialog* base,
                                                  const gchar* uri)
{
	OnlineAccountsMailDialog * self;
	gboolean result = FALSE;
	self = (OnlineAccountsMailDialog*) base;
	g_return_val_if_fail (uri != NULL, FALSE);
	result = TRUE;
	return result;
}

static gboolean
online_accounts_mail_dialog_real_set_parameters (OnlineAccountsDialog* base,
                                                 GHashTable* params)
{
	OnlineAccountsMailDialog * self;
	GVariant* temp_string = NULL;
	gconstpointer _tmp0_;
	GVariant* _tmp1_;
	gconstpointer _tmp5_;
	GVariant* _tmp6_;
	gconstpointer _tmp10_;
	GVariant* _tmp11_;
	gconstpointer _tmp15_;
	GVariant* _tmp16_;
	GtkEntry* _tmp20_;
	const gchar* _tmp21_;
	const gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	gboolean _tmp25_;
	gconstpointer _tmp40_;
	GVariant* _tmp41_;
	gconstpointer _tmp45_;
	GVariant* _tmp46_;
	gconstpointer _tmp50_;
	GVariant* _tmp51_;
	gconstpointer _tmp54_;
	GVariant* _tmp55_;
	gconstpointer _tmp58_;
	GVariant* _tmp59_;
	gconstpointer _tmp63_;
	GVariant* _tmp64_;
	gboolean result = FALSE;
	self = (OnlineAccountsMailDialog*) base;
	g_return_val_if_fail (params != NULL, FALSE);
	if (ONLINE_ACCOUNTS_DIALOG_CLASS (online_accounts_mail_dialog_parent_class)->set_parameters (G_TYPE_CHECK_INSTANCE_CAST (self, ONLINE_ACCOUNTS_TYPE_DIALOG, OnlineAccountsDialog), params) == FALSE) {
		result = FALSE;
		return result;
	}
	if (online_accounts_mail_dialog_validate_params (self, params) == FALSE) {
		result = FALSE;
		return result;
	}
	_tmp0_ = g_hash_table_lookup (params, "ImapUser");
	temp_string = (GVariant*) _tmp0_;
	_tmp1_ = temp_string;
	if (_tmp1_ != NULL) {
		GtkEntry* _tmp2_;
		GVariant* _tmp3_;
		const gchar* _tmp4_;
		_tmp2_ = self->priv->imap_username_entry;
		_tmp3_ = temp_string;
		_tmp4_ = g_variant_get_string (_tmp3_, NULL);
		gtk_entry_set_text (_tmp2_, _tmp4_);
	}
	_tmp5_ = g_hash_table_lookup (params, "ImapPassword");
	temp_string = (GVariant*) _tmp5_;
	_tmp6_ = temp_string;
	if (_tmp6_ != NULL) {
		GtkEntry* _tmp7_;
		GVariant* _tmp8_;
		const gchar* _tmp9_;
		_tmp7_ = self->priv->imap_password_entry;
		_tmp8_ = temp_string;
		_tmp9_ = g_variant_get_string (_tmp8_, NULL);
		gtk_entry_set_text (_tmp7_, _tmp9_);
	}
	_tmp10_ = g_hash_table_lookup (params, "SmtpUser");
	temp_string = (GVariant*) _tmp10_;
	_tmp11_ = temp_string;
	if (_tmp11_ != NULL) {
		GtkEntry* _tmp12_;
		GVariant* _tmp13_;
		const gchar* _tmp14_;
		_tmp12_ = self->priv->smtp_username_entry;
		_tmp13_ = temp_string;
		_tmp14_ = g_variant_get_string (_tmp13_, NULL);
		gtk_entry_set_text (_tmp12_, _tmp14_);
	}
	_tmp15_ = g_hash_table_lookup (params, "SmtpPassword");
	temp_string = (GVariant*) _tmp15_;
	_tmp16_ = temp_string;
	if (_tmp16_ != NULL) {
		GtkEntry* _tmp17_;
		GVariant* _tmp18_;
		const gchar* _tmp19_;
		_tmp17_ = self->priv->smtp_password_entry;
		_tmp18_ = temp_string;
		_tmp19_ = g_variant_get_string (_tmp18_, NULL);
		gtk_entry_set_text (_tmp17_, _tmp19_);
	}
	_tmp20_ = self->priv->smtp_username_entry;
	_tmp21_ = gtk_entry_get_text (_tmp20_);
	_tmp22_ = _tmp21_;
	_tmp23_ = string_strip (_tmp22_);
	_tmp24_ = _tmp23_;
	_tmp25_ = g_strcmp0 (_tmp24_, "") != 0;
	_g_free0 (_tmp24_);
	if (_tmp25_) {
		gboolean _tmp26_ = FALSE;
		GtkEntry* _tmp27_;
		const gchar* _tmp28_;
		const gchar* _tmp29_;
		GtkEntry* _tmp30_;
		const gchar* _tmp31_;
		const gchar* _tmp32_;
		GtkCheckButton* _tmp39_;
		_tmp27_ = self->priv->smtp_username_entry;
		_tmp28_ = gtk_entry_get_text (_tmp27_);
		_tmp29_ = _tmp28_;
		_tmp30_ = self->priv->imap_username_entry;
		_tmp31_ = gtk_entry_get_text (_tmp30_);
		_tmp32_ = _tmp31_;
		if (g_strcmp0 (_tmp29_, _tmp32_) == 0) {
			GtkEntry* _tmp33_;
			const gchar* _tmp34_;
			const gchar* _tmp35_;
			GtkEntry* _tmp36_;
			const gchar* _tmp37_;
			const gchar* _tmp38_;
			_tmp33_ = self->priv->smtp_password_entry;
			_tmp34_ = gtk_entry_get_text (_tmp33_);
			_tmp35_ = _tmp34_;
			_tmp36_ = self->priv->imap_password_entry;
			_tmp37_ = gtk_entry_get_text (_tmp36_);
			_tmp38_ = _tmp37_;
			_tmp26_ = g_strcmp0 (_tmp35_, _tmp38_) == 0;
		} else {
			_tmp26_ = FALSE;
		}
		_tmp39_ = self->priv->use_imap_credentials;
		gtk_toggle_button_set_active ((GtkToggleButton*) _tmp39_, _tmp26_);
	}
	_tmp40_ = g_hash_table_lookup (params, "ImapServer");
	temp_string = (GVariant*) _tmp40_;
	_tmp41_ = temp_string;
	if (_tmp41_ != NULL) {
		GtkEntry* _tmp42_;
		GVariant* _tmp43_;
		const gchar* _tmp44_;
		_tmp42_ = self->priv->imap_server_entry;
		_tmp43_ = temp_string;
		_tmp44_ = g_variant_get_string (_tmp43_, NULL);
		gtk_entry_set_text (_tmp42_, _tmp44_);
	}
	_tmp45_ = g_hash_table_lookup (params, "SmtpServer");
	temp_string = (GVariant*) _tmp45_;
	_tmp46_ = temp_string;
	if (_tmp46_ != NULL) {
		GtkEntry* _tmp47_;
		GVariant* _tmp48_;
		const gchar* _tmp49_;
		_tmp47_ = self->priv->smtp_server_entry;
		_tmp48_ = temp_string;
		_tmp49_ = g_variant_get_string (_tmp48_, NULL);
		gtk_entry_set_text (_tmp47_, _tmp49_);
	}
	_tmp50_ = g_hash_table_lookup (params, "ImapPort");
	temp_string = (GVariant*) _tmp50_;
	_tmp51_ = temp_string;
	if (_tmp51_ != NULL) {
		GtkSpinButton* _tmp52_;
		GVariant* _tmp53_;
		_tmp52_ = self->priv->imap_port_spin;
		_tmp53_ = temp_string;
		gtk_spin_button_set_value (_tmp52_, (gdouble) g_variant_get_uint16 (_tmp53_));
	}
	_tmp54_ = g_hash_table_lookup (params, "SmtpPort");
	temp_string = (GVariant*) _tmp54_;
	_tmp55_ = temp_string;
	if (_tmp55_ != NULL) {
		GtkSpinButton* _tmp56_;
		GVariant* _tmp57_;
		_tmp56_ = self->priv->smtp_port_spin;
		_tmp57_ = temp_string;
		gtk_spin_button_set_value (_tmp56_, (gdouble) g_variant_get_uint16 (_tmp57_));
	}
	_tmp58_ = g_hash_table_lookup (params, "ImapEncryption");
	temp_string = (GVariant*) _tmp58_;
	_tmp59_ = temp_string;
	if (_tmp59_ != NULL) {
		GtkComboBoxText* _tmp60_;
		GVariant* _tmp61_;
		const gchar* _tmp62_;
		_tmp60_ = self->priv->imap_encryption_combobox;
		_tmp61_ = temp_string;
		_tmp62_ = g_variant_get_string (_tmp61_, NULL);
		gtk_combo_box_set_active_id ((GtkComboBox*) _tmp60_, _tmp62_);
	}
	_tmp63_ = g_hash_table_lookup (params, "SmtpEncryption");
	temp_string = (GVariant*) _tmp63_;
	_tmp64_ = temp_string;
	if (_tmp64_ != NULL) {
		GtkComboBoxText* _tmp65_;
		GVariant* _tmp66_;
		const gchar* _tmp67_;
		_tmp65_ = self->priv->smtp_encryption_combobox;
		_tmp66_ = temp_string;
		_tmp67_ = g_variant_get_string (_tmp66_, NULL);
		gtk_combo_box_set_active_id ((GtkComboBox*) _tmp65_, _tmp67_);
	}
	online_accounts_mail_dialog_reset_ok (self);
	result = TRUE;
	return result;
}

static gboolean
online_accounts_mail_dialog_validate_params (OnlineAccountsMailDialog* self,
                                             GHashTable* params)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (params != NULL, FALSE);
	result = TRUE;
	return result;
}

static GHashTable*
online_accounts_mail_dialog_real_get_reply (OnlineAccountsDialog* base)
{
	OnlineAccountsMailDialog * self;
	GHashTable* table = NULL;
	GHashTable* _tmp0_;
	GHashTable* _tmp1_;
	gchar* _tmp2_;
	GtkEntry* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	GVariant* _tmp6_;
	GHashTable* _tmp7_;
	gchar* _tmp8_;
	GtkEntry* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	GVariant* _tmp12_;
	GtkCheckButton* _tmp13_;
	gboolean _tmp14_;
	gboolean _tmp15_;
	GHashTable* _tmp43_;
	gchar* _tmp44_;
	GtkEntry* _tmp45_;
	const gchar* _tmp46_;
	const gchar* _tmp47_;
	GVariant* _tmp48_;
	GHashTable* _tmp49_;
	gchar* _tmp50_;
	GtkSpinButton* _tmp51_;
	gdouble _tmp52_;
	gdouble _tmp53_;
	GVariant* _tmp54_;
	GHashTable* _tmp55_;
	gchar* _tmp56_;
	GtkComboBoxText* _tmp57_;
	const gchar* _tmp58_;
	const gchar* _tmp59_;
	GVariant* _tmp60_;
	GHashTable* _tmp61_;
	gchar* _tmp62_;
	GtkEntry* _tmp63_;
	const gchar* _tmp64_;
	const gchar* _tmp65_;
	GVariant* _tmp66_;
	GHashTable* _tmp67_;
	gchar* _tmp68_;
	GtkSpinButton* _tmp69_;
	gdouble _tmp70_;
	gdouble _tmp71_;
	GVariant* _tmp72_;
	GHashTable* _tmp73_;
	gchar* _tmp74_;
	GtkComboBoxText* _tmp75_;
	const gchar* _tmp76_;
	const gchar* _tmp77_;
	GVariant* _tmp78_;
	GHashTable* result = NULL;
	self = (OnlineAccountsMailDialog*) base;
	_tmp0_ = ONLINE_ACCOUNTS_DIALOG_CLASS (online_accounts_mail_dialog_parent_class)->get_reply (G_TYPE_CHECK_INSTANCE_CAST (self, ONLINE_ACCOUNTS_TYPE_DIALOG, OnlineAccountsDialog));
	table = _tmp0_;
	_tmp1_ = table;
	_tmp2_ = g_strdup ("ImapUser");
	_tmp3_ = self->priv->imap_username_entry;
	_tmp4_ = gtk_entry_get_text (_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = g_variant_new_string (_tmp5_);
	g_variant_ref_sink (_tmp6_);
	g_hash_table_insert (_tmp1_, _tmp2_, _tmp6_);
	_tmp7_ = table;
	_tmp8_ = g_strdup ("ImapPassword");
	_tmp9_ = self->priv->imap_password_entry;
	_tmp10_ = gtk_entry_get_text (_tmp9_);
	_tmp11_ = _tmp10_;
	_tmp12_ = g_variant_new_string (_tmp11_);
	g_variant_ref_sink (_tmp12_);
	g_hash_table_insert (_tmp7_, _tmp8_, _tmp12_);
	_tmp13_ = self->priv->no_credentials;
	_tmp14_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp13_);
	_tmp15_ = _tmp14_;
	if (!_tmp15_) {
		GtkCheckButton* _tmp16_;
		gboolean _tmp17_;
		gboolean _tmp18_;
		_tmp16_ = self->priv->use_imap_credentials;
		_tmp17_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp16_);
		_tmp18_ = _tmp17_;
		if (_tmp18_) {
			GHashTable* _tmp19_;
			gchar* _tmp20_;
			GtkEntry* _tmp21_;
			const gchar* _tmp22_;
			const gchar* _tmp23_;
			GVariant* _tmp24_;
			GHashTable* _tmp25_;
			gchar* _tmp26_;
			GtkEntry* _tmp27_;
			const gchar* _tmp28_;
			const gchar* _tmp29_;
			GVariant* _tmp30_;
			_tmp19_ = table;
			_tmp20_ = g_strdup ("SmtpUser");
			_tmp21_ = self->priv->imap_username_entry;
			_tmp22_ = gtk_entry_get_text (_tmp21_);
			_tmp23_ = _tmp22_;
			_tmp24_ = g_variant_new_string (_tmp23_);
			g_variant_ref_sink (_tmp24_);
			g_hash_table_insert (_tmp19_, _tmp20_, _tmp24_);
			_tmp25_ = table;
			_tmp26_ = g_strdup ("SmtpPassword");
			_tmp27_ = self->priv->imap_password_entry;
			_tmp28_ = gtk_entry_get_text (_tmp27_);
			_tmp29_ = _tmp28_;
			_tmp30_ = g_variant_new_string (_tmp29_);
			g_variant_ref_sink (_tmp30_);
			g_hash_table_insert (_tmp25_, _tmp26_, _tmp30_);
		} else {
			GHashTable* _tmp31_;
			gchar* _tmp32_;
			GtkEntry* _tmp33_;
			const gchar* _tmp34_;
			const gchar* _tmp35_;
			GVariant* _tmp36_;
			GHashTable* _tmp37_;
			gchar* _tmp38_;
			GtkEntry* _tmp39_;
			const gchar* _tmp40_;
			const gchar* _tmp41_;
			GVariant* _tmp42_;
			_tmp31_ = table;
			_tmp32_ = g_strdup ("SmtpUser");
			_tmp33_ = self->priv->smtp_username_entry;
			_tmp34_ = gtk_entry_get_text (_tmp33_);
			_tmp35_ = _tmp34_;
			_tmp36_ = g_variant_new_string (_tmp35_);
			g_variant_ref_sink (_tmp36_);
			g_hash_table_insert (_tmp31_, _tmp32_, _tmp36_);
			_tmp37_ = table;
			_tmp38_ = g_strdup ("SmtpPassword");
			_tmp39_ = self->priv->smtp_password_entry;
			_tmp40_ = gtk_entry_get_text (_tmp39_);
			_tmp41_ = _tmp40_;
			_tmp42_ = g_variant_new_string (_tmp41_);
			g_variant_ref_sink (_tmp42_);
			g_hash_table_insert (_tmp37_, _tmp38_, _tmp42_);
		}
	}
	_tmp43_ = table;
	_tmp44_ = g_strdup ("ImapServer");
	_tmp45_ = self->priv->imap_server_entry;
	_tmp46_ = gtk_entry_get_text (_tmp45_);
	_tmp47_ = _tmp46_;
	_tmp48_ = g_variant_new_string (_tmp47_);
	g_variant_ref_sink (_tmp48_);
	g_hash_table_insert (_tmp43_, _tmp44_, _tmp48_);
	_tmp49_ = table;
	_tmp50_ = g_strdup ("ImapPort");
	_tmp51_ = self->priv->imap_port_spin;
	_tmp52_ = gtk_spin_button_get_value (_tmp51_);
	_tmp53_ = _tmp52_;
	_tmp54_ = g_variant_new_uint16 ((guint16) _tmp53_);
	g_variant_ref_sink (_tmp54_);
	g_hash_table_insert (_tmp49_, _tmp50_, _tmp54_);
	_tmp55_ = table;
	_tmp56_ = g_strdup ("ImapSecurity");
	_tmp57_ = self->priv->imap_encryption_combobox;
	_tmp58_ = gtk_combo_box_get_active_id ((GtkComboBox*) _tmp57_);
	_tmp59_ = _tmp58_;
	_tmp60_ = g_variant_new_string (_tmp59_);
	g_variant_ref_sink (_tmp60_);
	g_hash_table_insert (_tmp55_, _tmp56_, _tmp60_);
	_tmp61_ = table;
	_tmp62_ = g_strdup ("SmtpServer");
	_tmp63_ = self->priv->smtp_server_entry;
	_tmp64_ = gtk_entry_get_text (_tmp63_);
	_tmp65_ = _tmp64_;
	_tmp66_ = g_variant_new_string (_tmp65_);
	g_variant_ref_sink (_tmp66_);
	g_hash_table_insert (_tmp61_, _tmp62_, _tmp66_);
	_tmp67_ = table;
	_tmp68_ = g_strdup ("SmtpPort");
	_tmp69_ = self->priv->smtp_port_spin;
	_tmp70_ = gtk_spin_button_get_value (_tmp69_);
	_tmp71_ = _tmp70_;
	_tmp72_ = g_variant_new_uint16 ((guint16) _tmp71_);
	g_variant_ref_sink (_tmp72_);
	g_hash_table_insert (_tmp67_, _tmp68_, _tmp72_);
	_tmp73_ = table;
	_tmp74_ = g_strdup ("SmtpSecurity");
	_tmp75_ = self->priv->smtp_encryption_combobox;
	_tmp76_ = gtk_combo_box_get_active_id ((GtkComboBox*) _tmp75_);
	_tmp77_ = _tmp76_;
	_tmp78_ = g_variant_new_string (_tmp77_);
	g_variant_ref_sink (_tmp78_);
	g_hash_table_insert (_tmp73_, _tmp74_, _tmp78_);
	result = table;
	return result;
}

static void
online_accounts_mail_dialog_reset_ok (OnlineAccountsMailDialog* self)
{
	gboolean state = FALSE;
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GtkEntry* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gboolean _tmp10_ = FALSE;
	GtkCheckButton* _tmp11_;
	gboolean _tmp12_;
	gboolean _tmp13_;
	GtkEntry* _tmp27_;
	const gchar* _tmp28_;
	const gchar* _tmp29_;
	gchar* _tmp30_;
	gchar* _tmp31_;
	gint _tmp32_;
	gint _tmp33_;
	GtkEntry* _tmp34_;
	const gchar* _tmp35_;
	const gchar* _tmp36_;
	gchar* _tmp37_;
	gchar* _tmp38_;
	gint _tmp39_;
	gint _tmp40_;
	GtkButton* _tmp41_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->imap_username_entry;
	_tmp1_ = gtk_entry_get_text (_tmp0_);
	_tmp2_ = _tmp1_;
	state = string_contains (_tmp2_, "@");
	_tmp3_ = self->priv->imap_password_entry;
	_tmp4_ = gtk_entry_get_text (_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = string_strip (_tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = strlen (_tmp7_);
	_tmp9_ = _tmp8_;
	state &= _tmp9_ > 0;
	_g_free0 (_tmp7_);
	_tmp11_ = self->priv->no_credentials;
	_tmp12_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp11_);
	_tmp13_ = _tmp12_;
	if (!_tmp13_) {
		GtkCheckButton* _tmp14_;
		gboolean _tmp15_;
		gboolean _tmp16_;
		_tmp14_ = self->priv->use_imap_credentials;
		_tmp15_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp14_);
		_tmp16_ = _tmp15_;
		_tmp10_ = !_tmp16_;
	} else {
		_tmp10_ = FALSE;
	}
	if (_tmp10_) {
		GtkEntry* _tmp17_;
		const gchar* _tmp18_;
		const gchar* _tmp19_;
		GtkEntry* _tmp20_;
		const gchar* _tmp21_;
		const gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		gint _tmp25_;
		gint _tmp26_;
		_tmp17_ = self->priv->smtp_username_entry;
		_tmp18_ = gtk_entry_get_text (_tmp17_);
		_tmp19_ = _tmp18_;
		state &= string_contains (_tmp19_, "@");
		_tmp20_ = self->priv->smtp_password_entry;
		_tmp21_ = gtk_entry_get_text (_tmp20_);
		_tmp22_ = _tmp21_;
		_tmp23_ = string_strip (_tmp22_);
		_tmp24_ = _tmp23_;
		_tmp25_ = strlen (_tmp24_);
		_tmp26_ = _tmp25_;
		state &= _tmp26_ > 0;
		_g_free0 (_tmp24_);
	}
	_tmp27_ = self->priv->imap_server_entry;
	_tmp28_ = gtk_entry_get_text (_tmp27_);
	_tmp29_ = _tmp28_;
	_tmp30_ = string_strip (_tmp29_);
	_tmp31_ = _tmp30_;
	_tmp32_ = strlen (_tmp31_);
	_tmp33_ = _tmp32_;
	state &= _tmp33_ > 0;
	_g_free0 (_tmp31_);
	_tmp34_ = self->priv->smtp_server_entry;
	_tmp35_ = gtk_entry_get_text (_tmp34_);
	_tmp36_ = _tmp35_;
	_tmp37_ = string_strip (_tmp36_);
	_tmp38_ = _tmp37_;
	_tmp39_ = strlen (_tmp38_);
	_tmp40_ = _tmp39_;
	state &= _tmp40_ > 0;
	_g_free0 (_tmp38_);
	_tmp41_ = self->priv->save_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp41_, state);
}

static void
online_accounts_mail_dialog_class_init (OnlineAccountsMailDialogClass * klass,
                                        gpointer klass_data)
{
	online_accounts_mail_dialog_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &OnlineAccountsMailDialog_private_offset);
	((OnlineAccountsDialogClass *) klass)->refresh_captcha = (gboolean (*) (OnlineAccountsDialog*, const gchar*)) online_accounts_mail_dialog_real_refresh_captcha;
	((OnlineAccountsDialogClass *) klass)->set_parameters = (gboolean (*) (OnlineAccountsDialog*, GHashTable*)) online_accounts_mail_dialog_real_set_parameters;
	((OnlineAccountsDialogClass *) klass)->get_reply = (GHashTable* (*) (OnlineAccountsDialog*)) online_accounts_mail_dialog_real_get_reply;
	G_OBJECT_CLASS (klass)->finalize = online_accounts_mail_dialog_finalize;
}

static void
online_accounts_mail_dialog_instance_init (OnlineAccountsMailDialog * self,
                                           gpointer klass)
{
	self->priv = online_accounts_mail_dialog_get_instance_private (self);
	self->priv->imap_modified_by_user = FALSE;
	self->priv->imap_port_modified_by_user = FALSE;
	self->priv->smtp_modified_by_user = FALSE;
	self->priv->smtp_port_modified_by_user = FALSE;
}

static void
online_accounts_mail_dialog_finalize (GObject * obj)
{
	OnlineAccountsMailDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, ONLINE_ACCOUNTS_TYPE_MAIL_DIALOG, OnlineAccountsMailDialog);
	_g_object_unref0 (self->priv->cancel_button);
	_g_object_unref0 (self->priv->save_button);
	_g_object_unref0 (self->priv->imap_username_entry);
	_g_object_unref0 (self->priv->imap_password_entry);
	_g_object_unref0 (self->priv->imap_server_entry);
	_g_object_unref0 (self->priv->imap_port_spin);
	_g_object_unref0 (self->priv->imap_encryption_combobox);
	_g_object_unref0 (self->priv->smtp_username_entry);
	_g_object_unref0 (self->priv->smtp_password_entry);
	_g_object_unref0 (self->priv->no_credentials);
	_g_object_unref0 (self->priv->smtp_server_entry);
	_g_object_unref0 (self->priv->smtp_port_spin);
	_g_object_unref0 (self->priv->smtp_encryption_combobox);
	_g_object_unref0 (self->priv->use_imap_credentials);
	G_OBJECT_CLASS (online_accounts_mail_dialog_parent_class)->finalize (obj);
}

static GType
online_accounts_mail_dialog_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (OnlineAccountsMailDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) online_accounts_mail_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (OnlineAccountsMailDialog), 0, (GInstanceInitFunc) online_accounts_mail_dialog_instance_init, NULL };
	GType online_accounts_mail_dialog_type_id;
	online_accounts_mail_dialog_type_id = g_type_register_static (ONLINE_ACCOUNTS_TYPE_DIALOG, "OnlineAccountsMailDialog", &g_define_type_info, 0);
	OnlineAccountsMailDialog_private_offset = g_type_add_instance_private (online_accounts_mail_dialog_type_id, sizeof (OnlineAccountsMailDialogPrivate));
	return online_accounts_mail_dialog_type_id;
}

GType
online_accounts_mail_dialog_get_type (void)
{
	static volatile gsize online_accounts_mail_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&online_accounts_mail_dialog_type_id__volatile)) {
		GType online_accounts_mail_dialog_type_id;
		online_accounts_mail_dialog_type_id = online_accounts_mail_dialog_get_type_once ();
		g_once_init_leave (&online_accounts_mail_dialog_type_id__volatile, online_accounts_mail_dialog_type_id);
	}
	return online_accounts_mail_dialog_type_id__volatile;
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gint i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	gint length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

