/* PasswordDialog.c generated by valac 0.48.8, the Vala compiler
 * generated from PasswordDialog.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2013-2016 elementary LLC. (https://elementary.io)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>

#define ONLINE_ACCOUNTS_TYPE_DIALOG (online_accounts_dialog_get_type ())
#define ONLINE_ACCOUNTS_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ONLINE_ACCOUNTS_TYPE_DIALOG, OnlineAccountsDialog))
#define ONLINE_ACCOUNTS_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ONLINE_ACCOUNTS_TYPE_DIALOG, OnlineAccountsDialogClass))
#define ONLINE_ACCOUNTS_IS_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ONLINE_ACCOUNTS_TYPE_DIALOG))
#define ONLINE_ACCOUNTS_IS_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ONLINE_ACCOUNTS_TYPE_DIALOG))
#define ONLINE_ACCOUNTS_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ONLINE_ACCOUNTS_TYPE_DIALOG, OnlineAccountsDialogClass))

typedef struct _OnlineAccountsDialog OnlineAccountsDialog;
typedef struct _OnlineAccountsDialogClass OnlineAccountsDialogClass;
typedef struct _OnlineAccountsDialogPrivate OnlineAccountsDialogPrivate;
typedef enum  {
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_NONE,
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_GENERAL,
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_NO_SIGNONUI,
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_BAD_PARAMETERS,
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_CANCELED,
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_NOT_AVAILABLE,
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_BAD_URL,
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_BAD_CAPTCHA,
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_BAD_CAPTCHA_URL,
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_REFRESH_FAILED,
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_FORBIDDEN,
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_FORGOT_PASSWORD
} OnlineAccountsSignonUIError;

#define ONLINE_ACCOUNTS_TYPE_SIGNON_UI_ERROR (online_accounts_signon_ui_error_get_type ())

#define ONLINE_ACCOUNTS_TYPE_PASSWORD_DIALOG (online_accounts_password_dialog_get_type ())
#define ONLINE_ACCOUNTS_PASSWORD_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ONLINE_ACCOUNTS_TYPE_PASSWORD_DIALOG, OnlineAccountsPasswordDialog))
#define ONLINE_ACCOUNTS_PASSWORD_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ONLINE_ACCOUNTS_TYPE_PASSWORD_DIALOG, OnlineAccountsPasswordDialogClass))
#define ONLINE_ACCOUNTS_IS_PASSWORD_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ONLINE_ACCOUNTS_TYPE_PASSWORD_DIALOG))
#define ONLINE_ACCOUNTS_IS_PASSWORD_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ONLINE_ACCOUNTS_TYPE_PASSWORD_DIALOG))
#define ONLINE_ACCOUNTS_PASSWORD_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ONLINE_ACCOUNTS_TYPE_PASSWORD_DIALOG, OnlineAccountsPasswordDialogClass))

typedef struct _OnlineAccountsPasswordDialog OnlineAccountsPasswordDialog;
typedef struct _OnlineAccountsPasswordDialogClass OnlineAccountsPasswordDialogClass;
typedef struct _OnlineAccountsPasswordDialogPrivate OnlineAccountsPasswordDialogPrivate;
enum  {
	ONLINE_ACCOUNTS_PASSWORD_DIALOG_0_PROPERTY,
	ONLINE_ACCOUNTS_PASSWORD_DIALOG_NUM_PROPERTIES
};
static GParamSpec* online_accounts_password_dialog_properties[ONLINE_ACCOUNTS_PASSWORD_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
enum  {
	ONLINE_ACCOUNTS_PASSWORD_DIALOG_REFRESH_CAPTCHA_NEEDED_SIGNAL,
	ONLINE_ACCOUNTS_PASSWORD_DIALOG_NUM_SIGNALS
};
static guint online_accounts_password_dialog_signals[ONLINE_ACCOUNTS_PASSWORD_DIALOG_NUM_SIGNALS] = {0};

struct _OnlineAccountsDialog {
	GtkGrid parent_instance;
	OnlineAccountsDialogPrivate * priv;
	GHashTable* parameters;
	gchar* request_id;
	OnlineAccountsSignonUIError error_code;
};

struct _OnlineAccountsDialogClass {
	GtkGridClass parent_class;
	GHashTable* (*get_reply) (OnlineAccountsDialog* self);
	gboolean (*set_parameters) (OnlineAccountsDialog* self, GHashTable* params);
	gboolean (*refresh_captcha) (OnlineAccountsDialog* self, const gchar* uri);
};

struct _OnlineAccountsPasswordDialog {
	OnlineAccountsDialog parent_instance;
	OnlineAccountsPasswordDialogPrivate * priv;
};

struct _OnlineAccountsPasswordDialogClass {
	OnlineAccountsDialogClass parent_class;
};

struct _OnlineAccountsPasswordDialogPrivate {
	GtkEntry* url_entry;
	GtkEntry* username_entry;
	GtkEntry* password_entry;
	GtkEntry* new_password_entry;
	GtkEntry* confirm_password_entry;
	GtkEntry* captcha_entry;
	GtkButton* cancel_button;
	GtkButton* save_button;
	GtkLinkButton* forgot_button;
	GtkLinkButton* signup_button;
	GtkImage* captcha_image;
	GtkLabel* message_label;
	GtkLabel* provider_label;
	gboolean query_url;
	gboolean query_username;
	gboolean query_password;
	gboolean query_confirm;
	gboolean query_captcha;
	gboolean is_username_valid;
	gboolean is_password_valid;
	gboolean is_new_password_valid;
	gboolean is_captcha_valid;
	gchar* display_name;
	gchar* old_password;
	gchar* forgot_password_url;
	gchar* signup_url;
};

static gint OnlineAccountsPasswordDialog_private_offset;
static gpointer online_accounts_password_dialog_parent_class = NULL;

GType online_accounts_dialog_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (OnlineAccountsDialog, g_object_unref)
GType online_accounts_signon_ui_error_get_type (void) G_GNUC_CONST;
GType online_accounts_password_dialog_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (OnlineAccountsPasswordDialog, g_object_unref)
OnlineAccountsPasswordDialog* online_accounts_password_dialog_new (GHashTable* params);
OnlineAccountsPasswordDialog* online_accounts_password_dialog_construct (GType object_type,
                                                                         GHashTable* params);
OnlineAccountsDialog* online_accounts_dialog_construct (GType object_type,
                                                        GHashTable* parameter);
gboolean online_accounts_dialog_set_parameters (OnlineAccountsDialog* self,
                                                GHashTable* params);
static void __lambda41_ (OnlineAccountsPasswordDialog* self);
static void ___lambda41__gtk_entry_activate (GtkEntry* _sender,
                                      gpointer self);
static void __lambda42_ (OnlineAccountsPasswordDialog* self);
static void ___lambda42__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
static void __lambda43_ (OnlineAccountsPasswordDialog* self);
static void ___lambda43__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
static gboolean online_accounts_password_dialog_real_set_parameters (OnlineAccountsDialog* base,
                                                              GHashTable* params);
static gboolean online_accounts_password_dialog_validate_params (OnlineAccountsPasswordDialog* self,
                                                          GHashTable* params);
#define ONLINE_ACCOUNTS_KEY_USERNAME "UserName"
static gboolean ___lambda34_ (OnlineAccountsPasswordDialog* self);
static gboolean ____lambda34__gtk_link_button_activate_link (GtkLinkButton* _sender,
                                                      gpointer self);
#define ONLINE_ACCOUNTS_KEY_MESSAGE "Message"
#define ONLINE_ACCOUNTS_KEY_CAPTCHA_URL "CaptchaUrl"
gboolean online_accounts_dialog_refresh_captcha (OnlineAccountsDialog* self,
                                                 const gchar* uri);
static void ___lambda35_ (OnlineAccountsPasswordDialog* self);
static void online_accounts_password_dialog_reset_ok (OnlineAccountsPasswordDialog* self);
static void ____lambda35__gtk_editable_changed (GtkEditable* _sender,
                                         gpointer self);
static void ___lambda36_ (OnlineAccountsPasswordDialog* self);
static void ____lambda36__gtk_editable_changed (GtkEditable* _sender,
                                         gpointer self);
static void ___lambda37_ (OnlineAccountsPasswordDialog* self);
static void ____lambda37__gtk_editable_changed (GtkEditable* _sender,
                                         gpointer self);
static void ___lambda38_ (OnlineAccountsPasswordDialog* self);
static void ____lambda38__gtk_editable_changed (GtkEditable* _sender,
                                         gpointer self);
static void ___lambda39_ (OnlineAccountsPasswordDialog* self);
static void ____lambda39__gtk_editable_changed (GtkEditable* _sender,
                                         gpointer self);
static void ___lambda40_ (OnlineAccountsPasswordDialog* self,
                   GtkEntryIconPosition pos,
                   GdkEventButton* event);
static void ____lambda40__gtk_entry_icon_release (GtkEntry* _sender,
                                           GtkEntryIconPosition icon_pos,
                                           GdkEventButton* event,
                                           gpointer self);
#define ONLINE_ACCOUNTS_KEY_QUERY_USERNAME "QueryUserName"
#define ONLINE_ACCOUNTS_KEY_QUERY_URL "QueryUrl"
#define ONLINE_ACCOUNTS_KEY_QUERY_PASSWORD "QueryPassword"
#define ONLINE_ACCOUNTS_KEY_CONFIRM "Confirm"
#define ONLINE_ACCOUNTS_KEY_PASSWORD "Secret"
#define ONLINE_ACCOUNTS_KEY_DISPLAY_NAME "DisplayName"
#define ONLINE_ACCOUNTS_KEY_FORGOT_PASSWORD_URL "ForgotPasswordUrl"
#define ONLINE_ACCOUNTS_KEY_SIGNUP_URL "SignUpURL"
static void __lambda33_ (OnlineAccountsPasswordDialog* self,
                  const gchar* key);
static void ___lambda33__gfunc (gconstpointer data,
                         gpointer self);
static gboolean online_accounts_password_dialog_real_refresh_captcha (OnlineAccountsDialog* base,
                                                               const gchar* uri);
static GHashTable* online_accounts_password_dialog_real_get_reply (OnlineAccountsDialog* base);
GHashTable* online_accounts_dialog_get_reply (OnlineAccountsDialog* self);
static void online_accounts_password_dialog_finalize (GObject * obj);
static GType online_accounts_password_dialog_get_type_once (void);

static inline gpointer
online_accounts_password_dialog_get_instance_private (OnlineAccountsPasswordDialog* self)
{
	return G_STRUCT_MEMBER_P (self, OnlineAccountsPasswordDialog_private_offset);
}

static void
__lambda41_ (OnlineAccountsPasswordDialog* self)
{
	GtkButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	_tmp0_ = self->priv->save_button;
	_tmp1_ = gtk_widget_get_sensitive ((GtkWidget*) _tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		GtkButton* _tmp3_;
		_tmp3_ = self->priv->save_button;
		g_signal_emit_by_name (_tmp3_, "activate");
	}
}

static void
___lambda41__gtk_entry_activate (GtkEntry* _sender,
                                 gpointer self)
{
	__lambda41_ ((OnlineAccountsPasswordDialog*) self);
}

static void
__lambda42_ (OnlineAccountsPasswordDialog* self)
{
	g_signal_emit_by_name ((OnlineAccountsDialog*) self, "finished");
}

static void
___lambda42__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
	__lambda42_ ((OnlineAccountsPasswordDialog*) self);
}

static void
__lambda43_ (OnlineAccountsPasswordDialog* self)
{
	((OnlineAccountsDialog*) self)->error_code = ONLINE_ACCOUNTS_SIGNON_UI_ERROR_CANCELED;
	g_signal_emit_by_name ((OnlineAccountsDialog*) self, "finished");
	gtk_widget_destroy ((GtkWidget*) self);
}

static void
___lambda43__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
	__lambda43_ ((OnlineAccountsPasswordDialog*) self);
}

OnlineAccountsPasswordDialog*
online_accounts_password_dialog_construct (GType object_type,
                                           GHashTable* params)
{
	OnlineAccountsPasswordDialog * self = NULL;
	GtkStyleContext* _tmp0_;
	GtkLabel* _tmp1_;
	GtkLabel* _tmp2_;
	GtkStyleContext* _tmp3_;
	GtkLabel* _tmp4_;
	GtkEntry* _tmp5_;
	GtkEntry* _tmp6_;
	GtkEntry* _tmp7_;
	GtkEntry* _tmp8_;
	GtkEntry* _tmp9_;
	GtkEntry* _tmp10_;
	GtkEntry* _tmp11_;
	GtkEntry* _tmp12_;
	GtkEntry* _tmp13_;
	GtkEntry* _tmp14_;
	GtkEntry* _tmp15_;
	GtkEntry* _tmp16_;
	GtkEntry* _tmp17_;
	GtkEntry* _tmp18_;
	GtkEntry* _tmp19_;
	GtkEntry* _tmp20_;
	GtkEntry* _tmp21_;
	GtkEntry* _tmp22_;
	GtkGrid* entry_grid = NULL;
	GtkGrid* _tmp23_;
	GtkGrid* _tmp24_;
	GtkStyleContext* _tmp25_;
	GtkGrid* _tmp26_;
	GtkLinkButton* _tmp27_;
	GtkEntry* _tmp28_;
	GtkEntry* _tmp29_;
	GtkEntry* _tmp30_;
	GtkEntry* _tmp31_;
	GtkEntry* _tmp32_;
	GtkLabel* _tmp33_;
	GtkLabel* _tmp34_;
	GtkButton* _tmp35_;
	GtkButton* _tmp36_;
	GtkButton* _tmp37_;
	GtkButton* _tmp38_;
	GtkStyleContext* _tmp39_;
	GtkButton* _tmp40_;
	GtkLinkButton* _tmp41_;
	GtkLabel* _tmp42_;
	GtkGrid* _tmp44_;
	GtkGrid* save_box = NULL;
	GtkGrid* _tmp49_;
	GtkGrid* _tmp50_;
	GtkGrid* _tmp51_;
	GtkGrid* _tmp52_;
	GtkButton* _tmp53_;
	GtkGrid* _tmp54_;
	GtkButton* _tmp55_;
	GtkGrid* _tmp56_;
	const gchar* _tmp57_;
	const gchar* _tmp59_;
	GtkLabel* _tmp67_;
	GtkEntry* _tmp68_;
	GtkButton* _tmp69_;
	GtkButton* _tmp70_;
	g_return_val_if_fail (params != NULL, NULL);
	self = (OnlineAccountsPasswordDialog*) online_accounts_dialog_construct (object_type, params);
	gtk_widget_set_halign ((GtkWidget*) self, GTK_ALIGN_CENTER);
	gtk_widget_set_valign ((GtkWidget*) self, GTK_ALIGN_CENTER);
	gtk_grid_set_column_spacing ((GtkGrid*) self, 12);
	gtk_grid_set_row_spacing ((GtkGrid*) self, 6);
	gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_VERTICAL);
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp0_, "login");
	_tmp1_ = (GtkLabel*) gtk_label_new ("");
	g_object_ref_sink (_tmp1_);
	_g_object_unref0 (self->priv->provider_label);
	self->priv->provider_label = _tmp1_;
	_tmp2_ = self->priv->provider_label;
	_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) _tmp2_);
	gtk_style_context_add_class (_tmp3_, "h1");
	_tmp4_ = self->priv->provider_label;
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp4_, 24);
	_tmp5_ = (GtkEntry*) gtk_entry_new ();
	g_object_ref_sink (_tmp5_);
	_g_object_unref0 (self->priv->url_entry);
	self->priv->url_entry = _tmp5_;
	_tmp6_ = self->priv->url_entry;
	gtk_entry_set_placeholder_text (_tmp6_, _ ("URL"));
	_tmp7_ = self->priv->url_entry;
	gtk_entry_set_input_purpose (_tmp7_, GTK_INPUT_PURPOSE_URL);
	_tmp8_ = (GtkEntry*) gtk_entry_new ();
	g_object_ref_sink (_tmp8_);
	_g_object_unref0 (self->priv->username_entry);
	self->priv->username_entry = _tmp8_;
	_tmp9_ = self->priv->username_entry;
	gtk_entry_set_placeholder_text (_tmp9_, _ ("Email"));
	_tmp10_ = self->priv->username_entry;
	g_object_set ((GtkWidget*) _tmp10_, "width-request", 256, NULL);
	_tmp11_ = (GtkEntry*) gtk_entry_new ();
	g_object_ref_sink (_tmp11_);
	_g_object_unref0 (self->priv->password_entry);
	self->priv->password_entry = _tmp11_;
	_tmp12_ = self->priv->password_entry;
	gtk_entry_set_placeholder_text (_tmp12_, _ ("Password"));
	_tmp13_ = self->priv->password_entry;
	gtk_entry_set_visibility (_tmp13_, FALSE);
	_tmp14_ = self->priv->password_entry;
	gtk_entry_set_input_purpose (_tmp14_, GTK_INPUT_PURPOSE_PASSWORD);
	_tmp15_ = (GtkEntry*) gtk_entry_new ();
	g_object_ref_sink (_tmp15_);
	_g_object_unref0 (self->priv->new_password_entry);
	self->priv->new_password_entry = _tmp15_;
	_tmp16_ = self->priv->new_password_entry;
	gtk_entry_set_placeholder_text (_tmp16_, _ ("New Password"));
	_tmp17_ = self->priv->new_password_entry;
	gtk_entry_set_visibility (_tmp17_, FALSE);
	_tmp18_ = self->priv->new_password_entry;
	gtk_entry_set_input_purpose (_tmp18_, GTK_INPUT_PURPOSE_PASSWORD);
	_tmp19_ = (GtkEntry*) gtk_entry_new ();
	g_object_ref_sink (_tmp19_);
	_g_object_unref0 (self->priv->confirm_password_entry);
	self->priv->confirm_password_entry = _tmp19_;
	_tmp20_ = self->priv->confirm_password_entry;
	gtk_entry_set_placeholder_text (_tmp20_, _ ("Confirm Password"));
	_tmp21_ = self->priv->confirm_password_entry;
	gtk_entry_set_visibility (_tmp21_, FALSE);
	_tmp22_ = self->priv->confirm_password_entry;
	gtk_entry_set_input_purpose (_tmp22_, GTK_INPUT_PURPOSE_PASSWORD);
	_tmp23_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp23_);
	entry_grid = _tmp23_;
	_tmp24_ = entry_grid;
	_tmp25_ = gtk_widget_get_style_context ((GtkWidget*) _tmp24_);
	gtk_style_context_add_class (_tmp25_, GTK_STYLE_CLASS_LINKED);
	_tmp26_ = entry_grid;
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp26_, GTK_ORIENTATION_VERTICAL);
	_tmp27_ = (GtkLinkButton*) gtk_link_button_new_with_label ("", _ ("Forgot password…"));
	g_object_ref_sink (_tmp27_);
	_g_object_unref0 (self->priv->forgot_button);
	self->priv->forgot_button = _tmp27_;
	_tmp28_ = (GtkEntry*) gtk_entry_new ();
	g_object_ref_sink (_tmp28_);
	_g_object_unref0 (self->priv->captcha_entry);
	self->priv->captcha_entry = _tmp28_;
	_tmp29_ = self->priv->captcha_entry;
	g_object_set (_tmp29_, "secondary-icon-name", "view-refresh", NULL);
	_tmp30_ = self->priv->captcha_entry;
	g_object_set (_tmp30_, "secondary-icon-activatable", TRUE, NULL);
	_tmp31_ = self->priv->captcha_entry;
	g_object_set (_tmp31_, "secondary-icon-tooltip-text", _ ("Refresh Captcha"), NULL);
	_tmp32_ = self->priv->captcha_entry;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp32_, _ ("Enter above text here"));
	_tmp33_ = (GtkLabel*) gtk_label_new ("");
	g_object_ref_sink (_tmp33_);
	_g_object_unref0 (self->priv->message_label);
	self->priv->message_label = _tmp33_;
	_tmp34_ = self->priv->message_label;
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp34_, TRUE);
	_tmp35_ = (GtkButton*) gtk_button_new_with_label (_ ("Cancel"));
	g_object_ref_sink (_tmp35_);
	_g_object_unref0 (self->priv->cancel_button);
	self->priv->cancel_button = _tmp35_;
	_tmp36_ = self->priv->cancel_button;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp36_, TRUE);
	_tmp37_ = (GtkButton*) gtk_button_new_with_label (_ ("Log In"));
	g_object_ref_sink (_tmp37_);
	_g_object_unref0 (self->priv->save_button);
	self->priv->save_button = _tmp37_;
	_tmp38_ = self->priv->save_button;
	_tmp39_ = gtk_widget_get_style_context ((GtkWidget*) _tmp38_);
	gtk_style_context_add_class (_tmp39_, GTK_STYLE_CLASS_SUGGESTED_ACTION);
	_tmp40_ = self->priv->save_button;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp40_, TRUE);
	_tmp41_ = (GtkLinkButton*) gtk_link_button_new_with_label ("", _ ("Don't have an account? Sign Up"));
	g_object_ref_sink (_tmp41_);
	_g_object_unref0 (self->priv->signup_button);
	self->priv->signup_button = _tmp41_;
	online_accounts_dialog_set_parameters ((OnlineAccountsDialog*) self, params);
	_tmp42_ = self->priv->provider_label;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp42_);
	if (self->priv->query_url) {
		GtkEntry* _tmp43_;
		_tmp43_ = self->priv->url_entry;
		gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp43_);
	}
	_tmp44_ = entry_grid;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp44_);
	if (self->priv->query_username) {
		GtkGrid* _tmp45_;
		GtkEntry* _tmp46_;
		_tmp45_ = entry_grid;
		_tmp46_ = self->priv->username_entry;
		gtk_container_add ((GtkContainer*) _tmp45_, (GtkWidget*) _tmp46_);
	}
	if (self->priv->query_password) {
		GtkGrid* _tmp47_;
		GtkEntry* _tmp48_;
		_tmp47_ = entry_grid;
		_tmp48_ = self->priv->password_entry;
		gtk_container_add ((GtkContainer*) _tmp47_, (GtkWidget*) _tmp48_);
	}
	_tmp49_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp49_);
	save_box = _tmp49_;
	_tmp50_ = save_box;
	gtk_widget_set_margin_top ((GtkWidget*) _tmp50_, 12);
	_tmp51_ = save_box;
	gtk_grid_set_column_spacing (_tmp51_, 6);
	_tmp52_ = save_box;
	_tmp53_ = self->priv->cancel_button;
	gtk_container_add ((GtkContainer*) _tmp52_, (GtkWidget*) _tmp53_);
	_tmp54_ = save_box;
	_tmp55_ = self->priv->save_button;
	gtk_container_add ((GtkContainer*) _tmp54_, (GtkWidget*) _tmp55_);
	_tmp56_ = save_box;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp56_);
	_tmp57_ = self->priv->forgot_password_url;
	if (_tmp57_ != NULL) {
		GtkLinkButton* _tmp58_;
		_tmp58_ = self->priv->forgot_button;
		gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp58_);
	}
	_tmp59_ = self->priv->signup_url;
	if (_tmp59_ != NULL) {
		GtkLinkButton* _tmp60_;
		_tmp60_ = self->priv->signup_button;
		gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp60_);
	}
	if (self->priv->query_confirm) {
		GtkGrid* _tmp61_;
		GtkEntry* _tmp62_;
		GtkGrid* _tmp63_;
		GtkEntry* _tmp64_;
		_tmp61_ = entry_grid;
		_tmp62_ = self->priv->new_password_entry;
		gtk_container_add ((GtkContainer*) _tmp61_, (GtkWidget*) _tmp62_);
		_tmp63_ = entry_grid;
		_tmp64_ = self->priv->confirm_password_entry;
		gtk_container_add ((GtkContainer*) _tmp63_, (GtkWidget*) _tmp64_);
	}
	if (self->priv->query_captcha) {
		GtkImage* _tmp65_;
		GtkEntry* _tmp66_;
		_tmp65_ = self->priv->captcha_image;
		gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp65_);
		_tmp66_ = self->priv->captcha_entry;
		gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp66_);
	}
	_tmp67_ = self->priv->message_label;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp67_);
	_tmp68_ = self->priv->password_entry;
	g_signal_connect_object (_tmp68_, "activate", (GCallback) ___lambda41__gtk_entry_activate, self, 0);
	_tmp69_ = self->priv->save_button;
	g_signal_connect_object (_tmp69_, "clicked", (GCallback) ___lambda42__gtk_button_clicked, self, 0);
	_tmp70_ = self->priv->cancel_button;
	g_signal_connect_object (_tmp70_, "clicked", (GCallback) ___lambda43__gtk_button_clicked, self, 0);
	gtk_widget_show_all ((GtkWidget*) self);
	_g_object_unref0 (save_box);
	_g_object_unref0 (entry_grid);
	return self;
}

OnlineAccountsPasswordDialog*
online_accounts_password_dialog_new (GHashTable* params)
{
	return online_accounts_password_dialog_construct (ONLINE_ACCOUNTS_TYPE_PASSWORD_DIALOG, params);
}

static gboolean
___lambda34_ (OnlineAccountsPasswordDialog* self)
{
	gboolean result = FALSE;
	g_warning ("PasswordDialog.vala:195: forgot password");
	((OnlineAccountsDialog*) self)->error_code = ONLINE_ACCOUNTS_SIGNON_UI_ERROR_FORGOT_PASSWORD;
	g_signal_emit_by_name ((OnlineAccountsDialog*) self, "finished");
	result = FALSE;
	return result;
}

static gboolean
____lambda34__gtk_link_button_activate_link (GtkLinkButton* _sender,
                                             gpointer self)
{
	gboolean result;
	result = ___lambda34_ ((OnlineAccountsPasswordDialog*) self);
	return result;
}

static void
___lambda35_ (OnlineAccountsPasswordDialog* self)
{
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	_tmp0_ = self->priv->username_entry;
	_tmp1_ = gtk_entry_get_text (_tmp0_);
	_tmp2_ = _tmp1_;
	self->priv->is_username_valid = g_utf8_strlen (_tmp2_, (gssize) -1) > 0;
	online_accounts_password_dialog_reset_ok (self);
}

static void
____lambda35__gtk_editable_changed (GtkEditable* _sender,
                                    gpointer self)
{
	___lambda35_ ((OnlineAccountsPasswordDialog*) self);
}

static void
___lambda36_ (OnlineAccountsPasswordDialog* self)
{
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	_tmp0_ = self->priv->password_entry;
	_tmp1_ = gtk_entry_get_text (_tmp0_);
	_tmp2_ = _tmp1_;
	self->priv->is_password_valid = g_utf8_strlen (_tmp2_, (gssize) -1) > 0;
	if (self->priv->query_confirm) {
		_tmp4_ = self->priv->is_password_valid;
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		const gchar* _tmp5_;
		_tmp5_ = self->priv->old_password;
		_tmp3_ = _tmp5_ != NULL;
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		GCompareFunc _tmp6_;
		const gchar* _tmp7_;
		GtkEntry* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		_tmp6_ = ((GCompareFunc) g_strcmp0);
		_tmp7_ = self->priv->old_password;
		_tmp8_ = self->priv->password_entry;
		_tmp9_ = gtk_entry_get_text (_tmp8_);
		_tmp10_ = _tmp9_;
		self->priv->is_password_valid = _tmp6_ (_tmp7_, _tmp10_) == 0;
	}
	online_accounts_password_dialog_reset_ok (self);
}

static void
____lambda36__gtk_editable_changed (GtkEditable* _sender,
                                    gpointer self)
{
	___lambda36_ ((OnlineAccountsPasswordDialog*) self);
}

static void
___lambda37_ (OnlineAccountsPasswordDialog* self)
{
	gchar* new_password = NULL;
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* confirm = NULL;
	GtkEntry* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp9_ = FALSE;
	const gchar* _tmp10_;
	_tmp0_ = self->priv->new_password_entry;
	_tmp1_ = gtk_entry_get_text (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strdup (_tmp2_);
	new_password = _tmp3_;
	_tmp4_ = self->priv->confirm_password_entry;
	_tmp5_ = gtk_entry_get_text (_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = g_strdup (_tmp6_);
	confirm = _tmp7_;
	_tmp10_ = new_password;
	if (g_utf8_strlen (_tmp10_, (gssize) -1) > 0) {
		const gchar* _tmp11_;
		_tmp11_ = confirm;
		_tmp9_ = g_utf8_strlen (_tmp11_, (gssize) -1) > 0;
	} else {
		_tmp9_ = FALSE;
	}
	if (_tmp9_) {
		GCompareFunc _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		_tmp12_ = ((GCompareFunc) g_strcmp0);
		_tmp13_ = new_password;
		_tmp14_ = confirm;
		_tmp8_ = _tmp12_ (_tmp13_, _tmp14_) == 0;
	} else {
		_tmp8_ = FALSE;
	}
	self->priv->is_new_password_valid = _tmp8_;
	online_accounts_password_dialog_reset_ok (self);
	_g_free0 (confirm);
	_g_free0 (new_password);
}

static void
____lambda37__gtk_editable_changed (GtkEditable* _sender,
                                    gpointer self)
{
	___lambda37_ ((OnlineAccountsPasswordDialog*) self);
}

static void
___lambda38_ (OnlineAccountsPasswordDialog* self)
{
	gchar* new_password = NULL;
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* confirm = NULL;
	GtkEntry* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp9_ = FALSE;
	const gchar* _tmp10_;
	_tmp0_ = self->priv->new_password_entry;
	_tmp1_ = gtk_entry_get_text (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strdup (_tmp2_);
	new_password = _tmp3_;
	_tmp4_ = self->priv->confirm_password_entry;
	_tmp5_ = gtk_entry_get_text (_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = g_strdup (_tmp6_);
	confirm = _tmp7_;
	_tmp10_ = new_password;
	if (g_utf8_strlen (_tmp10_, (gssize) -1) > 0) {
		const gchar* _tmp11_;
		_tmp11_ = confirm;
		_tmp9_ = g_utf8_strlen (_tmp11_, (gssize) -1) > 0;
	} else {
		_tmp9_ = FALSE;
	}
	if (_tmp9_) {
		GCompareFunc _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		_tmp12_ = ((GCompareFunc) g_strcmp0);
		_tmp13_ = new_password;
		_tmp14_ = confirm;
		_tmp8_ = _tmp12_ (_tmp13_, _tmp14_) == 0;
	} else {
		_tmp8_ = FALSE;
	}
	self->priv->is_new_password_valid = _tmp8_;
	online_accounts_password_dialog_reset_ok (self);
	_g_free0 (confirm);
	_g_free0 (new_password);
}

static void
____lambda38__gtk_editable_changed (GtkEditable* _sender,
                                    gpointer self)
{
	___lambda38_ ((OnlineAccountsPasswordDialog*) self);
}

static void
___lambda39_ (OnlineAccountsPasswordDialog* self)
{
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	_tmp0_ = self->priv->captcha_entry;
	_tmp1_ = gtk_entry_get_text (_tmp0_);
	_tmp2_ = _tmp1_;
	self->priv->is_captcha_valid = g_utf8_strlen (_tmp2_, (gssize) -1) > 0;
	online_accounts_password_dialog_reset_ok (self);
}

static void
____lambda39__gtk_editable_changed (GtkEditable* _sender,
                                    gpointer self)
{
	___lambda39_ ((OnlineAccountsPasswordDialog*) self);
}

static void
___lambda40_ (OnlineAccountsPasswordDialog* self,
              GtkEntryIconPosition pos,
              GdkEventButton* event)
{
	g_return_if_fail (event != NULL);
	if (pos == GTK_ENTRY_ICON_SECONDARY) {
		g_signal_emit (self, online_accounts_password_dialog_signals[ONLINE_ACCOUNTS_PASSWORD_DIALOG_REFRESH_CAPTCHA_NEEDED_SIGNAL], 0);
	}
}

static void
____lambda40__gtk_entry_icon_release (GtkEntry* _sender,
                                      GtkEntryIconPosition icon_pos,
                                      GdkEventButton* event,
                                      gpointer self)
{
	___lambda40_ ((OnlineAccountsPasswordDialog*) self, icon_pos, event);
}

static gboolean
online_accounts_password_dialog_real_set_parameters (OnlineAccountsDialog* base,
                                                     GHashTable* params)
{
	OnlineAccountsPasswordDialog * self;
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
	GVariant* temp_string = NULL;
	gconstpointer _tmp2_;
	GtkEntry* _tmp3_;
	GVariant* _tmp4_;
	const gchar* _tmp9_;
	const gchar* _tmp13_;
	gconstpointer _tmp16_;
	GVariant* _tmp17_;
	gconstpointer _tmp23_;
	GVariant* _tmp24_;
	gboolean result = FALSE;
	self = (OnlineAccountsPasswordDialog*) base;
	g_return_val_if_fail (params != NULL, FALSE);
	if (ONLINE_ACCOUNTS_DIALOG_CLASS (online_accounts_password_dialog_parent_class)->set_parameters (G_TYPE_CHECK_INSTANCE_CAST (self, ONLINE_ACCOUNTS_TYPE_DIALOG, OnlineAccountsDialog), params) == FALSE) {
		result = FALSE;
		return result;
	}
	if (online_accounts_password_dialog_validate_params (self, params) == FALSE) {
		result = FALSE;
		return result;
	}
	_tmp0_ = self->priv->provider_label;
	_tmp1_ = self->priv->display_name;
	gtk_label_set_label (_tmp0_, _tmp1_);
	_tmp2_ = g_hash_table_lookup (params, ONLINE_ACCOUNTS_KEY_USERNAME);
	temp_string = (GVariant*) _tmp2_;
	_tmp3_ = self->priv->username_entry;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp3_, self->priv->query_username);
	_tmp4_ = temp_string;
	if (_tmp4_ != NULL) {
		const gchar* _tmp5_ = NULL;
		GVariant* _tmp6_;
		const gchar* _tmp7_;
		GtkEntry* _tmp8_;
		_tmp6_ = temp_string;
		_tmp7_ = g_variant_get_string (_tmp6_, NULL);
		_tmp5_ = _tmp7_;
		if (_tmp5_ == NULL) {
			_tmp5_ = "";
		}
		_tmp8_ = self->priv->username_entry;
		gtk_entry_set_text (_tmp8_, _tmp5_);
	}
	_tmp9_ = self->priv->forgot_password_url;
	if (_tmp9_ != NULL) {
		GtkLinkButton* _tmp10_;
		const gchar* _tmp11_;
		GtkLinkButton* _tmp12_;
		_tmp10_ = self->priv->forgot_button;
		_tmp11_ = self->priv->forgot_password_url;
		gtk_link_button_set_uri (_tmp10_, _tmp11_);
		_tmp12_ = self->priv->forgot_button;
		g_signal_connect_object (_tmp12_, "activate-link", (GCallback) ____lambda34__gtk_link_button_activate_link, self, 0);
	}
	_tmp13_ = self->priv->signup_url;
	if (_tmp13_ != NULL) {
		GtkLinkButton* _tmp14_;
		const gchar* _tmp15_;
		_tmp14_ = self->priv->signup_button;
		_tmp15_ = self->priv->signup_url;
		gtk_link_button_set_uri (_tmp14_, _tmp15_);
	}
	_tmp16_ = g_hash_table_lookup (params, ONLINE_ACCOUNTS_KEY_MESSAGE);
	temp_string = (GVariant*) _tmp16_;
	_tmp17_ = temp_string;
	if (_tmp17_ != NULL) {
		GtkLabel* _tmp18_;
		GVariant* _tmp19_;
		const gchar* _tmp20_;
		GtkLabel* _tmp21_;
		_tmp18_ = self->priv->message_label;
		_tmp19_ = temp_string;
		_tmp20_ = g_variant_get_string (_tmp19_, NULL);
		gtk_label_set_label (_tmp18_, _tmp20_);
		_tmp21_ = self->priv->message_label;
		gtk_widget_show ((GtkWidget*) _tmp21_);
	} else {
		GtkLabel* _tmp22_;
		_tmp22_ = self->priv->message_label;
		gtk_widget_hide ((GtkWidget*) _tmp22_);
	}
	_tmp23_ = g_hash_table_lookup (params, ONLINE_ACCOUNTS_KEY_CAPTCHA_URL);
	temp_string = (GVariant*) _tmp23_;
	_tmp24_ = temp_string;
	if (_tmp24_ != NULL) {
		GVariant* _tmp25_;
		const gchar* _tmp26_;
		_tmp25_ = temp_string;
		_tmp26_ = g_variant_get_string (_tmp25_, NULL);
		self->priv->query_captcha = online_accounts_dialog_refresh_captcha ((OnlineAccountsDialog*) self, _tmp26_);
	}
	if (self->priv->query_username) {
		GtkEntry* _tmp27_;
		GtkEntry* _tmp28_;
		_tmp27_ = self->priv->username_entry;
		g_signal_connect_object ((GtkEditable*) _tmp27_, "changed", (GCallback) ____lambda35__gtk_editable_changed, self, 0);
		_tmp28_ = self->priv->password_entry;
		g_signal_connect_object ((GtkEditable*) _tmp28_, "changed", (GCallback) ____lambda36__gtk_editable_changed, self, 0);
	}
	if (self->priv->query_confirm) {
		GtkEntry* _tmp29_;
		GtkEntry* _tmp30_;
		_tmp29_ = self->priv->new_password_entry;
		g_signal_connect_object ((GtkEditable*) _tmp29_, "changed", (GCallback) ____lambda37__gtk_editable_changed, self, 0);
		_tmp30_ = self->priv->confirm_password_entry;
		g_signal_connect_object ((GtkEditable*) _tmp30_, "changed", (GCallback) ____lambda38__gtk_editable_changed, self, 0);
	}
	if (self->priv->query_captcha) {
		GtkEntry* _tmp31_;
		GtkEntry* _tmp32_;
		_tmp31_ = self->priv->captcha_entry;
		g_signal_connect_object ((GtkEditable*) _tmp31_, "changed", (GCallback) ____lambda39__gtk_editable_changed, self, 0);
		_tmp32_ = self->priv->captcha_entry;
		g_signal_connect_object (_tmp32_, "icon-release", (GCallback) ____lambda40__gtk_entry_icon_release, self, 0);
	}
	online_accounts_password_dialog_reset_ok (self);
	result = TRUE;
	return result;
}

static void
__lambda33_ (OnlineAccountsPasswordDialog* self,
             const gchar* key)
{
	g_return_if_fail (key != NULL);
	g_warning ("PasswordDialog.vala:318: %s", key);
}

static void
___lambda33__gfunc (gconstpointer data,
                    gpointer self)
{
	__lambda33_ ((OnlineAccountsPasswordDialog*) self, (const gchar*) data);
}

static gboolean
online_accounts_password_dialog_validate_params (OnlineAccountsPasswordDialog* self,
                                                 GHashTable* params)
{
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp9_ = FALSE;
	GList* _tmp21_;
	GList* _tmp22_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (params != NULL, FALSE);
	if (g_hash_table_contains (params, ONLINE_ACCOUNTS_KEY_QUERY_USERNAME)) {
		gconstpointer _tmp0_;
		_tmp0_ = g_hash_table_lookup (params, ONLINE_ACCOUNTS_KEY_QUERY_USERNAME);
		self->priv->query_username = g_variant_get_boolean ((GVariant*) _tmp0_);
	}
	if (g_hash_table_contains (params, ONLINE_ACCOUNTS_KEY_QUERY_URL)) {
		gconstpointer _tmp1_;
		_tmp1_ = g_hash_table_lookup (params, ONLINE_ACCOUNTS_KEY_QUERY_URL);
		self->priv->query_url = g_variant_get_boolean ((GVariant*) _tmp1_);
	}
	if (g_hash_table_contains (params, ONLINE_ACCOUNTS_KEY_QUERY_PASSWORD)) {
		gconstpointer _tmp2_;
		_tmp2_ = g_hash_table_lookup (params, ONLINE_ACCOUNTS_KEY_QUERY_PASSWORD);
		self->priv->query_password = g_variant_get_boolean ((GVariant*) _tmp2_);
	}
	if (g_hash_table_contains (params, ONLINE_ACCOUNTS_KEY_CONFIRM)) {
		gconstpointer _tmp3_;
		_tmp3_ = g_hash_table_lookup (params, ONLINE_ACCOUNTS_KEY_CONFIRM);
		self->priv->query_confirm = g_variant_get_boolean ((GVariant*) _tmp3_);
	}
	if (self->priv->query_username == FALSE) {
		_tmp5_ = self->priv->query_password == FALSE;
	} else {
		_tmp5_ = FALSE;
	}
	if (_tmp5_) {
		_tmp4_ = self->priv->query_confirm == FALSE;
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		g_warning ("PasswordDialog.vala:290: No Valid Query found");
		result = FALSE;
		return result;
	}
	if (g_hash_table_contains (params, ONLINE_ACCOUNTS_KEY_PASSWORD)) {
		gconstpointer _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		_tmp6_ = g_hash_table_lookup (params, ONLINE_ACCOUNTS_KEY_PASSWORD);
		_tmp7_ = g_variant_get_string ((GVariant*) _tmp6_, NULL);
		_tmp8_ = g_strdup (_tmp7_);
		_g_free0 (self->priv->old_password);
		self->priv->old_password = _tmp8_;
	}
	if (self->priv->query_confirm) {
		const gchar* _tmp10_;
		_tmp10_ = self->priv->old_password;
		_tmp9_ = _tmp10_ == NULL;
	} else {
		_tmp9_ = FALSE;
	}
	if (_tmp9_) {
		g_warning ("PasswordDialog.vala:299: Wrong params for confirm query");
		result = FALSE;
		return result;
	}
	if (g_hash_table_contains (params, ONLINE_ACCOUNTS_KEY_DISPLAY_NAME)) {
		gconstpointer _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		_tmp11_ = g_hash_table_lookup (params, ONLINE_ACCOUNTS_KEY_DISPLAY_NAME);
		_tmp12_ = g_variant_get_string ((GVariant*) _tmp11_, NULL);
		_tmp13_ = g_strdup (_tmp12_);
		_g_free0 (self->priv->display_name);
		self->priv->display_name = _tmp13_;
	} else {
		gchar* _tmp14_;
		_tmp14_ = g_strdup (_ ("Other Account"));
		_g_free0 (self->priv->display_name);
		self->priv->display_name = _tmp14_;
	}
	if (g_hash_table_contains (params, ONLINE_ACCOUNTS_KEY_FORGOT_PASSWORD_URL)) {
		gconstpointer _tmp15_;
		const gchar* _tmp16_;
		gchar* _tmp17_;
		_tmp15_ = g_hash_table_lookup (params, ONLINE_ACCOUNTS_KEY_FORGOT_PASSWORD_URL);
		_tmp16_ = g_variant_get_string ((GVariant*) _tmp15_, NULL);
		_tmp17_ = g_strdup (_tmp16_);
		_g_free0 (self->priv->forgot_password_url);
		self->priv->forgot_password_url = _tmp17_;
	}
	if (g_hash_table_contains (params, ONLINE_ACCOUNTS_KEY_SIGNUP_URL)) {
		gconstpointer _tmp18_;
		const gchar* _tmp19_;
		gchar* _tmp20_;
		_tmp18_ = g_hash_table_lookup (params, ONLINE_ACCOUNTS_KEY_SIGNUP_URL);
		_tmp19_ = g_variant_get_string ((GVariant*) _tmp18_, NULL);
		_tmp20_ = g_strdup (_tmp19_);
		_g_free0 (self->priv->signup_url);
		self->priv->signup_url = _tmp20_;
	}
	_tmp21_ = g_hash_table_get_keys (params);
	_tmp22_ = _tmp21_;
	g_list_foreach (_tmp22_, ___lambda33__gfunc, self);
	(_tmp22_ == NULL) ? NULL : (_tmp22_ = (g_list_free (_tmp22_), NULL));
	result = TRUE;
	return result;
}

static gboolean
online_accounts_password_dialog_real_refresh_captcha (OnlineAccountsDialog* base,
                                                      const gchar* uri)
{
	OnlineAccountsPasswordDialog * self;
	gchar* filename = NULL;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	GtkImage* _tmp8_;
	const gchar* _tmp9_;
	gchar* used_filename = NULL;
	GtkImage* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	const gchar* _tmp13_;
	gboolean is_valid = FALSE;
	GCompareFunc _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
	self = (OnlineAccountsPasswordDialog*) base;
	g_return_val_if_fail (uri != NULL, FALSE);
	if (uri == NULL) {
		g_warning ("PasswordDialog.vala:326: invalid captcha value : %s", uri);
		((OnlineAccountsDialog*) self)->error_code = ONLINE_ACCOUNTS_SIGNON_UI_ERROR_BAD_CAPTCHA_URL;
		result = FALSE;
		return result;
	}
	filename = NULL;
	{
		gchar* _tmp0_ = NULL;
		gchar* _tmp1_;
		gchar* _tmp2_;
		_tmp1_ = g_filename_from_uri (uri, NULL, &_inner_error0_);
		_tmp0_ = _tmp1_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp2_ = _tmp0_;
		_tmp0_ = NULL;
		_g_free0 (filename);
		filename = _tmp2_;
		_g_free0 (_tmp0_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp3_ = e;
		_tmp4_ = _tmp3_->message;
		g_critical ("PasswordDialog.vala:335: %s", _tmp4_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gboolean _tmp5_ = FALSE;
		_g_free0 (filename);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp5_;
	}
	_tmp6_ = filename;
	if (_tmp6_ == NULL) {
		g_warning ("PasswordDialog.vala:339: invalid captcha value : %s", uri);
		((OnlineAccountsDialog*) self)->error_code = ONLINE_ACCOUNTS_SIGNON_UI_ERROR_BAD_CAPTCHA_URL;
		result = FALSE;
		_g_free0 (filename);
		return result;
	}
	_tmp7_ = filename;
	g_debug ("PasswordDialog.vala:344: setting captcha : %s", _tmp7_);
	_tmp8_ = self->priv->captcha_image;
	_tmp9_ = filename;
	gtk_image_set_from_file (_tmp8_, _tmp9_);
	_tmp10_ = self->priv->captcha_image;
	g_object_get (_tmp10_, "file", &_tmp11_, NULL);
	_tmp12_ = _tmp11_;
	used_filename = _tmp12_;
	_tmp13_ = used_filename;
	g_debug ("PasswordDialog.vala:347: Used file : %s", _tmp13_);
	_tmp14_ = ((GCompareFunc) g_strcmp0);
	_tmp15_ = filename;
	_tmp16_ = used_filename;
	is_valid = _tmp14_ (_tmp15_, _tmp16_) == 0;
	if (is_valid == FALSE) {
		((OnlineAccountsDialog*) self)->error_code = ONLINE_ACCOUNTS_SIGNON_UI_ERROR_BAD_CAPTCHA;
		result = FALSE;
		_g_free0 (used_filename);
		_g_free0 (filename);
		return result;
	}
	self->priv->query_captcha = TRUE;
	result = TRUE;
	_g_free0 (used_filename);
	_g_free0 (filename);
	return result;
}

static GHashTable*
online_accounts_password_dialog_real_get_reply (OnlineAccountsDialog* base)
{
	OnlineAccountsPasswordDialog * self;
	GHashTable* table = NULL;
	GHashTable* _tmp0_;
	gchar* _tmp1_;
	GtkEntry* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	GVariant* _tmp5_;
	gchar* _tmp6_;
	GtkEntry* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	GVariant* _tmp10_;
	GHashTable* result = NULL;
	self = (OnlineAccountsPasswordDialog*) base;
	_tmp0_ = ONLINE_ACCOUNTS_DIALOG_CLASS (online_accounts_password_dialog_parent_class)->get_reply (G_TYPE_CHECK_INSTANCE_CAST (self, ONLINE_ACCOUNTS_TYPE_DIALOG, OnlineAccountsDialog));
	table = _tmp0_;
	_tmp1_ = g_strdup (ONLINE_ACCOUNTS_KEY_USERNAME);
	_tmp2_ = self->priv->username_entry;
	_tmp3_ = gtk_entry_get_text (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_variant_new_string (_tmp4_);
	g_variant_ref_sink (_tmp5_);
	g_hash_table_insert (table, _tmp1_, _tmp5_);
	_tmp6_ = g_strdup (ONLINE_ACCOUNTS_KEY_PASSWORD);
	_tmp7_ = self->priv->password_entry;
	_tmp8_ = gtk_entry_get_text (_tmp7_);
	_tmp9_ = _tmp8_;
	_tmp10_ = g_variant_new_string (_tmp9_);
	g_variant_ref_sink (_tmp10_);
	g_hash_table_insert (table, _tmp6_, _tmp10_);
	result = table;
	return result;
}

static void
online_accounts_password_dialog_reset_ok (OnlineAccountsPasswordDialog* self)
{
	gboolean state = FALSE;
	GtkButton* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	g_return_if_fail (self != NULL);
	state = FALSE;
	if (self->priv->query_username) {
		gboolean _tmp0_ = FALSE;
		if (self->priv->is_username_valid) {
			_tmp0_ = self->priv->is_password_valid;
		} else {
			_tmp0_ = FALSE;
		}
		state = _tmp0_;
	} else {
		if (self->priv->query_password) {
			state = self->priv->is_password_valid;
		} else {
			if (self->priv->query_confirm) {
				gboolean _tmp1_ = FALSE;
				if (self->priv->is_password_valid) {
					_tmp1_ = self->priv->is_new_password_valid;
				} else {
					_tmp1_ = FALSE;
				}
				state = _tmp1_;
			}
		}
	}
	if (self->priv->query_captcha) {
		gboolean _tmp2_ = FALSE;
		if (state) {
			_tmp2_ = self->priv->is_captcha_valid;
		} else {
			_tmp2_ = FALSE;
		}
		state = _tmp2_;
	}
	_tmp3_ = self->priv->save_button;
	_tmp4_ = gtk_widget_get_sensitive ((GtkWidget*) _tmp3_);
	_tmp5_ = _tmp4_;
	if (_tmp5_ != state) {
		GtkButton* _tmp6_;
		_tmp6_ = self->priv->save_button;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp6_, state);
	}
}

static void
online_accounts_password_dialog_class_init (OnlineAccountsPasswordDialogClass * klass,
                                            gpointer klass_data)
{
	online_accounts_password_dialog_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &OnlineAccountsPasswordDialog_private_offset);
	((OnlineAccountsDialogClass *) klass)->set_parameters = (gboolean (*) (OnlineAccountsDialog*, GHashTable*)) online_accounts_password_dialog_real_set_parameters;
	((OnlineAccountsDialogClass *) klass)->refresh_captcha = (gboolean (*) (OnlineAccountsDialog*, const gchar*)) online_accounts_password_dialog_real_refresh_captcha;
	((OnlineAccountsDialogClass *) klass)->get_reply = (GHashTable* (*) (OnlineAccountsDialog*)) online_accounts_password_dialog_real_get_reply;
	G_OBJECT_CLASS (klass)->finalize = online_accounts_password_dialog_finalize;
	online_accounts_password_dialog_signals[ONLINE_ACCOUNTS_PASSWORD_DIALOG_REFRESH_CAPTCHA_NEEDED_SIGNAL] = g_signal_new ("refresh-captcha-needed", ONLINE_ACCOUNTS_TYPE_PASSWORD_DIALOG, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
online_accounts_password_dialog_instance_init (OnlineAccountsPasswordDialog * self,
                                               gpointer klass)
{
	self->priv = online_accounts_password_dialog_get_instance_private (self);
	self->priv->query_url = FALSE;
	self->priv->query_username = FALSE;
	self->priv->query_password = FALSE;
	self->priv->query_confirm = FALSE;
	self->priv->query_captcha = FALSE;
	self->priv->is_username_valid = FALSE;
	self->priv->is_password_valid = FALSE;
	self->priv->is_new_password_valid = FALSE;
	self->priv->is_captcha_valid = FALSE;
}

static void
online_accounts_password_dialog_finalize (GObject * obj)
{
	OnlineAccountsPasswordDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, ONLINE_ACCOUNTS_TYPE_PASSWORD_DIALOG, OnlineAccountsPasswordDialog);
	_g_object_unref0 (self->priv->url_entry);
	_g_object_unref0 (self->priv->username_entry);
	_g_object_unref0 (self->priv->password_entry);
	_g_object_unref0 (self->priv->new_password_entry);
	_g_object_unref0 (self->priv->confirm_password_entry);
	_g_object_unref0 (self->priv->captcha_entry);
	_g_object_unref0 (self->priv->cancel_button);
	_g_object_unref0 (self->priv->save_button);
	_g_object_unref0 (self->priv->forgot_button);
	_g_object_unref0 (self->priv->signup_button);
	_g_object_unref0 (self->priv->captcha_image);
	_g_object_unref0 (self->priv->message_label);
	_g_object_unref0 (self->priv->provider_label);
	_g_free0 (self->priv->display_name);
	_g_free0 (self->priv->old_password);
	_g_free0 (self->priv->forgot_password_url);
	_g_free0 (self->priv->signup_url);
	G_OBJECT_CLASS (online_accounts_password_dialog_parent_class)->finalize (obj);
}

static GType
online_accounts_password_dialog_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (OnlineAccountsPasswordDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) online_accounts_password_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (OnlineAccountsPasswordDialog), 0, (GInstanceInitFunc) online_accounts_password_dialog_instance_init, NULL };
	GType online_accounts_password_dialog_type_id;
	online_accounts_password_dialog_type_id = g_type_register_static (ONLINE_ACCOUNTS_TYPE_DIALOG, "OnlineAccountsPasswordDialog", &g_define_type_info, 0);
	OnlineAccountsPasswordDialog_private_offset = g_type_add_instance_private (online_accounts_password_dialog_type_id, sizeof (OnlineAccountsPasswordDialogPrivate));
	return online_accounts_password_dialog_type_id;
}

GType
online_accounts_password_dialog_get_type (void)
{
	static volatile gsize online_accounts_password_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&online_accounts_password_dialog_type_id__volatile)) {
		GType online_accounts_password_dialog_type_id;
		online_accounts_password_dialog_type_id = online_accounts_password_dialog_get_type_once ();
		g_once_init_leave (&online_accounts_password_dialog_type_id__volatile, online_accounts_password_dialog_type_id);
	}
	return online_accounts_password_dialog_type_id__volatile;
}

