/* WebDialog.c generated by valac 0.48.8, the Vala compiler
 * generated from WebDialog.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2013-2015 Pantheon Developers (https://launchpad.net/switchboard-plug-onlineaccounts)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <webkit2/webkit2.h>
#include <glib/gi18n-lib.h>

#define ONLINE_ACCOUNTS_TYPE_DIALOG (online_accounts_dialog_get_type ())
#define ONLINE_ACCOUNTS_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ONLINE_ACCOUNTS_TYPE_DIALOG, OnlineAccountsDialog))
#define ONLINE_ACCOUNTS_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ONLINE_ACCOUNTS_TYPE_DIALOG, OnlineAccountsDialogClass))
#define ONLINE_ACCOUNTS_IS_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ONLINE_ACCOUNTS_TYPE_DIALOG))
#define ONLINE_ACCOUNTS_IS_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ONLINE_ACCOUNTS_TYPE_DIALOG))
#define ONLINE_ACCOUNTS_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ONLINE_ACCOUNTS_TYPE_DIALOG, OnlineAccountsDialogClass))

typedef struct _OnlineAccountsDialog OnlineAccountsDialog;
typedef struct _OnlineAccountsDialogClass OnlineAccountsDialogClass;
typedef struct _OnlineAccountsDialogPrivate OnlineAccountsDialogPrivate;
typedef enum  {
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_NONE,
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_GENERAL,
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_NO_SIGNONUI,
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_BAD_PARAMETERS,
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_CANCELED,
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_NOT_AVAILABLE,
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_BAD_URL,
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_BAD_CAPTCHA,
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_BAD_CAPTCHA_URL,
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_REFRESH_FAILED,
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_FORBIDDEN,
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_FORGOT_PASSWORD
} OnlineAccountsSignonUIError;

#define ONLINE_ACCOUNTS_TYPE_SIGNON_UI_ERROR (online_accounts_signon_ui_error_get_type ())

#define ONLINE_ACCOUNTS_TYPE_WEB_DIALOG (online_accounts_web_dialog_get_type ())
#define ONLINE_ACCOUNTS_WEB_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ONLINE_ACCOUNTS_TYPE_WEB_DIALOG, OnlineAccountsWebDialog))
#define ONLINE_ACCOUNTS_WEB_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ONLINE_ACCOUNTS_TYPE_WEB_DIALOG, OnlineAccountsWebDialogClass))
#define ONLINE_ACCOUNTS_IS_WEB_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ONLINE_ACCOUNTS_TYPE_WEB_DIALOG))
#define ONLINE_ACCOUNTS_IS_WEB_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ONLINE_ACCOUNTS_TYPE_WEB_DIALOG))
#define ONLINE_ACCOUNTS_WEB_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ONLINE_ACCOUNTS_TYPE_WEB_DIALOG, OnlineAccountsWebDialogClass))

typedef struct _OnlineAccountsWebDialog OnlineAccountsWebDialog;
typedef struct _OnlineAccountsWebDialogClass OnlineAccountsWebDialogClass;
typedef struct _OnlineAccountsWebDialogPrivate OnlineAccountsWebDialogPrivate;
enum  {
	ONLINE_ACCOUNTS_WEB_DIALOG_0_PROPERTY,
	ONLINE_ACCOUNTS_WEB_DIALOG_NUM_PROPERTIES
};
static GParamSpec* online_accounts_web_dialog_properties[ONLINE_ACCOUNTS_WEB_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))

struct _OnlineAccountsDialog {
	GtkGrid parent_instance;
	OnlineAccountsDialogPrivate * priv;
	GHashTable* parameters;
	gchar* request_id;
	OnlineAccountsSignonUIError error_code;
};

struct _OnlineAccountsDialogClass {
	GtkGridClass parent_class;
	GHashTable* (*get_reply) (OnlineAccountsDialog* self);
	gboolean (*set_parameters) (OnlineAccountsDialog* self, GHashTable* params);
	gboolean (*refresh_captcha) (OnlineAccountsDialog* self, const gchar* uri);
};

struct _OnlineAccountsWebDialog {
	OnlineAccountsDialog parent_instance;
	OnlineAccountsWebDialogPrivate * priv;
};

struct _OnlineAccountsWebDialogClass {
	OnlineAccountsDialogClass parent_class;
};

struct _OnlineAccountsWebDialogPrivate {
	WebKitWebView* webview;
	gchar* oauth_open_url;
	gchar* oauth_final_url;
	gchar* oauth_response;
	GtkLabel* info_label;
	GtkSpinner* spinner;
};

static gint OnlineAccountsWebDialog_private_offset;
static gpointer online_accounts_web_dialog_parent_class = NULL;

GType online_accounts_dialog_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (OnlineAccountsDialog, g_object_unref)
GType online_accounts_signon_ui_error_get_type (void) G_GNUC_CONST;
GType online_accounts_web_dialog_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (OnlineAccountsWebDialog, g_object_unref)
OnlineAccountsWebDialog* online_accounts_web_dialog_new (GHashTable* params);
OnlineAccountsWebDialog* online_accounts_web_dialog_construct (GType object_type,
                                                               GHashTable* params);
OnlineAccountsDialog* online_accounts_dialog_construct (GType object_type,
                                                        GHashTable* parameter);
static void __lambda18_ (OnlineAccountsWebDialog* self);
static void ___lambda18__gtk_info_bar_response (GtkInfoBar* _sender,
                                         gint response_id,
                                         gpointer self);
gboolean online_accounts_dialog_set_parameters (OnlineAccountsDialog* self,
                                                GHashTable* params);
static gboolean online_accounts_web_dialog_real_set_parameters (OnlineAccountsDialog* base,
                                                         GHashTable* params);
static void online_accounts_web_dialog_on_webview_load (OnlineAccountsWebDialog* self,
                                                 WebKitLoadEvent load_event);
static void _online_accounts_web_dialog_on_webview_load_webkit_web_view_load_changed (WebKitWebView* _sender,
                                                                               WebKitLoadEvent load_event,
                                                                               gpointer self);
static gboolean online_accounts_web_dialog_on_load_uri_failed (OnlineAccountsWebDialog* self,
                                                        WebKitLoadEvent load_event,
                                                        const gchar* failing_uri,
                                                        GError* _error_);
static gboolean _online_accounts_web_dialog_on_load_uri_failed_webkit_web_view_load_failed (WebKitWebView* _sender,
                                                                                     WebKitLoadEvent load_event,
                                                                                     const gchar* failing_uri,
                                                                                     GError* _error_,
                                                                                     gpointer self);
static gboolean online_accounts_web_dialog_validate_params (OnlineAccountsWebDialog* self,
                                                     GHashTable* params);
static gboolean online_accounts_web_dialog_is_valid_url (OnlineAccountsWebDialog* self,
                                                  const gchar* uri);
#define ONLINE_ACCOUNTS_KEY_OPEN_URL "OpenUrl"
#define ONLINE_ACCOUNTS_KEY_FINAL_URL "FinalUrl"
static GHashTable* online_accounts_web_dialog_real_get_reply (OnlineAccountsDialog* base);
GHashTable* online_accounts_dialog_get_reply (OnlineAccountsDialog* self);
#define ONLINE_ACCOUNTS_KEY_URL_RESPONSE "UrlResponse"
static gboolean online_accounts_web_dialog_real_refresh_captcha (OnlineAccountsDialog* base,
                                                          const gchar* uri);
static void online_accounts_web_dialog_finalize (GObject * obj);
static GType online_accounts_web_dialog_get_type_once (void);
static gint _vala_array_length (gpointer array);

static inline gpointer
online_accounts_web_dialog_get_instance_private (OnlineAccountsWebDialog* self)
{
	return G_STRUCT_MEMBER_P (self, OnlineAccountsWebDialog_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
__lambda18_ (OnlineAccountsWebDialog* self)
{
	((OnlineAccountsDialog*) self)->error_code = ONLINE_ACCOUNTS_SIGNON_UI_ERROR_CANCELED;
	g_signal_emit_by_name ((OnlineAccountsDialog*) self, "finished");
	gtk_widget_destroy ((GtkWidget*) self);
}

static void
___lambda18__gtk_info_bar_response (GtkInfoBar* _sender,
                                    gint response_id,
                                    gpointer self)
{
	__lambda18_ ((OnlineAccountsWebDialog*) self);
}

OnlineAccountsWebDialog*
online_accounts_web_dialog_construct (GType object_type,
                                      GHashTable* params)
{
	OnlineAccountsWebDialog * self = NULL;
	GtkInfoBar* infobar = NULL;
	GtkInfoBar* _tmp0_;
	GtkContainer* container = NULL;
	GtkContainer* _tmp1_;
	GtkContainer* _tmp2_;
	GtkGrid* container_grid = NULL;
	GtkGrid* _tmp3_;
	GtkLabel* _tmp4_;
	GtkSpinner* _tmp5_;
	GtkSpinner* _tmp6_;
	GtkSpinner* _tmp7_;
	GtkLabel* _tmp8_;
	WebKitWebContext* _tmp9_;
	gchar** _tmp10_;
	gchar** _tmp11_;
	WebKitWebView* _tmp12_;
	WebKitWebView* _tmp13_;
	GtkEventBox* event_box = NULL;
	GtkEventBox* _tmp14_;
	WebKitWebView* _tmp15_;
	GtkStyleContext* _tmp16_;
	g_return_val_if_fail (params != NULL, NULL);
	self = (OnlineAccountsWebDialog*) online_accounts_dialog_construct (object_type, params);
	_tmp0_ = (GtkInfoBar*) gtk_info_bar_new_with_buttons (_ ("Cancel"), 0, NULL);
	g_object_ref_sink (_tmp0_);
	infobar = _tmp0_;
	_tmp1_ = gtk_info_bar_get_content_area (infobar);
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, gtk_container_get_type ()) ? ((GtkContainer*) _tmp1_) : NULL);
	container = _tmp2_;
	_tmp3_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp3_);
	container_grid = _tmp3_;
	gtk_grid_set_column_spacing (container_grid, 12);
	_tmp4_ = (GtkLabel*) gtk_label_new (_ ("Loading…"));
	g_object_ref_sink (_tmp4_);
	_g_object_unref0 (self->priv->info_label);
	self->priv->info_label = _tmp4_;
	gtk_widget_set_valign ((GtkWidget*) container_grid, GTK_ALIGN_CENTER);
	_tmp5_ = (GtkSpinner*) gtk_spinner_new ();
	g_object_ref_sink (_tmp5_);
	_g_object_unref0 (self->priv->spinner);
	self->priv->spinner = _tmp5_;
	_tmp6_ = self->priv->spinner;
	gtk_spinner_start (_tmp6_);
	_tmp7_ = self->priv->spinner;
	gtk_grid_attach (container_grid, (GtkWidget*) _tmp7_, 0, 0, 1, 1);
	_tmp8_ = self->priv->info_label;
	gtk_grid_attach (container_grid, (GtkWidget*) _tmp8_, 1, 0, 1, 1);
	gtk_container_add (container, (GtkWidget*) container_grid);
	g_signal_connect_object (infobar, "response", (GCallback) ___lambda18__gtk_info_bar_response, self, 0);
	_tmp9_ = webkit_web_context_get_default ();
	_tmp11_ = _tmp10_ = g_get_language_names ();
	webkit_web_context_set_preferred_languages (_tmp9_, _tmp11_);
	_tmp12_ = (WebKitWebView*) webkit_web_view_new ();
	g_object_ref_sink (_tmp12_);
	_g_object_unref0 (self->priv->webview);
	self->priv->webview = _tmp12_;
	_tmp13_ = self->priv->webview;
	g_object_set ((GtkWidget*) _tmp13_, "expand", TRUE, NULL);
	_tmp14_ = (GtkEventBox*) gtk_event_box_new ();
	g_object_ref_sink (_tmp14_);
	event_box = _tmp14_;
	_tmp15_ = self->priv->webview;
	gtk_container_add ((GtkContainer*) event_box, (GtkWidget*) _tmp15_);
	_tmp16_ = gtk_widget_get_style_context ((GtkWidget*) event_box);
	gtk_style_context_add_class (_tmp16_, GTK_STYLE_CLASS_VIEW);
	g_object_set ((GtkWidget*) event_box, "expand", TRUE, NULL);
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) infobar, 0, 0, 1, 1);
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) event_box, 0, 1, 1, 1);
	gtk_widget_show_all ((GtkWidget*) self);
	online_accounts_dialog_set_parameters ((OnlineAccountsDialog*) self, params);
	_g_object_unref0 (event_box);
	_g_object_unref0 (container_grid);
	_g_object_unref0 (container);
	_g_object_unref0 (infobar);
	return self;
}

OnlineAccountsWebDialog*
online_accounts_web_dialog_new (GHashTable* params)
{
	return online_accounts_web_dialog_construct (ONLINE_ACCOUNTS_TYPE_WEB_DIALOG, params);
}

static void
_online_accounts_web_dialog_on_webview_load_webkit_web_view_load_changed (WebKitWebView* _sender,
                                                                          WebKitLoadEvent load_event,
                                                                          gpointer self)
{
	online_accounts_web_dialog_on_webview_load ((OnlineAccountsWebDialog*) self, load_event);
}

static gboolean
_online_accounts_web_dialog_on_load_uri_failed_webkit_web_view_load_failed (WebKitWebView* _sender,
                                                                            WebKitLoadEvent load_event,
                                                                            const gchar* failing_uri,
                                                                            GError* _error_,
                                                                            gpointer self)
{
	gboolean result;
	result = online_accounts_web_dialog_on_load_uri_failed ((OnlineAccountsWebDialog*) self, load_event, failing_uri, _error_);
	return result;
}

static gboolean
online_accounts_web_dialog_real_set_parameters (OnlineAccountsDialog* base,
                                                GHashTable* params)
{
	OnlineAccountsWebDialog * self;
	WebKitWebView* _tmp0_;
	WebKitWebView* _tmp1_;
	WebKitWebView* _tmp2_;
	const gchar* _tmp3_;
	gboolean result = FALSE;
	self = (OnlineAccountsWebDialog*) base;
	g_return_val_if_fail (params != NULL, FALSE);
	if (ONLINE_ACCOUNTS_DIALOG_CLASS (online_accounts_web_dialog_parent_class)->set_parameters (G_TYPE_CHECK_INSTANCE_CAST (self, ONLINE_ACCOUNTS_TYPE_DIALOG, OnlineAccountsDialog), params) == FALSE) {
		result = FALSE;
		return result;
	}
	_tmp0_ = self->priv->webview;
	g_signal_connect_object (_tmp0_, "load-changed", (GCallback) _online_accounts_web_dialog_on_webview_load_webkit_web_view_load_changed, self, 0);
	_tmp1_ = self->priv->webview;
	g_signal_connect_object (_tmp1_, "load-failed", (GCallback) _online_accounts_web_dialog_on_load_uri_failed_webkit_web_view_load_failed, self, 0);
	if (online_accounts_web_dialog_validate_params (self, params) == FALSE) {
		result = FALSE;
		return result;
	}
	_tmp2_ = self->priv->webview;
	_tmp3_ = self->priv->oauth_open_url;
	webkit_web_view_load_uri (_tmp2_, _tmp3_);
	result = TRUE;
	return result;
}

static gboolean
online_accounts_web_dialog_is_valid_url (OnlineAccountsWebDialog* self,
                                         const gchar* uri)
{
	gchar* scheme = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (uri != NULL, FALSE);
	_tmp0_ = g_uri_parse_scheme (uri);
	scheme = _tmp0_;
	_tmp1_ = scheme;
	if (_tmp1_ == NULL) {
		result = FALSE;
		_g_free0 (scheme);
		return result;
	}
	_tmp2_ = scheme;
	result = g_str_has_prefix (_tmp2_, "http");
	_g_free0 (scheme);
	return result;
}

static gboolean
online_accounts_web_dialog_validate_params (OnlineAccountsWebDialog* self,
                                            GHashTable* params)
{
	GVariant* open_url_var = NULL;
	gconstpointer _tmp0_;
	GVariant* _tmp1_;
	GVariant* final_url_var = NULL;
	gconstpointer _tmp5_;
	GVariant* _tmp6_;
	gboolean _tmp10_ = FALSE;
	const gchar* _tmp11_;
	gboolean _tmp13_ = FALSE;
	const gchar* _tmp14_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (params != NULL, FALSE);
	_tmp0_ = g_hash_table_lookup (params, ONLINE_ACCOUNTS_KEY_OPEN_URL);
	open_url_var = (GVariant*) _tmp0_;
	_tmp1_ = open_url_var;
	if (_tmp1_ != NULL) {
		GVariant* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		_tmp2_ = open_url_var;
		_tmp3_ = g_variant_get_string (_tmp2_, NULL);
		_tmp4_ = g_strdup (_tmp3_);
		_g_free0 (self->priv->oauth_open_url);
		self->priv->oauth_open_url = _tmp4_;
	}
	_tmp5_ = g_hash_table_lookup (params, ONLINE_ACCOUNTS_KEY_FINAL_URL);
	final_url_var = (GVariant*) _tmp5_;
	_tmp6_ = final_url_var;
	if (_tmp6_ != NULL) {
		GVariant* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		_tmp7_ = final_url_var;
		_tmp8_ = g_variant_get_string (_tmp7_, NULL);
		_tmp9_ = g_strdup (_tmp8_);
		_g_free0 (self->priv->oauth_final_url);
		self->priv->oauth_final_url = _tmp9_;
	}
	_tmp11_ = self->priv->oauth_open_url;
	if (_tmp11_ == NULL) {
		_tmp10_ = TRUE;
	} else {
		const gchar* _tmp12_;
		_tmp12_ = self->priv->oauth_final_url;
		_tmp10_ = _tmp12_ == NULL;
	}
	if (_tmp10_) {
		g_warning ("WebDialog.vala:100: Missing open_url or final_url");
		result = FALSE;
		return result;
	}
	_tmp14_ = self->priv->oauth_open_url;
	if (online_accounts_web_dialog_is_valid_url (self, _tmp14_) == FALSE) {
		_tmp13_ = TRUE;
	} else {
		const gchar* _tmp15_;
		_tmp15_ = self->priv->oauth_final_url;
		_tmp13_ = online_accounts_web_dialog_is_valid_url (self, _tmp15_) == FALSE;
	}
	if (_tmp13_) {
		g_warning ("WebDialog.vala:105: Invalid open_url or final_url");
		result = FALSE;
		return result;
	}
	result = TRUE;
	return result;
}

static gboolean
online_accounts_web_dialog_on_load_uri_failed (OnlineAccountsWebDialog* self,
                                               WebKitLoadEvent load_event,
                                               const gchar* failing_uri,
                                               GError* _error_)
{
	const gchar* _tmp0_;
	GCompareFunc _tmp1_;
	const gchar* _tmp2_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (failing_uri != NULL, FALSE);
	g_return_val_if_fail (_error_ != NULL, FALSE);
	_tmp0_ = _error_->message;
	g_warning ("WebDialog.vala:113: Loading uri '%s' failed, error : %s", failing_uri, _tmp0_);
	_tmp1_ = ((GCompareFunc) g_strcmp0);
	_tmp2_ = self->priv->oauth_open_url;
	if (_tmp1_ (failing_uri, _tmp2_) == 0) {
		((OnlineAccountsDialog*) self)->error_code = ONLINE_ACCOUNTS_SIGNON_UI_ERROR_NOT_AVAILABLE;
	}
	result = TRUE;
	return result;
}

static void
online_accounts_web_dialog_on_webview_load (OnlineAccountsWebDialog* self,
                                            WebKitLoadEvent load_event)
{
	gchar* redirect_uri = NULL;
	WebKitWebView* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
	WebKitWebView* _tmp13_;
	guint _tmp14_;
	const gchar* _tmp15_;
	gchar* _tmp16_;
	const gchar* _tmp17_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->webview;
	_tmp1_ = webkit_web_view_get_uri (_tmp0_);
	_tmp2_ = g_strdup (_tmp1_);
	redirect_uri = _tmp2_;
	_tmp4_ = redirect_uri;
	if (_tmp4_ == NULL) {
		_tmp3_ = TRUE;
	} else {
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		_tmp5_ = redirect_uri;
		_tmp6_ = self->priv->oauth_final_url;
		_tmp3_ = !g_str_has_prefix (_tmp5_, _tmp6_);
	}
	if (_tmp3_) {
		if (load_event == WEBKIT_LOAD_FINISHED) {
			GtkLabel* _tmp7_;
			GtkSpinner* _tmp8_;
			GtkSpinner* _tmp9_;
			_tmp7_ = self->priv->info_label;
			gtk_label_set_label (_tmp7_, _ ("Please enter your credentials…"));
			_tmp8_ = self->priv->spinner;
			gtk_spinner_stop (_tmp8_);
			_tmp9_ = self->priv->spinner;
			gtk_widget_hide ((GtkWidget*) _tmp9_);
			_g_free0 (redirect_uri);
			return;
		}
		if (load_event == WEBKIT_LOAD_STARTED) {
			GtkLabel* _tmp10_;
			GtkSpinner* _tmp11_;
			GtkSpinner* _tmp12_;
			_tmp10_ = self->priv->info_label;
			gtk_label_set_label (_tmp10_, _ ("Loading…"));
			_tmp11_ = self->priv->spinner;
			gtk_spinner_start (_tmp11_);
			_tmp12_ = self->priv->spinner;
			gtk_widget_show ((GtkWidget*) _tmp12_);
			_g_free0 (redirect_uri);
			return;
		}
		_g_free0 (redirect_uri);
		return;
	}
	_tmp13_ = self->priv->webview;
	g_signal_parse_name ("load-changed", webkit_web_view_get_type (), &_tmp14_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp13_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp14_, 0, NULL, (GCallback) _online_accounts_web_dialog_on_webview_load_webkit_web_view_load_changed, self);
	_tmp15_ = redirect_uri;
	_tmp16_ = g_strdup (_tmp15_);
	_g_free0 (self->priv->oauth_response);
	self->priv->oauth_response = _tmp16_;
	_tmp17_ = self->priv->oauth_response;
	g_debug ("WebDialog.vala:144: Found OAUTH Response : %s", _tmp17_);
	((OnlineAccountsDialog*) self)->error_code = ONLINE_ACCOUNTS_SIGNON_UI_ERROR_NONE;
	g_signal_emit_by_name ((OnlineAccountsDialog*) self, "finished");
	_g_free0 (redirect_uri);
}

static GHashTable*
online_accounts_web_dialog_real_get_reply (OnlineAccountsDialog* base)
{
	OnlineAccountsWebDialog * self;
	GHashTable* table = NULL;
	GHashTable* _tmp0_;
	OnlineAccountsSignonUIError _tmp1_;
	GHashTable* result = NULL;
	self = (OnlineAccountsWebDialog*) base;
	_tmp0_ = ONLINE_ACCOUNTS_DIALOG_CLASS (online_accounts_web_dialog_parent_class)->get_reply (G_TYPE_CHECK_INSTANCE_CAST (self, ONLINE_ACCOUNTS_TYPE_DIALOG, OnlineAccountsDialog));
	table = _tmp0_;
	_tmp1_ = ((OnlineAccountsDialog*) self)->error_code;
	if (_tmp1_ == ONLINE_ACCOUNTS_SIGNON_UI_ERROR_NONE) {
		GHashTable* _tmp2_;
		gchar* _tmp3_;
		const gchar* _tmp4_;
		GVariant* _tmp5_;
		_tmp2_ = table;
		_tmp3_ = g_strdup (ONLINE_ACCOUNTS_KEY_URL_RESPONSE);
		_tmp4_ = self->priv->oauth_response;
		_tmp5_ = g_variant_new_string (_tmp4_);
		g_variant_ref_sink (_tmp5_);
		g_hash_table_insert (_tmp2_, _tmp3_, _tmp5_);
	}
	result = table;
	return result;
}

static gboolean
online_accounts_web_dialog_real_refresh_captcha (OnlineAccountsDialog* base,
                                                 const gchar* uri)
{
	OnlineAccountsWebDialog * self;
	gboolean result = FALSE;
	self = (OnlineAccountsWebDialog*) base;
	g_return_val_if_fail (uri != NULL, FALSE);
	result = TRUE;
	return result;
}

static void
online_accounts_web_dialog_class_init (OnlineAccountsWebDialogClass * klass,
                                       gpointer klass_data)
{
	online_accounts_web_dialog_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &OnlineAccountsWebDialog_private_offset);
	((OnlineAccountsDialogClass *) klass)->set_parameters = (gboolean (*) (OnlineAccountsDialog*, GHashTable*)) online_accounts_web_dialog_real_set_parameters;
	((OnlineAccountsDialogClass *) klass)->get_reply = (GHashTable* (*) (OnlineAccountsDialog*)) online_accounts_web_dialog_real_get_reply;
	((OnlineAccountsDialogClass *) klass)->refresh_captcha = (gboolean (*) (OnlineAccountsDialog*, const gchar*)) online_accounts_web_dialog_real_refresh_captcha;
	G_OBJECT_CLASS (klass)->finalize = online_accounts_web_dialog_finalize;
}

static void
online_accounts_web_dialog_instance_init (OnlineAccountsWebDialog * self,
                                          gpointer klass)
{
	self->priv = online_accounts_web_dialog_get_instance_private (self);
}

static void
online_accounts_web_dialog_finalize (GObject * obj)
{
	OnlineAccountsWebDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, ONLINE_ACCOUNTS_TYPE_WEB_DIALOG, OnlineAccountsWebDialog);
	_g_object_unref0 (self->priv->webview);
	_g_free0 (self->priv->oauth_open_url);
	_g_free0 (self->priv->oauth_final_url);
	_g_free0 (self->priv->oauth_response);
	_g_object_unref0 (self->priv->info_label);
	_g_object_unref0 (self->priv->spinner);
	G_OBJECT_CLASS (online_accounts_web_dialog_parent_class)->finalize (obj);
}

static GType
online_accounts_web_dialog_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (OnlineAccountsWebDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) online_accounts_web_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (OnlineAccountsWebDialog), 0, (GInstanceInitFunc) online_accounts_web_dialog_instance_init, NULL };
	GType online_accounts_web_dialog_type_id;
	online_accounts_web_dialog_type_id = g_type_register_static (ONLINE_ACCOUNTS_TYPE_DIALOG, "OnlineAccountsWebDialog", &g_define_type_info, 0);
	OnlineAccountsWebDialog_private_offset = g_type_add_instance_private (online_accounts_web_dialog_type_id, sizeof (OnlineAccountsWebDialogPrivate));
	return online_accounts_web_dialog_type_id;
}

GType
online_accounts_web_dialog_get_type (void)
{
	static volatile gsize online_accounts_web_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&online_accounts_web_dialog_type_id__volatile)) {
		GType online_accounts_web_dialog_type_id;
		online_accounts_web_dialog_type_id = online_accounts_web_dialog_get_type_once ();
		g_once_init_leave (&online_accounts_web_dialog_type_id__volatile, online_accounts_web_dialog_type_id);
	}
	return online_accounts_web_dialog_type_id__volatile;
}

static gint
_vala_array_length (gpointer array)
{
	gint length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

