/* AppRow.c generated by valac 0.48.8, the Vala compiler
 * generated from AppRow.vala, do not modify */

/*
* Copyright (c) 2013-2018 elementary, Inc. (https://elementary.io)
*
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Library General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Library General Public License for more details.
*
* You should have received a copy of the GNU Library General Public
* License along with this library; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA.
*
* Authored by: Corentin Noël <corentin@elementary.io>
*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <libaccounts-glib.h>
#include <libsignon-glib/signon-glib.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gdesktopappinfo.h>
#include <gio/gio.h>

#define TYPE_APP_ROW (app_row_get_type ())
#define APP_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_APP_ROW, AppRow))
#define APP_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_APP_ROW, AppRowClass))
#define IS_APP_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_APP_ROW))
#define IS_APP_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_APP_ROW))
#define APP_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_APP_ROW, AppRowClass))

typedef struct _AppRow AppRow;
typedef struct _AppRowClass AppRowClass;
typedef struct _AppRowPrivate AppRowPrivate;
enum  {
	APP_ROW_0_PROPERTY,
	APP_ROW_ACCOUNT_PROPERTY,
	APP_ROW_APP_PROPERTY,
	APP_ROW_SERVICE_PROPERTY,
	APP_ROW_IDENTITY_PROPERTY,
	APP_ROW_NUM_PROPERTIES
};
static GParamSpec* app_row_properties[APP_ROW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _ag_application_unref0(var) ((var == NULL) ? NULL : (var = (ag_application_unref (var), NULL)))
#define _ag_service_unref0(var) ((var == NULL) ? NULL : (var = (ag_service_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_SignonIdentityInfo_free0(var) ((var == NULL) ? NULL : (var = (_vala_SignonIdentityInfo_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _AppRowAllowAppData AppRowAllowAppData;
typedef struct _Block8Data Block8Data;
typedef struct _AppRowDenyAppData AppRowDenyAppData;

struct _AppRow {
	GtkListBoxRow parent_instance;
	AppRowPrivate * priv;
};

struct _AppRowClass {
	GtkListBoxRowClass parent_class;
};

struct _AppRowPrivate {
	AgAccount* _account;
	AgApplication* _app;
	AgService* _service;
	SignonIdentity* _identity;
	GtkCheckButton* app_switch;
};

struct _AppRowAllowAppData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AppRow* self;
	AgAccount* _tmp0_;
	AgService* _tmp1_;
	SignonIdentityInfo* info;
	SignonIdentity* _tmp2_;
	SignonIdentityInfo* _tmp3_;
	SignonIdentityInfo* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	SignonIdentity* _tmp7_;
	SignonIdentityInfo* _tmp8_;
	GtkCheckButton* _tmp9_;
	AgAccount* _tmp10_;
	AgAccount* _tmp11_;
	GError* e;
	GError* _tmp12_;
	const gchar* _tmp13_;
	AgAccount* _tmp14_;
	GError* _inner_error0_;
};

struct _Block8Data {
	int _ref_count_;
	AppRow* self;
	GList* list;
	gchar* path;
};

struct _AppRowDenyAppData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AppRow* self;
	Block8Data* _data8_;
	AgAccount* _tmp0_;
	AgService* _tmp1_;
	SignonIdentityInfo* info;
	SignonIdentity* _tmp2_;
	SignonIdentityInfo* _tmp3_;
	SignonIdentityInfo* _tmp4_;
	GList* _tmp5_;
	gchar* _tmp6_;
	GList* _tmp7_;
	SignonIdentityInfo* _tmp8_;
	GList* _tmp9_;
	SignonIdentity* _tmp10_;
	SignonIdentityInfo* _tmp11_;
	GtkCheckButton* _tmp12_;
	AgAccount* _tmp13_;
	AgAccount* _tmp14_;
	GError* e;
	GError* _tmp15_;
	const gchar* _tmp16_;
	AgAccount* _tmp17_;
	GError* _inner_error0_;
};

static gint AppRow_private_offset;
static gpointer app_row_parent_class = NULL;

GType app_row_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AppRow, g_object_unref)
AppRow* app_row_new (AgAccount* account,
                     AgApplication* app,
                     AgService* service,
                     SignonIdentity* identity);
AppRow* app_row_construct (GType object_type,
                           AgAccount* account,
                           AgApplication* app,
                           AgService* service,
                           SignonIdentity* identity);
static gchar* app_row_get_app_path (AppRow* self);
AgApplication* app_row_get_app (AppRow* self);
void app_row_check_acl (AppRow* self,
                        GList* acl);
static void app_row_allow_app_data_free (gpointer _data);
void app_row_allow_app (AppRow* self,
                        GAsyncReadyCallback _callback_,
                        gpointer _user_data_);
void app_row_allow_app_finish (AppRow* self,
                               GAsyncResult* _res_);
static gboolean app_row_allow_app_co (AppRowAllowAppData* _data_);
AgAccount* app_row_get_account (AppRow* self);
AgService* app_row_get_service (AppRow* self);
SignonIdentity* app_row_get_identity (AppRow* self);
static void app_row_allow_app_ready (GObject* source_object,
                              GAsyncResult* _res_,
                              gpointer _user_data_);
static void _vala_SignonIdentityInfo_free (SignonIdentityInfo* self);
static void app_row_deny_app_data_free (gpointer _data);
void app_row_deny_app (AppRow* self,
                       GAsyncReadyCallback _callback_,
                       gpointer _user_data_);
void app_row_deny_app_finish (AppRow* self,
                              GAsyncResult* _res_);
static gboolean app_row_deny_app_co (AppRowDenyAppData* _data_);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void _vala_SignonSecurityContext_free (SignonSecurityContext* self);
static void __vala_SignonSecurityContext_free0_ (gpointer var);
static inline void _g_list_free___vala_SignonSecurityContext_free0_ (GList* self);
static void block8_data_unref (void * _userdata_);
static void app_row_deny_app_ready (GObject* source_object,
                             GAsyncResult* _res_,
                             gpointer _user_data_);
static void ___lambda6_ (Block8Data* _data8_,
                  SignonSecurityContext* nth);
static void ____lambda6__gfunc (gconstpointer data,
                         gpointer self);
static void app_row_set_account (AppRow* self,
                          AgAccount* value);
static void app_row_set_app (AppRow* self,
                      AgApplication* value);
static void app_row_set_service (AppRow* self,
                          AgService* value);
static void app_row_set_identity (AppRow* self,
                           SignonIdentity* value);
static GObject * app_row_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties);
static void _app_row___lambda7_ (AppRow* self);
static void __app_row___lambda7__gtk_button_activate (GtkButton* _sender,
                                               gpointer self);
static void app_row_finalize (GObject * obj);
static GType app_row_get_type_once (void);
static void _vala_app_row_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec);
static void _vala_app_row_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec);

static inline gpointer
app_row_get_instance_private (AppRow* self)
{
	return G_STRUCT_MEMBER_P (self, AppRow_private_offset);
}

AppRow*
app_row_construct (GType object_type,
                   AgAccount* account,
                   AgApplication* app,
                   AgService* service,
                   SignonIdentity* identity)
{
	AppRow * self = NULL;
	g_return_val_if_fail (account != NULL, NULL);
	g_return_val_if_fail (app != NULL, NULL);
	g_return_val_if_fail (service != NULL, NULL);
	g_return_val_if_fail (identity != NULL, NULL);
	self = (AppRow*) g_object_new (object_type, "account", account, "app", app, "identity", identity, "service", service, NULL);
	return self;
}

AppRow*
app_row_new (AgAccount* account,
             AgApplication* app,
             AgService* service,
             SignonIdentity* identity)
{
	return app_row_construct (TYPE_APP_ROW, account, app, service, identity);
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

static gchar*
app_row_get_app_path (AppRow* self)
{
	GDesktopAppInfo* app_info = NULL;
	AgApplication* _tmp0_;
	GDesktopAppInfo* _tmp1_;
	const gchar* exec = NULL;
	GDesktopAppInfo* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_app;
	_tmp1_ = ag_application_get_desktop_app_info (_tmp0_);
	app_info = _tmp1_;
	_tmp2_ = app_info;
	_tmp3_ = g_app_info_get_executable ((GAppInfo*) _tmp2_);
	exec = _tmp3_;
	_tmp4_ = exec;
	if (string_contains (_tmp4_, "/") == FALSE) {
		const gchar* _tmp5_;
		gchar* _tmp6_;
		_tmp5_ = exec;
		_tmp6_ = g_find_program_in_path (_tmp5_);
		result = _tmp6_;
		_g_object_unref0 (app_info);
		return result;
	}
	_tmp7_ = exec;
	_tmp8_ = g_strdup (_tmp7_);
	result = _tmp8_;
	_g_object_unref0 (app_info);
	return result;
}

void
app_row_check_acl (AppRow* self,
                   GList* acl)
{
	gchar* path = NULL;
	gchar* _tmp0_;
	GtkCheckButton* _tmp11_;
	g_return_if_fail (self != NULL);
	_tmp0_ = app_row_get_app_path (self);
	path = _tmp0_;
	{
		GList* nth = NULL;
		GList* _tmp1_;
		_tmp1_ = g_list_first (acl);
		nth = _tmp1_;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				GList* _tmp5_;
				GList* _tmp6_;
				gconstpointer _tmp7_;
				const gchar* _tmp8_;
				const gchar* _tmp9_;
				if (!_tmp2_) {
					GList* _tmp3_;
					GList* _tmp4_;
					_tmp3_ = nth;
					_tmp4_ = _tmp3_->next;
					nth = _tmp4_;
				}
				_tmp2_ = FALSE;
				_tmp5_ = nth;
				if (!(_tmp5_ != NULL)) {
					break;
				}
				_tmp6_ = nth;
				_tmp7_ = _tmp6_->data;
				_tmp8_ = signon_security_context_get_system_context ((SignonSecurityContext*) _tmp7_);
				_tmp9_ = path;
				if (g_strcmp0 (_tmp8_, _tmp9_) == 0) {
					GtkCheckButton* _tmp10_;
					_tmp10_ = self->priv->app_switch;
					gtk_toggle_button_set_active ((GtkToggleButton*) _tmp10_, TRUE);
					_g_free0 (path);
					return;
				}
			}
		}
	}
	_tmp11_ = self->priv->app_switch;
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp11_, FALSE);
	_g_free0 (path);
}

static void
app_row_allow_app_data_free (gpointer _data)
{
	AppRowAllowAppData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (AppRowAllowAppData, _data_);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
app_row_allow_app (AppRow* self,
                   GAsyncReadyCallback _callback_,
                   gpointer _user_data_)
{
	AppRowAllowAppData* _data_;
	AppRow* _tmp0_;
	_data_ = g_slice_new0 (AppRowAllowAppData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, app_row_allow_app_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	app_row_allow_app_co (_data_);
}

void
app_row_allow_app_finish (AppRow* self,
                          GAsyncResult* _res_)
{
	AppRowAllowAppData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static void
app_row_allow_app_ready (GObject* source_object,
                         GAsyncResult* _res_,
                         gpointer _user_data_)
{
	AppRowAllowAppData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	app_row_allow_app_co (_data_);
}

static void
_vala_SignonIdentityInfo_free (SignonIdentityInfo* self)
{
	g_boxed_free (signon_identity_info_get_type (), self);
}

static gboolean
app_row_allow_app_co (AppRowAllowAppData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		case 2:
		goto _state_2;
		case 3:
		goto _state_3;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	{
		_data_->_tmp0_ = _data_->self->priv->_account;
		_data_->_tmp1_ = _data_->self->priv->_service;
		ag_account_select_service (_data_->_tmp0_, _data_->_tmp1_);
		_data_->_tmp2_ = _data_->self->priv->_identity;
		_data_->_state_ = 1;
		signon_identity_query_info (_data_->_tmp2_, NULL, app_row_allow_app_ready, _data_);
		return FALSE;
		_state_1:
		_data_->_tmp3_ = signon_identity_query_info_finish (_data_->_tmp2_, _data_->_res_, &_data_->_inner_error0_);
		_data_->info = _data_->_tmp3_;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_data_->_tmp4_ = _data_->info;
		_data_->_tmp5_ = app_row_get_app_path (_data_->self);
		_data_->_tmp6_ = _data_->_tmp5_;
		signon_identity_info_add_access_control (_data_->_tmp4_, _data_->_tmp6_, "*");
		_g_free0 (_data_->_tmp6_);
		_data_->_tmp7_ = _data_->self->priv->_identity;
		_data_->_tmp8_ = _data_->info;
		_data_->_state_ = 2;
		signon_identity_store_info (_data_->_tmp7_, _data_->_tmp8_, NULL, app_row_allow_app_ready, _data_);
		return FALSE;
		_state_2:
		signon_identity_store_info_finish (_data_->_tmp7_, _data_->_res_, &_data_->_inner_error0_);
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			__vala_SignonIdentityInfo_free0 (_data_->info);
			goto __catch0_g_error;
		}
		_data_->_tmp9_ = _data_->self->priv->app_switch;
		gtk_toggle_button_set_active ((GtkToggleButton*) _data_->_tmp9_, TRUE);
		_data_->_tmp10_ = _data_->self->priv->_account;
		ag_account_select_service (_data_->_tmp10_, NULL);
		_data_->_tmp11_ = _data_->self->priv->_account;
		_data_->_state_ = 3;
		ag_account_store_async (_data_->_tmp11_, NULL, app_row_allow_app_ready, _data_);
		return FALSE;
		_state_3:
		ag_account_store_finish (_data_->_tmp11_, _data_->_res_, &_data_->_inner_error0_);
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			__vala_SignonIdentityInfo_free0 (_data_->info);
			goto __catch0_g_error;
		}
		__vala_SignonIdentityInfo_free0 (_data_->info);
	}
	goto __finally0;
	__catch0_g_error:
	{
		_data_->e = _data_->_inner_error0_;
		_data_->_inner_error0_ = NULL;
		_data_->_tmp12_ = _data_->e;
		_data_->_tmp13_ = _data_->_tmp12_->message;
		g_critical ("AppRow.vala:102: %s", _data_->_tmp13_);
		_data_->_tmp14_ = _data_->self->priv->_account;
		ag_account_select_service (_data_->_tmp14_, NULL);
		_g_error_free0 (_data_->e);
	}
	__finally0:
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
		g_clear_error (&_data_->_inner_error0_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
app_row_deny_app_data_free (gpointer _data)
{
	AppRowDenyAppData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (AppRowDenyAppData, _data_);
}

void
app_row_deny_app (AppRow* self,
                  GAsyncReadyCallback _callback_,
                  gpointer _user_data_)
{
	AppRowDenyAppData* _data_;
	AppRow* _tmp0_;
	_data_ = g_slice_new0 (AppRowDenyAppData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, app_row_deny_app_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	app_row_deny_app_co (_data_);
}

void
app_row_deny_app_finish (AppRow* self,
                         GAsyncResult* _res_)
{
	AppRowDenyAppData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
	g_atomic_int_inc (&_data8_->_ref_count_);
	return _data8_;
}

static void
_vala_SignonSecurityContext_free (SignonSecurityContext* self)
{
	g_boxed_free (signon_security_context_get_type (), self);
}

static void
__vala_SignonSecurityContext_free0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (_vala_SignonSecurityContext_free (var), NULL));
}

static inline void
_g_list_free___vala_SignonSecurityContext_free0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) __vala_SignonSecurityContext_free0_);
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
		AppRow* self;
		self = _data8_->self;
		_g_free0 (_data8_->path);
		(_data8_->list == NULL) ? NULL : (_data8_->list = (_g_list_free___vala_SignonSecurityContext_free0_ (_data8_->list), NULL));
		_g_object_unref0 (self);
		g_slice_free (Block8Data, _data8_);
	}
}

static void
app_row_deny_app_ready (GObject* source_object,
                        GAsyncResult* _res_,
                        gpointer _user_data_)
{
	AppRowDenyAppData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	app_row_deny_app_co (_data_);
}

static void
___lambda6_ (Block8Data* _data8_,
             SignonSecurityContext* nth)
{
	AppRow* self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	self = _data8_->self;
	g_return_if_fail (nth != NULL);
	_tmp0_ = signon_security_context_get_system_context (nth);
	_tmp1_ = _data8_->path;
	if (g_strcmp0 (_tmp0_, _tmp1_) == 0) {
		_data8_->list = g_list_remove (_data8_->list, nth);
	}
}

static void
____lambda6__gfunc (gconstpointer data,
                    gpointer self)
{
	___lambda6_ (self, (SignonSecurityContext*) data);
}

static gboolean
app_row_deny_app_co (AppRowDenyAppData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		case 2:
		goto _state_2;
		case 3:
		goto _state_3;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	{
		_data_->_data8_ = g_slice_new0 (Block8Data);
		_data_->_data8_->_ref_count_ = 1;
		_data_->_data8_->self = g_object_ref (_data_->self);
		_data_->_tmp0_ = _data_->self->priv->_account;
		_data_->_tmp1_ = _data_->self->priv->_service;
		ag_account_select_service (_data_->_tmp0_, _data_->_tmp1_);
		_data_->_tmp2_ = _data_->self->priv->_identity;
		_data_->_state_ = 1;
		signon_identity_query_info (_data_->_tmp2_, NULL, app_row_deny_app_ready, _data_);
		return FALSE;
		_state_1:
		_data_->_tmp3_ = signon_identity_query_info_finish (_data_->_tmp2_, _data_->_res_, &_data_->_inner_error0_);
		_data_->info = _data_->_tmp3_;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			block8_data_unref (_data_->_data8_);
			_data_->_data8_ = NULL;
			goto __catch0_g_error;
		}
		_data_->_tmp4_ = _data_->info;
		_data_->_tmp5_ = signon_identity_info_get_access_control_list (_data_->_tmp4_);
		_data_->_data8_->list = _data_->_tmp5_;
		_data_->_tmp6_ = app_row_get_app_path (_data_->self);
		_data_->_data8_->path = _data_->_tmp6_;
		_data_->_tmp7_ = _data_->_data8_->list;
		g_list_foreach (_data_->_tmp7_, ____lambda6__gfunc, _data_->_data8_);
		_data_->_tmp8_ = _data_->info;
		_data_->_tmp9_ = _data_->_data8_->list;
		signon_identity_info_set_access_control_list (_data_->_tmp8_, _data_->_tmp9_);
		_data_->_tmp10_ = _data_->self->priv->_identity;
		_data_->_tmp11_ = _data_->info;
		_data_->_state_ = 2;
		signon_identity_store_info (_data_->_tmp10_, _data_->_tmp11_, NULL, app_row_deny_app_ready, _data_);
		return FALSE;
		_state_2:
		signon_identity_store_info_finish (_data_->_tmp10_, _data_->_res_, &_data_->_inner_error0_);
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			__vala_SignonIdentityInfo_free0 (_data_->info);
			block8_data_unref (_data_->_data8_);
			_data_->_data8_ = NULL;
			goto __catch0_g_error;
		}
		_data_->_tmp12_ = _data_->self->priv->app_switch;
		gtk_toggle_button_set_active ((GtkToggleButton*) _data_->_tmp12_, FALSE);
		_data_->_tmp13_ = _data_->self->priv->_account;
		ag_account_select_service (_data_->_tmp13_, NULL);
		_data_->_tmp14_ = _data_->self->priv->_account;
		_data_->_state_ = 3;
		ag_account_store_async (_data_->_tmp14_, NULL, app_row_deny_app_ready, _data_);
		return FALSE;
		_state_3:
		ag_account_store_finish (_data_->_tmp14_, _data_->_res_, &_data_->_inner_error0_);
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			__vala_SignonIdentityInfo_free0 (_data_->info);
			block8_data_unref (_data_->_data8_);
			_data_->_data8_ = NULL;
			goto __catch0_g_error;
		}
		__vala_SignonIdentityInfo_free0 (_data_->info);
		block8_data_unref (_data_->_data8_);
		_data_->_data8_ = NULL;
	}
	goto __finally0;
	__catch0_g_error:
	{
		_data_->e = _data_->_inner_error0_;
		_data_->_inner_error0_ = NULL;
		_data_->_tmp15_ = _data_->e;
		_data_->_tmp16_ = _data_->_tmp15_->message;
		g_critical ("AppRow.vala:125: %s", _data_->_tmp16_);
		_data_->_tmp17_ = _data_->self->priv->_account;
		ag_account_select_service (_data_->_tmp17_, NULL);
		_g_error_free0 (_data_->e);
	}
	__finally0:
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
		g_clear_error (&_data_->_inner_error0_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

AgAccount*
app_row_get_account (AppRow* self)
{
	AgAccount* result;
	AgAccount* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_account;
	result = _tmp0_;
	return result;
}

static void
app_row_set_account (AppRow* self,
                     AgAccount* value)
{
	g_return_if_fail (self != NULL);
	if (app_row_get_account (self) != value) {
		AgAccount* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_account);
		self->priv->_account = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, app_row_properties[APP_ROW_ACCOUNT_PROPERTY]);
	}
}

AgApplication*
app_row_get_app (AppRow* self)
{
	AgApplication* result;
	AgApplication* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_app;
	result = _tmp0_;
	return result;
}

static gpointer
_ag_application_ref0 (gpointer self)
{
	return self ? ag_application_ref (self) : NULL;
}

static void
app_row_set_app (AppRow* self,
                 AgApplication* value)
{
	g_return_if_fail (self != NULL);
	if (app_row_get_app (self) != value) {
		AgApplication* _tmp0_;
		_tmp0_ = _ag_application_ref0 (value);
		_ag_application_unref0 (self->priv->_app);
		self->priv->_app = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, app_row_properties[APP_ROW_APP_PROPERTY]);
	}
}

AgService*
app_row_get_service (AppRow* self)
{
	AgService* result;
	AgService* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_service;
	result = _tmp0_;
	return result;
}

static gpointer
_ag_service_ref0 (gpointer self)
{
	return self ? ag_service_ref (self) : NULL;
}

static void
app_row_set_service (AppRow* self,
                     AgService* value)
{
	g_return_if_fail (self != NULL);
	if (app_row_get_service (self) != value) {
		AgService* _tmp0_;
		_tmp0_ = _ag_service_ref0 (value);
		_ag_service_unref0 (self->priv->_service);
		self->priv->_service = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, app_row_properties[APP_ROW_SERVICE_PROPERTY]);
	}
}

SignonIdentity*
app_row_get_identity (AppRow* self)
{
	SignonIdentity* result;
	SignonIdentity* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_identity;
	result = _tmp0_;
	return result;
}

static void
app_row_set_identity (AppRow* self,
                      SignonIdentity* value)
{
	g_return_if_fail (self != NULL);
	if (app_row_get_identity (self) != value) {
		SignonIdentity* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_identity);
		self->priv->_identity = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, app_row_properties[APP_ROW_IDENTITY_PROPERTY]);
	}
}

static void
_app_row___lambda7_ (AppRow* self)
{
	GtkCheckButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	_tmp0_ = self->priv->app_switch;
	_tmp1_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		app_row_allow_app (self, NULL, NULL);
	} else {
		app_row_deny_app (self, NULL, NULL);
	}
}

static void
__app_row___lambda7__gtk_button_activate (GtkButton* _sender,
                                          gpointer self)
{
	_app_row___lambda7_ ((AppRow*) self);
}

static GObject *
app_row_constructor (GType type,
                     guint n_construct_properties,
                     GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	AppRow * self;
	GDesktopAppInfo* app_info = NULL;
	AgApplication* _tmp0_;
	GDesktopAppInfo* _tmp1_;
	GtkImage* app_image = NULL;
	GtkImage* _tmp2_;
	GtkImage* _tmp3_;
	GtkImage* _tmp4_;
	GDesktopAppInfo* _tmp5_;
	GIcon* _tmp6_;
	GtkLabel* app_name = NULL;
	GDesktopAppInfo* _tmp7_;
	const gchar* _tmp8_;
	GtkLabel* _tmp9_;
	GtkCheckButton* _tmp10_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp11_;
	GtkGrid* _tmp12_;
	GtkGrid* _tmp13_;
	GtkCheckButton* _tmp14_;
	GtkGrid* _tmp15_;
	GtkImage* _tmp16_;
	GtkGrid* _tmp17_;
	GtkLabel* _tmp18_;
	GtkGrid* _tmp19_;
	GtkCheckButton* _tmp20_;
	parent_class = G_OBJECT_CLASS (app_row_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_APP_ROW, AppRow);
	_tmp0_ = self->priv->_app;
	_tmp1_ = ag_application_get_desktop_app_info (_tmp0_);
	app_info = _tmp1_;
	_tmp2_ = (GtkImage*) gtk_image_new ();
	g_object_ref_sink (_tmp2_);
	app_image = _tmp2_;
	_tmp3_ = app_image;
	g_object_set (_tmp3_, "icon-size", (gint) GTK_ICON_SIZE_DND, NULL);
	_tmp4_ = app_image;
	_tmp5_ = app_info;
	_tmp6_ = g_app_info_get_icon ((GAppInfo*) _tmp5_);
	g_object_set (_tmp4_, "gicon", _tmp6_, NULL);
	_tmp7_ = app_info;
	_tmp8_ = g_app_info_get_display_name ((GAppInfo*) _tmp7_);
	_tmp9_ = (GtkLabel*) gtk_label_new (_tmp8_);
	g_object_ref_sink (_tmp9_);
	app_name = _tmp9_;
	_tmp10_ = (GtkCheckButton*) gtk_check_button_new ();
	g_object_ref_sink (_tmp10_);
	_g_object_unref0 (self->priv->app_switch);
	self->priv->app_switch = _tmp10_;
	_tmp11_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp11_);
	grid = _tmp11_;
	_tmp12_ = grid;
	gtk_grid_set_column_spacing (_tmp12_, 6);
	_tmp13_ = grid;
	_tmp14_ = self->priv->app_switch;
	gtk_container_add ((GtkContainer*) _tmp13_, (GtkWidget*) _tmp14_);
	_tmp15_ = grid;
	_tmp16_ = app_image;
	gtk_container_add ((GtkContainer*) _tmp15_, (GtkWidget*) _tmp16_);
	_tmp17_ = grid;
	_tmp18_ = app_name;
	gtk_container_add ((GtkContainer*) _tmp17_, (GtkWidget*) _tmp18_);
	gtk_list_box_row_set_activatable ((GtkListBoxRow*) self, FALSE);
	gtk_list_box_row_set_selectable ((GtkListBoxRow*) self, FALSE);
	g_object_set ((GtkWidget*) self, "margin", 6, NULL);
	_tmp19_ = grid;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp19_);
	_tmp20_ = self->priv->app_switch;
	g_signal_connect_object ((GtkButton*) _tmp20_, "activate", (GCallback) __app_row___lambda7__gtk_button_activate, self, 0);
	_g_object_unref0 (grid);
	_g_object_unref0 (app_name);
	_g_object_unref0 (app_image);
	_g_object_unref0 (app_info);
	return obj;
}

static void
app_row_class_init (AppRowClass * klass,
                    gpointer klass_data)
{
	app_row_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &AppRow_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_app_row_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_app_row_set_property;
	G_OBJECT_CLASS (klass)->constructor = app_row_constructor;
	G_OBJECT_CLASS (klass)->finalize = app_row_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), APP_ROW_ACCOUNT_PROPERTY, app_row_properties[APP_ROW_ACCOUNT_PROPERTY] = g_param_spec_object ("account", "account", "account", ag_account_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), APP_ROW_APP_PROPERTY, app_row_properties[APP_ROW_APP_PROPERTY] = g_param_spec_boxed ("app", "app", "app", ag_application_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), APP_ROW_SERVICE_PROPERTY, app_row_properties[APP_ROW_SERVICE_PROPERTY] = g_param_spec_boxed ("service", "service", "service", ag_service_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), APP_ROW_IDENTITY_PROPERTY, app_row_properties[APP_ROW_IDENTITY_PROPERTY] = g_param_spec_object ("identity", "identity", "identity", signon_identity_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}

static void
app_row_instance_init (AppRow * self,
                       gpointer klass)
{
	self->priv = app_row_get_instance_private (self);
}

static void
app_row_finalize (GObject * obj)
{
	AppRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_APP_ROW, AppRow);
	_g_object_unref0 (self->priv->_account);
	_ag_application_unref0 (self->priv->_app);
	_ag_service_unref0 (self->priv->_service);
	_g_object_unref0 (self->priv->_identity);
	_g_object_unref0 (self->priv->app_switch);
	G_OBJECT_CLASS (app_row_parent_class)->finalize (obj);
}

static GType
app_row_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (AppRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) app_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AppRow), 0, (GInstanceInitFunc) app_row_instance_init, NULL };
	GType app_row_type_id;
	app_row_type_id = g_type_register_static (gtk_list_box_row_get_type (), "AppRow", &g_define_type_info, 0);
	AppRow_private_offset = g_type_add_instance_private (app_row_type_id, sizeof (AppRowPrivate));
	return app_row_type_id;
}

GType
app_row_get_type (void)
{
	static volatile gsize app_row_type_id__volatile = 0;
	if (g_once_init_enter (&app_row_type_id__volatile)) {
		GType app_row_type_id;
		app_row_type_id = app_row_get_type_once ();
		g_once_init_leave (&app_row_type_id__volatile, app_row_type_id);
	}
	return app_row_type_id__volatile;
}

static void
_vala_app_row_get_property (GObject * object,
                            guint property_id,
                            GValue * value,
                            GParamSpec * pspec)
{
	AppRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_APP_ROW, AppRow);
	switch (property_id) {
		case APP_ROW_ACCOUNT_PROPERTY:
		g_value_set_object (value, app_row_get_account (self));
		break;
		case APP_ROW_APP_PROPERTY:
		g_value_set_boxed (value, app_row_get_app (self));
		break;
		case APP_ROW_SERVICE_PROPERTY:
		g_value_set_boxed (value, app_row_get_service (self));
		break;
		case APP_ROW_IDENTITY_PROPERTY:
		g_value_set_object (value, app_row_get_identity (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_app_row_set_property (GObject * object,
                            guint property_id,
                            const GValue * value,
                            GParamSpec * pspec)
{
	AppRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_APP_ROW, AppRow);
	switch (property_id) {
		case APP_ROW_ACCOUNT_PROPERTY:
		app_row_set_account (self, g_value_get_object (value));
		break;
		case APP_ROW_APP_PROPERTY:
		app_row_set_app (self, g_value_get_boxed (value));
		break;
		case APP_ROW_SERVICE_PROPERTY:
		app_row_set_service (self, g_value_get_boxed (value));
		break;
		case APP_ROW_IDENTITY_PROPERTY:
		app_row_set_identity (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

